SystemOrganization addCategory: #OmniBase!

!Time class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbDeserialize: deserializer

	^deserializer register: (self fromSeconds: deserializer stream getPositiveInteger)! !

!Time methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbBasicSerialize: serializer

	serializer stream
		putByte: 33;
		putPositiveInteger: self asSeconds! !

!Process methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbSerialize: serializer

	serializer cantSave: self! !

!ProcessorScheduler methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbBasicSerialize: serializer

	serializer stream putByte: 22! !

!ProcessorScheduler methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbSerialize: serializer

	serializer stream putByte: 22! !

Error subclass: #ODBError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBError subclass: #ODBCannotLock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBError subclass: #ODBLockingConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBLockingConflict subclass: #ODBCannotLockKey
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBLockingConflict subclass: #ODBCannotLockObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

Error subclass: #ODBPreviousVersionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

Error subclass: #ODBUnexpectedNetworkError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!Object class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
newPersistent

	^self new makePersistent! !

!Object class methodsFor: '*omnibase' stamp: 'mu 8/29/2005 08:11'!
odbLoadVariables: deserializer classInfo: classInfo

	| stream order iSize object basicSize varArray |
	stream := deserializer stream.
	classInfo isVariable
		ifTrue: [ object := self basicNew: (basicSize := stream getPositiveInteger) ]
		ifFalse: [
			basicSize := 0.
			object := self basicNew.
		].
	deserializer register: object.
	classInfo isBytes ifTrue: [
		self isWords 
			ifTrue: [1 to: basicSize do: [:i | object basicAt: i put: stream getInteger]]
			ifFalse: [stream getBytesFor: object len: basicSize].
		^object
	].
	varArray := Array new: (iSize := classInfo realInstSize) + 1.
	order := classInfo variableOrder.
	1 to: classInfo instSize do: [:i | varArray at: (order at: i) put: deserializer odbNextObject ].
	1 to: iSize do: [:i | object instVarAt: i put: (varArray at: i) ].
	iSize + 1 to: iSize + basicSize do: [:i | object instVarAt: i put: deserializer odbNextObject ].
	^object odbDeserialized: deserializer! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
asBtreeKeyOfSize: keySize

	OmniBase signalError: 'Dont know how to convert this object to a B-tree dictionary bytes key'! !

!Object methodsFor: '*omnibase' stamp: 'ac 1/23/2004 18:18'!
commit: serializer
	"do nothing"
! !

!Object methodsFor: '*omnibase' stamp: ''!
isIdenticalTo: anObject 
	"Answer true if anObject is identical to receiver. This is necessary since with database
	proxies the real object identity is lost because while the object is not yet loaded from the
	database it is represented by its proxy. Later when the real object is loaded this proxy still
	represents the identical object but the #== identity check will answer false because it is not
	aware of this. It is implemented in this way because the #== method is inlined and can not
	be overridden."

	anObject isODBReference ifTrue: [^anObject isIdenticalTo: self].
	^self == anObject! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 21:40'!
isImmediate
	^false! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
isODBReference

	^false! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
isODBTransactionObject

	^false! !

!Object methodsFor: '*omnibase' stamp: ''!
makePersistent
	"Makes the object persistent in the current process's transaction."

	OmniBase currentTransaction makePersistent: self! !

!Object methodsFor: '*omnibase' stamp: ''!
markDirty
	| t |
	(t := OmniBase currentTransactionOrNil) isNil 
		ifTrue: 
			[(t := self odbGetTransaction) isNil 
				ifTrue: 
					[OmniBase signalError: 'Can not mark object as dirty. Transaction context is unknown. ']].
	t markDirty: self! !

!Object methodsFor: '*omnibase' stamp: 'david@inspiron 11/29/2003 18:52'!
odbAboutToCommitIn: anOmniBaseTransaction 
	"Sent before transaction writes changes to the database (right before commit).
	In this method you can use transaction the same way as usual.
	Do nothing by default."

	! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 21:26'!
odbBasicSerialize: serializer

	| stream classInfo instSize |
	classInfo := serializer registerClass: self class.
	stream := serializer stream.
	classInfo isVariable ifTrue: [ stream putPositiveInteger: self basicSize ].
	classInfo isBytes ifFalse: [
		classInfo instVarIndexes do: [:i | (self instVarAt: i) odbSerialize: serializer ].
		instSize := self class instSize.
		instSize + 1 to: instSize + self basicSize do: [:i | 
			(self instVarAt: i) odbSerialize: serializer ].
		^self].
	"variable - need to check whether we have bytes or words"
	self class isWords
		ifFalse: [ stream putBytesFrom: self len: self basicSize ]
		ifTrue: [1 to: self basicSize do: [:i | stream putInteger: (self basicAt: i)]].! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
odbDeserialized: deserializer

	^self! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
odbDeserialize: deserializer

	^self! !

!Object methodsFor: '*omnibase' stamp: 'david@inspiron 10/18/2004 22:01'!
odbGetOID
	"Answer persistent object's OID."

	| t oid |
	(oid := self odbObjectID) isNil ifFalse: [^oid].
	(t := OmniBase currentTransactionOrNil) isNil 
		ifFalse: [(oid := t getObjectIDOrNil: self) isNil ifFalse: [^oid]].
	(t := self odbGetTransaction) isNil ifFalse: [^t getObjectIDOrNil: self].
	^nil! !

!Object methodsFor: '*omnibase' stamp: 'dg 3/14/2005 12:19'!
odbGetTransaction
	"Answer the transaction in which the object was loaded."

	"immediate objects can not be made persistent"

	| allReferences |
	self isImmediate ifTrue: [^nil].

	"first check all inst vars if any references a proxy from which we could get a reference to transaction"
	self class isBits
		ifFalse: 
			[1 to: self class instSize + self basicSize
				do: [:i | (self instVarAt: i) isODBReference ifTrue: [^(self instVarAt: i) odbTransaction]]].
	"check references to self and find the transaction in which object was loaded"
	allReferences := self allReferences.
	allReferences do: [:each | each isODBReference ifTrue: [^each odbTransaction]].
	^nil! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
odbLoadedIn: anOmniBaseTransaction
		"This method is sent when the object is loaded from the database."! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
odbMadePersistentIn: anOmniBaseTransaction
		"This method is sent when the object is made persistent."! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
odbObject
        "Answer real persistent object."

    ^self! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
odbObjectID

	^nil! !

!Object methodsFor: '*omnibase' stamp: 'dg 5/7/2003 23:06'!
odbResolve
	"If this were a proxy object it would resolve itself and answer a real persistent object from the database.
	Since this is not a proxy answer yourself.
	Note: This method is here because in Dolphin 5.1 sending yourself is optimized which means that there is no message
	send involved and a proxy does not fetch an object from the database, instead it answers itself a proxy."

	^self! !

!Object methodsFor: '*omnibase' stamp: ''!
odbSerialize: serializer 
	(serializer register: self) ifTrue: [^self].
	self odbBasicSerialize: serializer! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:26'!
odbToDo
		"See implementors to list all methods in OmniBase which need to be improved."! !

!Object methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 19:25'!
signalError: aString
	self error: aString! !

Object subclass: #ODBBTreeDictionaryAssociation
	instanceVariableNames: 'valueHolder key transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBBTreeDictionaryAssociation methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
key

    ^key! !

!ODBBTreeDictionaryAssociation methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
keyAsInteger
		"Convert from BCD encoded byte array into integer."

	| value |
	value := 0.
	1 to: key size do: [:i | value := (value * 100) + ((key at: i) & 15) + (((key at: i) bitShift: -4) * 10) ].
	^value! !

!ODBBTreeDictionaryAssociation methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
setKey: aKey value: aValue

    key := aKey.
    valueHolder := aValue! !

!ODBBTreeDictionaryAssociation methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
setTransaction: aTransaction key: aKey value: aValue

    transaction := aTransaction.
    key := aKey.
    valueHolder := aValue! !

!ODBBTreeDictionaryAssociation methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
value

    ^valueHolder getObjectIn: transaction! !

!ODBBTreeDictionaryAssociation methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
valueHolder
        "Private - Answer BTree valueHolder."

    ^valueHolder! !

!ODBBTreeDictionaryAssociation methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
valueObjectID

    ^valueHolder objectID! !

!ODBBTreeDictionaryAssociation methodsFor: 'public' stamp: ''!
valueOrObjectID
	| obj |
	(obj := valueHolder object) isNil ifFalse: [^obj].
	^valueHolder objectID! !

!ODBBTreeDictionaryAssociation methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
< aBTreeDictionaryAssociation

    ^key odbIsLessThan: aBTreeDictionaryAssociation key! !

Object subclass: #ODBByteStorageRequest
	instanceVariableNames: 'objectHolder byteArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBByteStorageRequest methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
bytes

    ^byteArray! !

!ODBByteStorageRequest methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
bytesStored! !

!ODBByteStorageRequest methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
objectHolder

    ^objectHolder! !

!ODBByteStorageRequest methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
objectHolder: anObjectHolder bytes: aByteArray

    objectHolder := anObjectHolder.
    byteArray := aByteArray! !

!ODBByteStorageRequest methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
objectPosition: anInteger

    objectHolder objectPosition: anInteger! !

ODBByteStorageRequest subclass: #ODBGarbageCollectorRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBGarbageCollectorRequest methodsFor: 'public' stamp: ''!
bytesStored
	objectHolder container indexFile at: objectHolder objectID index
		put: objectHolder contents! !

Object subclass: #ODBChange
	instanceVariableNames: 'objectID transactionObject transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBChange subclass: #ODBAssociationChanged
	instanceVariableNames: 'key oldValue newValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBAssociationChanged class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
changeClassID
        "Answer unique class ID used for storing changes into 
        transaction file or <nil> if change does not need to be stored."

    ^2! !

!ODBAssociationChanged methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
commit

    transactionObject dataBaseObject at: key put: newValue! !

!ODBAssociationChanged methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
key: aString

    key := aString! !

!ODBAssociationChanged methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:06'!
loadFromStream: aStream

    objectID := ODBObjectID new loadFromStream: aStream.
    key := aStream getString asByteArray.
    oldValue := ODBValueHolder new loadFromStream: aStream.
    newValue := ODBValueHolder new loadFromStream: aStream! !

!ODBAssociationChanged methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
newValue: aValue

    newValue := aValue! !

!ODBAssociationChanged methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
oldValue: aValue

    oldValue := aValue! !

!ODBAssociationChanged methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
rollback

    self transactionObject dataBaseObject at: key put: oldValue! !

!ODBAssociationChanged methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:06'!
storeOnStream: aStream

    objectID storeOnStream: aStream.
    aStream putString: key.
    oldValue storeOnStream: aStream.
    newValue storeOnStream: aStream! !

!ODBChange class methodsFor: 'public' stamp: ''!
changeClassID
	"Answer unique class ID used for storing changes into 
	transaction file or <nil> if change does not need to be stored."

	^nil! !

!ODBChange class methodsFor: 'public' stamp: ''!
new
	^super new initialize! !

!ODBChange methodsFor: 'transaction processing' stamp: 'cdg 3/13/2003 18:05'!
commit
        "Commit changes."! !

!ODBChange methodsFor: 'transaction processing' stamp: 'cdg 3/13/2003 18:05'!
committed! !

!ODBChange methodsFor: 'private' stamp: ''!
initialize
	! !

!ODBChange methodsFor: 'public' stamp: ''!
loadFromStream: aStream 
	"Load receiver from aStream.  Implemented by subclasses."

	! !

!ODBChange methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
objectID

    ^objectID! !

!ODBChange methodsFor: 'transaction processing' stamp: 'cdg 3/13/2003 18:05'!
rollback! !

!ODBChange methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
setObjectID: anObjectID transactionObject: aTransactionObject

    objectID := anObjectID.
    transactionObject := aTransactionObject! !

!ODBChange methodsFor: 'load/store' stamp: 'cdg 3/13/2003 18:05'!
storeOnStream: aStream
        "Store receiver on aStream. 
        Implemented by subclasses."! !

!ODBChange methodsFor: 'public' stamp: ''!
transactionObject
	^transactionObject isNil 
		ifFalse: [transactionObject]
		ifTrue: [transactionObject := transaction transactionObjectAt: objectID]! !

!ODBChange methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
transactionObject: aTransactionObject

    transactionObject := aTransactionObject! !

!ODBChange methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
transaction: aTransaction

    transaction := aTransaction! !

ODBChange subclass: #ODBDictionaryChanged
	instanceVariableNames: 'dataBaseObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBDictionaryChanged methodsFor: 'public' stamp: ''!
committed
	"Changes have been committed, update transaction object."

	dataBaseObject isNil ifFalse: [transactionObject setDataBaseObject: dataBaseObject].
	transactionObject objectCommitted! !

!ODBDictionaryChanged methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
dataBaseObject: anObject

    dataBaseObject := anObject! !

ODBChange subclass: #ODBNewObjectVersion
	instanceVariableNames: 'newVersion oldVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBNewObjectVersion class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
changeClassID
        "Answer unique class ID used for storing changes into 
        transaction file or <nil> if change does not need to be stored."

    ^1! !

!ODBNewObjectVersion methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
commit
        "Commit changes."

    newVersion store! !

!ODBNewObjectVersion methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
committed
        "Changes have been committed, update transaction object."

    transactionObject
        setObjectHolder: newVersion;
        objectCommitted! !

!ODBNewObjectVersion methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:06'!
loadFromStream: aStream

    objectID := ODBObjectID new loadFromStream: aStream.
    oldVersion := ODBObjectHolder new loadFromStream: aStream.
    newVersion := ODBObjectHolder new loadFromStream: aStream.! !

!ODBNewObjectVersion methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
newVersion

    ^newVersion! !

!ODBNewObjectVersion methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
newVersion: anObjectHolder

    newVersion := anObjectHolder! !

!ODBNewObjectVersion methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
oldVersion

    ^oldVersion! !

!ODBNewObjectVersion methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
oldVersion: anObjectHolder

    oldVersion := anObjectHolder! !

!ODBNewObjectVersion methodsFor: 'public' stamp: ''!
rollback
	"Rollback changes."

	| currentHolder |
	(currentHolder := transaction objectHolderAt: objectID) isNil ifTrue: [^self].
	currentHolder versionNumber > newVersion versionNumber 
		ifFalse: 
			[currentHolder
				contents: oldVersion contents;
				store]! !

!ODBNewObjectVersion methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:06'!
storeOnStream: aStream

        objectID storeOnStream: aStream.
        oldVersion storeOnStream: aStream.
        newVersion storeOnStream: aStream! !

ODBChange subclass: #ODBSizeChanged
	instanceVariableNames: 'deltaSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBSizeChanged class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:05'!
changeClassID
        "Answer unique class ID used for storing changes into 
        transaction file or <nil> if change does not need to be stored."

    ^4! !

!ODBSizeChanged methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
commit

    transaction := transactionObject transaction.
    transactionObject dataBaseObject iterator
        updateSizeAt: transaction versionNumber
        oldHolders: transaction oldHolders
        deltaSize: deltaSize! !

!ODBSizeChanged methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
deltaSize: anInteger

    deltaSize := anInteger! !

!ODBSizeChanged methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:06'!
loadFromStream: aStream

    objectID := ODBObjectID new loadFromStream: aStream.
    deltaSize := aStream getInteger! !

!ODBSizeChanged methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
rollback

    self transactionObject dataBaseObject iterator
        updateSizeAt: transaction versionNumber
        oldHolders: transaction oldHolders
        deltaSize: 0 - deltaSize! !

!ODBSizeChanged methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:06'!
storeOnStream: aStream

    objectID storeOnStream: aStream.
    aStream putInteger: deltaSize! !

Object subclass: #ODBChangesPackage
	instanceVariableNames: 'changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBChangesPackage class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new initialize! !

!ODBChangesPackage methodsFor: 'public' stamp: ''!
add: aChange 
	changes add: aChange! !

!ODBChangesPackage methodsFor: 'public' stamp: ''!
changes
	^changes! !

!ODBChangesPackage methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
collectChangeClassIDsFrom: rootClass to: aDictionary
        "Private - Collect all change classIDs and store them to aDictionary."

    rootClass changeClassID notNil
        ifTrue: [aDictionary at: rootClass changeClassID put: rootClass].
    rootClass subclasses do: [:each | self collectChangeClassIDsFrom: each to: aDictionary]! !

!ODBChangesPackage methodsFor: 'public' stamp: ''!
commit
	changes do: [:each | each commit]! !

!ODBChangesPackage methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
committed
        "Changes have just been committed."

    changes do: [:each | each committed]! !

!ODBChangesPackage methodsFor: 'private' stamp: 'dg 12/20/2003 09:38'!
fixTemps
	^self! !

!ODBChangesPackage methodsFor: 'private' stamp: ''!
initialize
	changes := (SortedCollection new: 300) sortBlock: self! !

!ODBChangesPackage methodsFor: 'public' stamp: ''!
loadFromStream: aStream 
	"Load receiver from aStream."

	"collect change class IDs"

	| memoryStream classID classes change |
	classes := IdentityDictionary new.
	self collectChangeClassIDsFrom: ODBChange to: classes.
	"load changes"
	changes := OrderedCollection new.
	memoryStream := ODBMemoryReadStream new readFrom: aStream.
	[(classID := memoryStream getByte) > 0] whileTrue: 
			[change := (classes at: classID
						ifAbsent: [OmniBase signalError: 'Transaction rollback: Unknown change classID']) new 
						loadFromStream: memoryStream.
			changes add: change]! !

!ODBChangesPackage methodsFor: 'public' stamp: ''!
rollback
	"Rollback change objects."

	changes do: [:each | each rollback]! !

!ODBChangesPackage methodsFor: 'public' stamp: ''!
storeOnStream: aStream 
	"Store receiver on aStream."

	| memoryStream classID |
	memoryStream := ODBMemoryWriteStream new.
	changes do: 
			[:each | 
			(classID := each class changeClassID) isNil 
				ifFalse: 
					[memoryStream putByte: classID.
					each storeOnStream: memoryStream]].
	memoryStream
		putByte: 0;
		writeOn: aStream! !

!ODBChangesPackage methodsFor: 'public' stamp: ''!
transaction: aTransaction 
	changes do: [:each | each transaction: aTransaction]! !

!ODBChangesPackage methodsFor: 'private' stamp: ''!
value: change1 value: change2 
	"Private - Answer <true> if change1 is to be committed before change2.
	Disk access optimization so that files are updated sequentialy."

	| oid1 oid2 cid1 cid2 |
	(oid1 := change1 objectID) isNil ifTrue: [^true].
	(oid2 := change2 objectID) isNil ifTrue: [^false].
	(cid1 := oid1 containerID) == (cid2 := oid2 containerID) 
		ifTrue: [^oid1 index < oid2 index].
	^cid1 < cid2! !

Object subclass: #ODBClassDescription
	instanceVariableNames: 'name bytes variable instSize instVarNames instVarIndexes class varOrder classID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBClassDescription methodsFor: 'private' stamp: ''!
allPersistentInstanceVariablesFor: aClass 
	^(aClass allInstVarNames 
		reject: [:each | aClass odbTransientInstanceVariables includes: each]) asArray! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
classID

	^classID! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
classID: anInteger

	classID := anInteger.! !

!ODBClassDescription methodsFor: 'public' stamp: 'dg 12/20/2003 10:03'!
createdFor: aClass

	^name = aClass name asString
		and: [ variable = aClass isVariable
		and: [ bytes = aClass isBits
		and: [ instVarNames = (self allPersistentInstanceVariablesFor: aClass) ]]]! !

!ODBClassDescription methodsFor: 'public' stamp: 'dg 3/14/2005 10:10'!
createFor: aClass

	class := aClass.
	name := aClass name.
	instVarNames := self allPersistentInstanceVariablesFor: aClass.
	instSize := instVarNames size.
	bytes := aClass isBits.
	variable := aClass isVariable.
	self updateVariableOrder! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
instSize

	^instSize! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
instVarIndexes

	^instVarIndexes! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
instVarNames

	^instVarNames! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
isBytes

	^bytes! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
isVariable

	^variable! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
loadFromStream: aStream

	name := aStream getString.
	bytes := aStream getBoolean.
	variable := aStream getBoolean.
	instSize := aStream getPositiveInteger.
	instVarNames := Array new: instSize.
	1 to: instSize do: [:i | instVarNames at: i put: aStream getString].
	self updateVariableOrder.! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
name

	^name! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
realClass

	^class! !

!ODBClassDescription methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
realInstSize

	^class instSize! !

!ODBClassDescription methodsFor: 'public' stamp: ''!
saveOnStream: aStream 
	aStream
		putString: name;
		putBoolean: bytes;
		putBoolean: variable;
		putPositiveInteger: instSize.
	instVarNames do: [:n | aStream putString: n]! !

!ODBClassDescription methodsFor: 'private' stamp: ''!
updateVariableOrder
	| realNames |
	class := Smalltalk at: name asSymbol ifAbsent: [].
	varOrder := Array new: instVarNames size.
	class isNil 
		ifTrue: [varOrder atAllPut: 1]
		ifFalse: 
			[realNames := class allInstVarNames.
			1 to: varOrder size
				do: 
					[:i | 
					(varOrder at: i put: (realNames indexOf: (instVarNames at: i))) = 0 
						ifTrue: [varOrder at: i put: realNames size + 1]].
			instVarIndexes := Array new: instVarNames size.
			1 to: instVarNames size
				do: [:i | instVarIndexes at: i put: (class allInstVarNames indexOf: (instVarNames at: i))]]! !

!ODBClassDescription methodsFor: 'public' stamp: ''!
variableOrder
	^varOrder! !

Object subclass: #ODBClassManager
	instanceVariableNames: 'classes idTable infoFile mutex names'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBClassManager class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new initialize! !

!ODBClassManager methodsFor: 'private' stamp: ''!
addClassDescription: aClassDescription withId: classId 
	"Private - Add aClassDescription under a given ID."

	| pos stream unlocked previousVersionPos lastPos classDesc |
	aClassDescription isNil 
		ifTrue: 
			[[idTable getLastID < classId] whileTrue: [idTable add: 0].
			^self].
	unlocked := false.
	stream := infoFile stream.
	idTable waitForAddingLock.
	
	[pos := infoFile at: aClassDescription name
				ifAbsent: 
					[pos := stream setToEnd.
					[idTable getLastID < classId] whileTrue: [idTable add: 0].
					idTable at: classId put: pos.
					aClassDescription classID: classId.
					stream putLong: 0.	"info of previous class version"
					aClassDescription saveOnStream: stream.	"class definition"
					stream putLong: aClassDescription classID.	"class ID"
					infoFile
						at: aClassDescription name put: pos;
						flush.
					unlocked := idTable unlockAdding.
					^self].
	
	[lastPos := pos.
	stream position: pos.
	previousVersionPos := stream getLong.
	classDesc := ODBSerializer classDescriptionFrom: stream.
	classDesc classID: stream getLong.
	previousVersionPos = 0] 
			whileFalse: [pos := previousVersionPos].
	pos := stream setToEnd.
	stream putLong: 0.
	aClassDescription saveOnStream: stream.
	stream
		putLong: classId;
		position: lastPos;
		putLong: pos;
		flush.
	[idTable getLastID < classId] whileTrue: [idTable add: 0].
	idTable at: classId put: pos.
	idTable unlockAdding] 
			ifCurtailed: [unlocked ifFalse: [idTable unlockAdding]]! !

!ODBClassManager methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
addClassInfo: aClassInfo
        "Private - Add class info to names dictionary."

    | id |
    id := aClassInfo classID.
    id > classes size
        ifTrue: [
            id - classes size timesRepeat: [ classes add: nil].
            classes at: id put: aClassInfo.
            self addToDict: aClassInfo]
        ifFalse: [
            (classes at: id) isNil ifTrue: [
                classes at: id put: aClassInfo.
                self addToDict: aClassInfo]]! !

!ODBClassManager methodsFor: 'private' stamp: ''!
addToDict: aClassInfo 
	"Private - Add class info to names dictionary."

	| coll |
	(coll := names at: aClassInfo realClass) isNil 
		ifTrue: [^names at: aClassInfo realClass put: aClassInfo].
	coll class == OrderedCollection ifTrue: [^coll add: aClassInfo].
	names at: aClassInfo realClass put: (OrderedCollection with: coll with: aClassInfo)! !

!ODBClassManager methodsFor: 'public' stamp: ''!
classDescriptionAt: anInteger 
	"Answers class at class id anInteger."

	| pos classInfo stream |
	mutex critical: 
			[classes size < anInteger 
				ifFalse: [(classInfo := classes at: anInteger) isNil ifFalse: [^classInfo]].
			(pos := idTable at: anInteger) isNil 
				ifTrue: [OmniBase signalError: 'Unknown class ID in serialized persistent object'].
			stream := infoFile stream.
			stream position: pos + 4.
			classInfo := ODBSerializer classDescriptionFrom: stream.
			classInfo classID: anInteger.
			self addClassInfo: classInfo].
	^classInfo! !

!ODBClassManager methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:05'!
close

    idTable isNil ifFalse: [idTable close].
    infoFile isNil ifFalse: [infoFile close]! !

!ODBClassManager methodsFor: 'public' stamp: ''!
createOn: anOmniBase 
	mutex := Semaphore forMutualExclusion.
	
	[infoFile := ODBClassInfoFile createOn: anOmniBase dirName , self infoFileName.
	idTable := ODBIDTable createOn: anOmniBase dirName , self idFileName] 
			ifCurtailed: [self close]! !

!ODBClassManager methodsFor: 'private' stamp: ''!
find: aClass 
	"Private - Answer class description for aClass or <nil> if none.
	Uses #createdFor: to check if class description corresponds to aClass."

	| coll |
	(coll := names at: aClass) isNil ifTrue: [^nil].
	coll class == OrderedCollection ifFalse: [^(coll createdFor: aClass) ifTrue: [coll]].
	coll reverseDo: [:classInfo | (classInfo createdFor: aClass) ifTrue: [^classInfo]].
	^nil! !

!ODBClassManager methodsFor: 'private' stamp: ''!
idFileName
	^ODBFileStream pathSeparatorString , 'omnibase.odt'! !

!ODBClassManager methodsFor: 'private' stamp: ''!
infoFileName
	^ODBFileStream pathSeparatorString , 'omnibase.odl'! !

!ODBClassManager methodsFor: 'private' stamp: ''!
initialize
	classes := OrderedCollection new.
	names := ODBIdentityDictionary new! !

!ODBClassManager methodsFor: 'private' stamp: ''!
lastClassId
	^idTable getLastID! !

!ODBClassManager methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
loadInfoChainFrom: anInteger
        "Private - Load class info chain from pos. Answer end of list."

    | info pos lastPos stream |
    pos := anInteger.
    stream := infoFile stream.
    [pos == 0] whileFalse: [
        stream position: pos.
        lastPos := pos.
        pos := stream getLong.
        info := ODBSerializer classDescriptionFrom: stream.
        info classID: stream getLong.
        self addClassInfo: info].
    ^lastPos! !

!ODBClassManager methodsFor: 'public' stamp: ''!
openOn: anOmniBase 
	"Open receiver. Signal an error if failed."

	mutex := Semaphore forMutualExclusion.
	
	[idTable := ODBIDTable openOn: anOmniBase dirName , self idFileName.
	infoFile := ODBClassInfoFile openOn: anOmniBase dirName , self infoFileName] 
			ifCurtailed: [self close]! !

!ODBClassManager methodsFor: 'private' stamp: ''!
registerNewClassVersion: aClass from: anInteger 
	"Private - Register new class version and answer its classInfo."

	| info pos lastPos stream unlocked |
	unlocked := false.
	idTable waitForAddingLock.
	
	[stream := infoFile stream.
	pos := anInteger.
	[true] whileTrue: 
			[lastPos := pos.
			stream position: pos.
			pos := stream getLong.
			pos == 0 
				ifTrue: 
					[info := ODBSerializer classDescriptionFor: aClass.
					pos := stream setToEnd.
					info classID: (idTable add: pos).
					stream putLong: 0.
					info saveOnStream: stream.
					stream
						putLong: info classID;
						position: lastPos;
						putLong: pos;
						flush.
					unlocked := idTable unlockAdding.
					self addClassInfo: info.
					^info].
			info := ODBSerializer classDescriptionFrom: stream.
			info classID: stream getLong.
			self addClassInfo: info.
			(info := self find: aClass) isNil 
				ifFalse: 
					[unlocked := idTable unlockAdding.
					^info]]] 
			ifCurtailed: [unlocked ifFalse: [idTable unlockAdding]]! !

!ODBClassManager methodsFor: 'private' stamp: ''!
registerNewClass: aClass 
	"Private - Register new class and answer its classInfo."

	| info pos stream unlocked |
	unlocked := false.
	info := ODBSerializer classDescriptionFor: aClass.
	idTable waitForAddingLock.
	
	[pos := infoFile at: aClass name
				ifAbsent: 
					[stream := infoFile stream.
					pos := stream setToEnd.
					info classID: (idTable add: pos).
					stream putLong: 0.	"info of previous class version"
					info saveOnStream: stream.	"class definition"
					stream putLong: info classID.	"class ID"
					infoFile
						at: info name put: pos;
						flush.
					unlocked := idTable unlockAdding.
					self addClassInfo: info.
					^info].
	idTable unlockAdding] 
			ifCurtailed: [unlocked ifFalse: [idTable unlockAdding]].
	pos := self loadInfoChainFrom: pos.
	(info := self find: aClass) isNil ifFalse: [^info].
	^self registerNewClassVersion: aClass from: pos! !

!ODBClassManager methodsFor: 'public' stamp: ''!
register: aClass 
	"Answer an instance of ODBClassDescription for aClass.
	ODBClassDescription holds meta information about objects in the database."

	| info pos |
	mutex critical: 
			[(info := self find: aClass) isNil ifFalse: [^info].
			pos := infoFile at: aClass name ifAbsent: [^self registerNewClass: aClass].
			pos := self loadInfoChainFrom: pos.
			(info := self find: aClass) isNil ifFalse: [^info].
			^self registerNewClassVersion: aClass from: pos]! !

Object subclass: #ODBClassManagerForSerialization
	instanceVariableNames: 'classesToDescription idToClassDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBClassManagerForSerialization methodsFor: 'public' stamp: 'david@inspiron 2/9/2005 9:00'!
classDescriptionAt: anInteger 
	^idToClassDescription at: anInteger
		ifAbsent: [self error: '[Deserializer] Class description not found']! !

!ODBClassManagerForSerialization methodsFor: 'private' stamp: 'david@inspiron 2/9/2005 9:25'!
initializeForSerialization
	idToClassDescription := OrderedCollection new.
	classesToDescription := IdentityDictionary new! !

!ODBClassManagerForSerialization methodsFor: 'private' stamp: 'david@inspiron 2/9/2005 9:23'!
loadFromStream: stream 
	| n classDescription |
	n := stream getPositiveInteger.
	n > 10000 ifTrue: [self error: '[Deserializer] Number of classes is too big'].
	idToClassDescription := OrderedCollection new.
	1 to: n
		do: 
			[:i | 
			classDescription := ODBSerializer classDescriptionFrom: stream.
			classDescription classID: i.
			idToClassDescription add: classDescription]! !

!ODBClassManagerForSerialization methodsFor: 'public' stamp: 'david@inspiron 2/9/2005 9:04'!
register: aClass 
	| classDescription |
	^classesToDescription at: aClass
		ifAbsentPut: 
			[classDescription := ODBSerializer classDescriptionFor: aClass.
			idToClassDescription add: classDescription.
			classDescription classID: idToClassDescription size.
			classDescription]! !

!ODBClassManagerForSerialization methodsFor: 'private' stamp: 'david@inspiron 2/9/2005 9:20'!
saveOnStream: stream 
	stream putPositiveInteger: idToClassDescription size.
	idToClassDescription do: [:each | each saveOnStream: stream]! !

Object subclass: #ODBClient
	instanceVariableNames: 'id clientFile transactions clientManager transactionFiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBClient class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new initialize! !

!ODBClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
clientID
        "Answer client ID."

    ^id! !

!ODBClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
description
        "Answer client description string."

    ^clientFile clientDescription! !

!ODBClient methodsFor: 'private' stamp: ''!
initialize

    transactions := OrderedCollection new.
    transactionFiles := OrderedCollection new! !

!ODBClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
isForeign

    ^false! !

!ODBClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
isTerminated

    ^false! !

!ODBClient methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
remove
        "Remove client from database."

    | cf |
    clientFile isNil ifFalse: [
        clientManager removePending: id.
        self transactions copy do: [:t | t abort].
        cf := clientFile.
        clientFile := nil.
        cf remove ifTrue: [clientManager removed: id]]! !

!ODBClient methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
transactionAdd: aTransaction
        "Private - Add aTransaction to client."

    transactions add: aTransaction.
    aTransaction setClient: self environment: clientManager environment! !

!ODBClient methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
transactionRemove: aTransaction
        "Private - Remove aTransaction."

    | trnFile trID |
    (trnFile := aTransaction transactionFile) == nil
        ifFalse: [
            trID := trnFile transactionID.
            trnFile remove
                ifTrue: [
                    transactionFiles remove: trID ifAbsent: [].
                    clientFile transactionIDs: transactionFiles.
                    transactionFiles isEmpty
                        ifTrue: [ clientManager removeLocksFor: id ]
                ]
        ].
    transactions remove: aTransaction ifAbsent: []! !

!ODBClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
transactions
        "Answer collection of R/W transactions started by client."

    ^transactions asArray! !

!ODBClient methodsFor: 'private' stamp: ''!
trnFileName: fileID 
	"Private - Answer transaction file name."

	^clientManager dirName , ODBFileStream pathSeparatorString , fileID printString , '.trn'! !

ODBClient subclass: #ODBForeignClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBForeignClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
isForeign

    ^true! !

!ODBForeignClient methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
openOn: aClientManager clientID: clientID

    | fName |
    id := clientID.
    clientManager := aClientManager.
    fName := clientManager clientFileName: id.
    [ clientFile := ODBClientFile new openReadOnlyOn: fName ]
        on: Error do: [ :er | ^nil ].
    clientManager addOpenedClient: self! !

!ODBForeignClient methodsFor: 'public' stamp: ''!
remove
	"Remove client from database. 
	Close files only, because client may be still active."

	clientFile isNil 
		ifFalse: 
			[self transactions copy do: [:each | each abort].
			clientFile close.
			clientFile := nil.
			clientManager removeForeignActiveClient: id]! !

!ODBForeignClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
transactions
        "Answer all R/W transactions started by receiver."

    self updateTransactions.
    ^transactions! !

!ODBForeignClient methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:06'!
updateTransactions
        "Private - Update transactions from transaction files."

"   | vn res coll |
    coll := OrderedCollection new.
    clientFile transactions do: [:each |
        vn := each versionNumber.
        res := transactions detect: [:t | t versionNumber = vn ] ifNone: [
            res := ODForeignTransaction new client: self.
            res transactionFile: each.
            res
        ].
        coll add: res.
    ].
    transactions := coll.
"! !

ODBClient subclass: #ODBLocalClient
	instanceVariableNames: 'hasGlobalLock freeTransactionFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBLocalClient methodsFor: 'public' stamp: 'dg 12/20/2003 09:36'!
createOn: aClientManager clientID: anInteger 
	| userName machineName |
	"get logged in user and local hostname"
	self odbToDo.
	userName := nil.
	machineName := nil.
	(userName isNil or: [userName isEmpty]) ifTrue: [userName := 'unknown-user'].
	(machineName isNil or: [machineName isEmpty]) ifTrue: [machineName := 'unknown-host'].
	id := anInteger.
	clientManager := aClientManager.
	clientFile := ODBClientFile createOn: (clientManager clientFileName: id).
	clientManager addOpenedClient: self.
	self description: 'OmniBase 2.1 [clientID=' , id printString , '] ' , userName , '@' 
				, machineName! !

!ODBLocalClient methodsFor: 'private/for transaction control only' stamp: 'cdg 3/13/2003 18:06'!
currentGlobalLockedTransaction

    transactions do: [:each | each transactionFile == nil ifFalse: [ ^each ]].
    ^nil! !

!ODBLocalClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
description: aString
        "Set client description string."

    clientFile clientDescription: aString! !

!ODBLocalClient methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
globalLock
        "Set global write lock to all objects in the database.
        No other client will be able to write to the database
        until the lock is released by globalUnlock. Answer <true>
        if sucessfull or <false> if failed. Global lock will fail if
        any client (including local client) allready has read-write
        transactions running. When database is globaly locked only one
        read-write transaction can run at that time."

    | count |
    count := transactionFiles size.
    freeTransactionFile isNil ifFalse: [ count := count - 1 ].
    (hasGlobalLock not and: [ count == 0 ])
        ifTrue: [ hasGlobalLock := clientManager setGlobalLockFor: id ].
    ^hasGlobalLock! !

!ODBLocalClient methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
globalUnlock
        "Release global lock on database.
        Answer <true> if successfull."

    hasGlobalLock ifFalse: [ ^false ].
    transactions do: [:each | each isGlobalLocked ifTrue: [ ^false ]].
    clientManager globalUnlock.
    hasGlobalLock := false.
    ^true! !

!ODBLocalClient methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
initialize
        "Private - Initialize receiver."

    transactions := IdentitySet new: 20.
    transactionFiles := OrderedCollection new.
    hasGlobalLock := false.! !

!ODBLocalClient methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
isGlobalLocked

    ^hasGlobalLock! !

!ODBLocalClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
isLocal

    ^true! !

!ODBLocalClient methodsFor: 'private' stamp: ''!
makeRootObject
	"Private - Initialize root object."

	(self newTransaction)
		root: OmniBase newPersistentDictionary;
		commit! !

!ODBLocalClient methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
newReadOnlyTransaction
		"Answer new read-only transaction for receiver."

	^ODBReadOnlyTransaction new
		setClient: self environment: clientManager environment;
		start! !

!ODBLocalClient methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
newTransaction
        "Answer new transaction for receiver."

    | transaction |
    hasGlobalLock
        ifFalse: [ transaction := ODBLocalTransaction new ]
        ifTrue: [ transaction := ODBGlobalLockedTransaction new ].
    ^transaction setClient: self environment: clientManager environment; start! !

!ODBLocalClient methodsFor: 'private' stamp: ''!
newTransactionFileFor: aTransaction 
	| transactionFile transactionID count |
	count := transactionFiles size.
	freeTransactionFile isNil ifFalse: [count := count - 1].
	hasGlobalLock 
		ifTrue: 
			[aTransaction isGlobalLocked ifFalse: [^nil].
			count == 0 ifFalse: [^nil]]
		ifFalse: 
			[aTransaction isGlobalLocked ifTrue: [^nil].
			count == 0 ifTrue: [(clientManager requestLocksFor: id) ifFalse: [^nil]]].
	freeTransactionFile isNil 
		ifFalse: 
			[transactionFile := freeTransactionFile.
			freeTransactionFile := nil.
			transactions add: aTransaction.
			^transactionFile].
	transactionID := id bitShift: 8.
	256 timesRepeat: 
			[(transactionFiles includes: transactionID) 
				ifFalse: 
					[transactionFiles add: transactionID.
					clientFile transactionIDs: transactionFiles.
					[transactionFile := ODBTransactionFile createOn: (self trnFileName: transactionID)] 
						on: Error
						do: [:er | transactionFile := nil].
					transactionFile isNil 
						ifTrue: [transactionFiles remove: transactionID]
						ifFalse: 
							[transactions add: aTransaction.
							^transactionFile transactionID: transactionID]].
			transactionID := transactionID + 1].
	OmniBase signalError: 'Maximum number of active read-write transactions reached'! !

!ODBLocalClient methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
newTransactionFrom: aTransaction
        "Answer new transaction for receiver from aTransaction. 
        Objects accessible in aTransaction will also be accessible 
        in new transaction."

    | transaction |
    transaction := aTransaction class new.
    ^transaction setClient: self environment: clientManager environment; startFrom: aTransaction! !

!ODBLocalClient methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
newTransactionInVersion: aVersionDescriptor
        "Answer new transaction with given version descriptor."

    | transaction |
    hasGlobalLock
        ifFalse: [ transaction := ODBLocalTransaction new ]
        ifTrue: [ transaction := ODBGlobalLockedTransaction new ].
    ^transaction setClient: self environment: clientManager environment; startInVersion: aVersionDescriptor! !

!ODBLocalClient methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
remove

    freeTransactionFile isNil ifFalse: [ freeTransactionFile remove ].
    freeTransactionFile := true. "do not cache transaction files anymore"
    ^super remove! !

!ODBLocalClient methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:06'!
transactionRemove: aTransaction
        "Private - Remove aTransaction."

    | trnFile trID |
    (trnFile := aTransaction transactionFile) == nil ifTrue: [ ^self ].
    freeTransactionFile == nil
        ifTrue: [ freeTransactionFile := trnFile reinitialize ]
        ifFalse: [
            trID := trnFile transactionID.
            trnFile remove
                ifTrue: [
                    transactionFiles remove: trID ifAbsent: [].
                    clientFile transactionIDs: transactionFiles.
                ]
        ].
    transactionFiles size > 1 ifFalse: [ clientManager removeLocksFor: id ].
    transactions remove: aTransaction ifAbsent: []! !

ODBClient subclass: #ODBTerminatedClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBTerminatedClient methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
isTerminated

    ^true! !

!ODBTerminatedClient methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:06'!
loadTransactions

    | transactionFile transaction |
    clientFile transactionIDs do: [:fileID |
        [ transactionFile := ODBTransactionFile openOn: (self trnFileName: fileID) ]
            on: Error do: [:er | transactionFile := nil ].
        transactionFile notNil
            ifTrue: [
                transaction := ODBTerminatedTransaction new.
                transaction transactionFile: transactionFile.
                self transactionAdd: transaction.
                transaction start
            ]
    ]! !

!ODBTerminatedClient methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
openOn: aClientManager clientID: clientID

    | fName |
    id := clientID.
    clientManager := aClientManager.
    fName := clientManager clientFileName: id.
    [ clientFile := ODBClientFile new openOn: fName ]
        on: Error do: [:er | ^nil ].
    clientManager addOpenedClient: self.
    self loadTransactions! !

Object subclass: #ODBClientManager
	instanceVariableNames: 'localClient environment idTable clients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBClientManager methodsFor: 'private' stamp: ''!
addOpenedClient: aClient 
	"Private - Add opened client to array of clients."

	(clients at: aClient clientID) isNil 
		ifFalse: [OmniBase signalError: 'Client already exists'].
	clients at: aClient clientID put: aClient! !

!ODBClientManager methodsFor: 'public' stamp: ''!
clientAt: clientID 
	"Answer client object for clientID or <nil> if none."

	| client |
	client := clients at: clientID.
	client isNil 
		ifTrue: 
			[client := ODBTerminatedClient new openOn: self clientID: clientID.
			client isNil 
				ifTrue: 
					[client := ODBForeignClient new openOn: self clientID: clientID.
					client isNil 
						ifTrue: 
							[(ODBFileStream exists: (self clientFileName: clientID)) 
								ifFalse: 
									[self
										removePending: clientID;
										removed: clientID]]]].
	^client! !

!ODBClientManager methodsFor: 'private' stamp: ''!
clientFileName: clientID 
	"Private - Answer client file name for clientID."

	^self dirName , ODBFileStream pathSeparatorString , clientID printString , '.usr'! !

!ODBClientManager methodsFor: 'public' stamp: ''!
clients
	"Answer collection of all clients currently connected to database."

	| client coll |
	coll := OrderedCollection new.
	idTable 
		onClientIDsDo: [:clientID | (client := self clientAt: clientID) == nil ifFalse: [coll add: client]].
	^coll! !

!ODBClientManager methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:05'!
close

    clients isNil
        ifFalse: [
            clients do: [:each | each == nil ifFalse: [ each remove ]].
            clients := nil ].
    idTable isNil
        ifFalse: [
            idTable close.
            idTable := nil ]! !

!ODBClientManager methodsFor: 'public' stamp: ''!
closeForeignClients
	"Close cached foreign clients."

	clients do: [:each | (each notNil and: [each isForeign]) ifTrue: [each remove]]! !

!ODBClientManager methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:05'!
createOn: anEnvironment
        "Create new user manager."

    environment := anEnvironment.
    [   idTable := ODBClientTable createOn: self idFileName.
        self opened
    ] ifCurtailed: [ self close ]! !

!ODBClientManager methodsFor: 'private' stamp: ''!
dirName
	"Private - Answer directory where user files are placed."

	^environment dirName , ODBFileStream pathSeparatorString , 'Users'! !

!ODBClientManager methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
environment

    ^environment! !

!ODBClientManager methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
globalUnlock
                "Private - Remove global lock."

        idTable globalUnlock! !

!ODBClientManager methodsFor: 'private' stamp: ''!
idFileName
	"Private - Answer name of file where client statuses are stored."

	^environment dirName , ODBFileStream pathSeparatorString , 'omnibase.usr'! !

!ODBClientManager methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
localClient
        "Answer local client."

    localClient == nil
        ifFalse: [ ^localClient ]
        ifTrue: [ ^localClient := self newClient ]! !

!ODBClientManager methodsFor: 'public' stamp: ''!
newClient
	"Answer new local client."

	| newClient |
	idTable 
		onNewClientIDDo: [:newID | newClient := ODBLocalClient new createOn: self clientID: newID].
	newClient isNil ifTrue: [OmniBase signalError: 'Maximum number of clients reached'].
	^newClient! !

!ODBClientManager methodsFor: 'private' stamp: ''!
opened
	"Private - Receiver has just been opened."

	clients := Array new: ODBClientTable maxClients.
	"ensure that directory exists in case the database was unzipped
	(WinZIP does not zip and later create empty directories)."
	(ODBFileStream directoryExists: self dirName) 
		ifFalse: [ODBFileStream directoryCreate: self dirName]! !

!ODBClientManager methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:05'!
openOn: anOmniBase

	environment := anOmniBase.
	[	idTable := ODBClientTable openOn: self idFileName.
		self opened
	] ifCurtailed: [ self close ]! !

!ODBClientManager methodsFor: 'public' stamp: ''!
removeDisconnectedClients
	"Remove all disconnected clients."

	self clients do: 
			[:client | 
			(client isTerminated or: [idTable isBeingRemoved: client clientID]) 
				ifTrue: [client remove]]! !

!ODBClientManager methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
removed: clientID
                "Private - Client has been completely removed."

        idTable removeClientID: clientID! !

!ODBClientManager methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
removeForeignActiveClient: clientID
                "Private - Foreign active client has been closed."

        clients at: clientID put: nil! !

!ODBClientManager methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
removeLocksFor: clientID
                "Private - Client has no RW transactions anymore."

        ^idTable activateClientID: clientID! !

!ODBClientManager methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
removePending: clientID
                "Private - Client is about to be removed."

        (localClient notNil and: [localClient clientID == clientID]) ifTrue: [localClient := nil].
        clients at: clientID put: nil.
        idTable removingClientID: clientID! !

!ODBClientManager methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
requestLocksFor: clientID
                "Private - Client wants to set locks. Answer <true> if OK."

        ^idTable requestLockForClientID: clientID! !

!ODBClientManager methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
setGlobalLockFor: clientID
                "Private - Client wants to set global lock. Answer <true> if OK."

        ^idTable setGlobalLockFor: clientID! !

Object subclass: #ODBContainer
	instanceVariableNames: 'activeDataFile byteStorageQueue dataFileA dataFileB dbFiles dbFilesMutex id indexFile name objectManager path queueSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBContainer class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new initialize! !

!ODBContainer methodsFor: 'public' stamp: ''!
addByteStorageRequest: anODBByteStorageRequest 
	byteStorageQueue add: anODBByteStorageRequest.
	queueSize := queueSize + anODBByteStorageRequest bytes size.
	queueSize > 65536 ifTrue: [self flushBytes]! !

!ODBContainer methodsFor: 'public' stamp: ''!
at: index 
	| bytes |
	(bytes := indexFile at: index) isNil ifTrue: [^nil].
	^(ODBObjectHolder createOn: bytes) setContainer: self
		objectID: (ODBObjectID containerID: id index: index)! !

!ODBContainer methodsFor: 'public' stamp: 'dg 12/20/2003 22:37'!
close
	dbFiles do: [:each | each isNil ifFalse: [each close]].
	indexFile isNil ifFalse: [indexFile close].
	dataFileA isNil ifFalse: [dataFileA close].
	dataFileB isNil ifFalse: [dataFileB close]! !

!ODBContainer methodsFor: 'public' stamp: 'dg 12/20/2003 10:16'!
closeObjectFile: anInteger 
	"Remove database object file number anInteger from 
        dictionary of opened files and close it."

	| file |
	dbFilesMutex critical: 
			[file := dbFiles at: anInteger ifAbsent: [^self].
			dbFiles removeKey: anInteger.
			file
				close]! !

!ODBContainer methodsFor: 'public' stamp: ''!
createNewObjectSpace
	"Create new object space for garbage collection."

	dataFileA isNil 
		ifTrue: [dataFileA := ODBObjectStorage createOn: self dataFileNameA]
		ifFalse: 
			[dataFileB isNil ifTrue: [dataFileB := ODBObjectStorage createOn: self dataFileNameB]]! !

!ODBContainer methodsFor: 'public' stamp: ''!
createOn: aString 
	"Create new container on containerPath."

	path := aString.
	
	[indexFile := ODBObjectIndexFile createOn: self indexFileName.
	objectManager defaultObjectSpace == 0 
		ifTrue: 
			[dataFileA := ODBObjectStorage createOn: self dataFileNameA.
			activeDataFile := dataFileA]
		ifFalse: 
			[dataFileB := ODBObjectStorage createOn: self dataFileNameB.
			activeDataFile := dataFileB]] 
			ifCurtailed: [self close]! !

!ODBContainer methodsFor: 'private' stamp: ''!
dataFileNameA
	^path , ODBFileStream pathSeparatorString , 'objects.a'! !

!ODBContainer methodsFor: 'private' stamp: ''!
dataFileNameB
	^path , ODBFileStream pathSeparatorString , 'objects.b'! !

!ODBContainer methodsFor: 'public' stamp: ''!
dataFileSize
	^activeDataFile stream size! !

!ODBContainer methodsFor: 'private-accessing' stamp: 'cdg 3/13/2003 18:05'!
dirName
        "Private - Needed by database objects that 
        are creating their own files."

    ^path! !

!ODBContainer methodsFor: 'private' stamp: ''!
fileNameFromIndex: anInteger 
	"Private - Answer object file name from index."

	^path , ODBFileStream pathSeparatorString , anInteger printString , '.btr'! !

!ODBContainer methodsFor: 'public' stamp: ''!
flushBytes
	"Store byte array queue to dataFile and update object holders in queue."

	| pos bufPos stream buf size bytes objectPosition |
	queueSize == 0 ifTrue: [^self].
	self lockDataFile.
	stream := activeDataFile stream.
	pos := stream setToEnd.
	buf := ByteArray new: queueSize.
	bufPos := 0.
	byteStorageQueue do: 
			[:each | 
			bytes := each bytes.
			size := bytes size.
			buf 
				replaceFrom: bufPos + 1
				to: bufPos + size
				with: bytes
				startingAt: 1.
			objectPosition := pos + bufPos bitShift: 1.
			activeDataFile == dataFileA 
				ifTrue: [each objectPosition: objectPosition]
				ifFalse: [each objectPosition: (objectPosition bitOr: 1)].
			bufPos := bufPos + size].
	stream
		atPosition: pos
			putBytesFrom: buf
			len: queueSize;
		flush.
	activeDataFile unlockAdding.
	byteStorageQueue do: [:each | each bytesStored].
	byteStorageQueue := OrderedCollection new.
	queueSize := 0! !

!ODBContainer methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
id

    ^id! !

!ODBContainer methodsFor: 'private-accessing' stamp: 'cdg 3/13/2003 18:05'!
id: anInteger

    id := anInteger! !

!ODBContainer methodsFor: 'private-accessing' stamp: 'cdg 3/13/2003 18:05'!
indexFile

    ^indexFile! !

!ODBContainer methodsFor: 'private' stamp: ''!
indexFileName
	^path , ODBFileStream pathSeparatorString , 'objects.idx'! !

!ODBContainer methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
initHolders: holders

    indexFile addHolders: holders! !

!ODBContainer methodsFor: 'private' stamp: ''!
initialize
	dbFiles := ODBWeakValueIdentityDictionary new.
	dbFilesMutex := Semaphore forMutualExclusion.
	byteStorageQueue := OrderedCollection new.
	queueSize := 0! !

!ODBContainer methodsFor: 'public' stamp: ''!
loadBytesAt: anInteger length: length 
	| byteArray stream bytesRead |
	(anInteger bitAnd: 1) == 0 
		ifTrue: 
			[dataFileA isNil ifTrue: [dataFileA := ODBObjectStorage openOn: self dataFileNameA].
			stream := dataFileA stream]
		ifFalse: 
			[dataFileB isNil ifTrue: [dataFileB := ODBObjectStorage openOn: self dataFileNameB].
			stream := dataFileB stream].
	byteArray := ByteArray new: length.
	bytesRead := stream 
				atPosition: (anInteger bitShift: -1)
				getBytesFor: byteArray
				len: length.
	bytesRead == length ifTrue: [^byteArray].
	^OmniBase signalError: 'Can not read object'! !

!ODBContainer methodsFor: 'private' stamp: ''!
lockDataFile
	| currentSpace defaultSpace |
	activeDataFile waitForAddingLockWhileWaitingDo: 
			[currentSpace := activeDataFile == dataFileA ifTrue: [0] ifFalse: [1].
			defaultSpace := objectManager defaultObjectSpace.
			currentSpace == defaultSpace 
				ifFalse: 
					[defaultSpace == 0 
						ifTrue: 
							[dataFileA isNil ifTrue: [dataFileA := ODBObjectStorage openOn: self dataFileNameA].
							activeDataFile := dataFileA]
						ifFalse: 
							[dataFileB isNil ifTrue: [dataFileB := ODBObjectStorage openOn: self dataFileNameB].
							activeDataFile := dataFileB].
					^self lockDataFile]]! !

!ODBContainer methodsFor: 'public' stamp: ''!
lockObjectSpace: anInteger 
	anInteger = 0 ifTrue: [dataFileA waitForAddingLock] ifFalse: [dataFileB waitForAddingLock]! !

!ODBContainer methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
name

    ^name! !

!ODBContainer methodsFor: 'private-accessing' stamp: 'cdg 3/13/2003 18:05'!
name: aString

    name := aString! !

!ODBContainer methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
newObjectHolder

    ^ODBObjectHolder new
        setContainer: self objectID: (ODBObjectID containerID: id index: 0)! !

!ODBContainer methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
numberOfObjects
		"Answer number of objects in container."

	^indexFile getLastIndex! !

!ODBContainer methodsFor: 'public' stamp: ''!
objectHoldersDo: aBlock 
	| objectHolder |
	indexFile indexesAndValuesDo: 
			[:index :value | 
			objectHolder := (ODBObjectHolder createOn: value) setContainer: self
						objectID: (ODBObjectID containerID: id index: index).
			aBlock value: objectHolder]! !

!ODBContainer methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
objectManager

    ^objectManager! !

!ODBContainer methodsFor: 'private' stamp: ''!
objectManager: anODBObjectManager 
	objectManager := anODBObjectManager! !

!ODBContainer methodsFor: 'public' stamp: 'dg 12/20/2003 10:16'!
onNewObjectFileDo: aBlock 
	| file newIndex |
	dbFilesMutex critical: 
			[newIndex := indexFile newObjectFileID.
			file := aBlock value: newIndex value: (self fileNameFromIndex: newIndex).
			file notNil 
				ifTrue: 
					[dbFiles at: newIndex put: file]].
	^file! !

!ODBContainer methodsFor: 'public' stamp: 'dg 12/20/2003 10:16'!
openObjectFile: index ifAbsentPut: aBlock 
	| file |
	dbFilesMutex critical: 
			[((file := dbFiles at: index) isNil or: [file stream isNil]) 
				ifTrue: 
					[file := aBlock value: (self fileNameFromIndex: index).
					dbFiles at: index put: file]].
	^file! !

!ODBContainer methodsFor: 'public' stamp: ''!
openOn: aString 
	path := aString.
	
	[indexFile := ODBObjectIndexFile openOn: self indexFileName.
	objectManager defaultObjectSpace == 0 
		ifTrue: 
			[dataFileA := ODBObjectStorage openOn: self dataFileNameA.
			activeDataFile := dataFileA]
		ifFalse: 
			[dataFileB := ODBObjectStorage openOn: self dataFileNameB.
			activeDataFile := dataFileB]] 
			ifCurtailed: [self close]! !

!ODBContainer methodsFor: 'byte storage management' stamp: 'cdg 3/13/2003 18:05'!
removeHolderAt: index

	indexFile removeIndex: index! !

!ODBContainer methodsFor: 'public' stamp: 'dg 12/20/2003 10:16'!
removeObjectFile: anInteger 
	| file |
	dbFilesMutex critical: 
			[file := dbFiles at: anInteger ifAbsent: [^self].
			dbFiles removeKey: anInteger.
			file
				close.
			ODBFileStream remove: (self fileNameFromIndex: anInteger)]! !

!ODBContainer methodsFor: 'public' stamp: ''!
removeObjectSpace: anInteger 
	anInteger = 0 
		ifTrue: 
			[dataFileA isNil 
				ifFalse: 
					[activeDataFile == dataFileA ifTrue: [activeDataFile := dataFileB].
					dataFileA
						unlockAdding;
						removeAll;
						remove.
					dataFileA := nil]]
		ifFalse: 
			[dataFileB isNil 
				ifFalse: 
					[activeDataFile == dataFileB ifTrue: [activeDataFile := dataFileA].
					dataFileB
						unlockAdding;
						removeAll;
						remove.
					dataFileB := nil]]! !

!ODBContainer methodsFor: 'byte storage management' stamp: 'cdg 3/13/2003 18:05'!
setNewObjectSpace: newSpace

	| currentSpace |
	currentSpace := activeDataFile == dataFileA ifTrue: [0] ifFalse: [1].
	currentSpace = newSpace ifTrue: [ ^self ].
	newSpace = 0
		ifTrue: [
			dataFileA isNil ifTrue: [dataFileA := ODBObjectStorage openOn: self dataFileNameA].
			activeDataFile := dataFileA]
		ifFalse: [
			dataFileB isNil ifTrue: [dataFileB := ODBObjectStorage openOn: self dataFileNameB].
			activeDataFile := dataFileB].! !

Object subclass: #ODBDatabaseObject
	instanceVariableNames: 'objectHolder'
	classVariableNames: 'ClassIDs'
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBDatabaseObject class methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
addClassIDsTo: aDictionary
        "Private - Add classID of each subclass of receiver 
        to aDictionary. Answer class ID maximum."

    | maxID |
    maxID := 0.
    self subclasses do: [:each |
        aDictionary at: each classID put: each.
        maxID := (each classID max: maxID) max: (each addClassIDsTo: aDictionary)].
    ^maxID! !

!ODBDatabaseObject class methodsFor: 'public' stamp: ''!
hasBytes
	"Answer <true> if the object stores its contents as bytes."

	^false! !

!ODBDatabaseObject class methodsFor: 'public' stamp: ''!
hasExternalFiles
	"Answer <true> if the object stores its contents into external files."

	^false! !

!ODBDatabaseObject class methodsFor: 'private' stamp: 'dg 12/20/2003 09:24'!
initialize
	"Private - Initialize ClassIDs array used to convert classID to appropriate class."

	| dict maxID |
	dict := IdentityDictionary new.
	maxID := self addClassIDsTo: dict.
	ClassIDs := Array new: maxID.
	dict keysAndValuesDo: [:key :value | ClassIDs at: key put: value]! !

!ODBDatabaseObject class methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
persistentClassAt: anInteger
        "Answer persistent class for a given class ID."

    ^ClassIDs at: anInteger! !

!ODBDatabaseObject methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:05'!
close
        "Implemented by subclasses."! !

!ODBDatabaseObject methodsFor: 'public' stamp: ''!
garbageCollectOn: anODBGarbageCollector 
	self close! !

!ODBDatabaseObject methodsFor: 'public' stamp: ''!
makeTransactionObject: aTransaction 
	"Make transaction object from receiver. "

	self subclassResponsibility! !

!ODBDatabaseObject methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
objectHolder

    ^objectHolder! !

!ODBDatabaseObject methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:05'!
openOn: anObjectHolder

    objectHolder := anObjectHolder! !

!ODBDatabaseObject methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
referencesDo: aBlock! !

!ODBDatabaseObject methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
remove! !

ODBDatabaseObject subclass: #ODBDBBTreeIndexDictionary
	instanceVariableNames: 'iterator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBDBBTreeIndexDictionary subclass: #ODBDBBTreeDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBDBBTreeDictionary class methodsFor: 'defining' stamp: 'cdg 3/13/2003 18:06'!
classID
        "Answer database object classID."

    ^65! !

!ODBDBBTreeDictionary methodsFor: 'public' stamp: ''!
garbageCollectOn: anODBGarbageCollector 
	anODBGarbageCollector reorganizeDictionaries ifTrue: [self reorganizeBTree]! !

!ODBDBBTreeDictionary methodsFor: 'public' stamp: ''!
makeTransactionObject: aTransaction 
	iterator version = aTransaction versionDescriptor 
		ifFalse: 
			[iterator
				clearSearchCache;
				version: aTransaction versionDescriptor].
	^(ODBBTreeDictionary new)
		setObjectHolder: objectHolder
			dataBaseObject: self
			transaction: aTransaction;
		keySize: iterator keyLength! !

!ODBDBBTreeDictionary methodsFor: 'public' stamp: ''!
referencesDo: aBlock 
	| valueHolder association |
	iterator critical: [association := iterator getFirst].
	[association isNil] whileFalse: 
			[(valueHolder := ODBValueHolder createOn: association value) isRemoved 
				ifFalse: [aBlock value: valueHolder objectID].
			iterator critical: 
					[association := iterator
								goTo: association key;
								getNext]]! !

!ODBDBBTreeDictionary methodsFor: 'public' stamp: ''!
unlockKey: aKey with: lockID 
	| result |
	iterator critical: 
			[result := iterator
						goTo: aKey;
						unlockCurrentWith: lockID].
	^result! !

ODBDBBTreeDictionary subclass: #ODBDBBTreeIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBDBBTreeIdentityDictionary class methodsFor: 'public' stamp: ''!
classID
	"Answer database object classID."

	^68! !

!ODBDBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
makeTransactionObject: aTransaction 
	iterator version = aTransaction versionDescriptor 
		ifFalse: 
			[iterator
				clearSearchCache;
				version: aTransaction versionDescriptor].
	^(ODBBTreeIdentityDictionary new)
		setObjectHolder: objectHolder
			dataBaseObject: self
			transaction: aTransaction;
		keySize: iterator keyLength! !

!ODBDBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
referencesDo: aBlock 
	"A key is a persistent object and a value is a persistent object.
	Therefore we need to iterate over both."

	| valueHolder association |
	iterator critical: [association := iterator getFirst].
	[association isNil] whileFalse: 
			[(valueHolder := ODBValueHolder createOn: association value) isRemoved 
				ifFalse: 
					[aBlock value: (ODBObjectID new fromBytes: association key at: 1).
					aBlock value: valueHolder objectID].
			iterator critical: 
					[association := iterator
								goTo: association key;
								getNext]]! !

!ODBDBBTreeIndexDictionary class methodsFor: 'defining' stamp: 'cdg 3/13/2003 18:05'!
classID
        "Answer database object classID."

    ^67! !

!ODBDBBTreeIndexDictionary class methodsFor: 'public' stamp: ''!
hasExternalFiles
	"Answer <true> if the object stores its contents into external files."

	^true! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
associationsDo: aBlock 
	| association |
	iterator critical: [association := iterator getFirst].
	[association isNil] whileFalse: 
			[aBlock value: (Association key: association key
						value: (ODBValueHolder createOn: association value)).
			iterator critical: 
					[association := iterator
								goTo: association key;
								getNext]]! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
at: aKey ifAbsent: aBlock 
	| association |
	^(association := iterator goToAndGetCurrentAt: ((ByteArray new: iterator keyLength) 
						replaceFrom: 1
						to: (aKey size min: iterator keyLength)
						with: aKey
						startingAt: 1)) 
		isNil ifTrue: [aBlock value] ifFalse: [ODBValueHolder createOn: association value]! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
at: aKey put: value 
	iterator goTo: aKey put: value contents! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
close
	iterator notNil 
		ifTrue: 
			[objectHolder container closeObjectFile: objectHolder fileID.
			iterator := nil]! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
createBackupCopyIn: newContainer versionDescriptor: versionDescriptor oldHolders: oldHolders versionNumber: versionNumber 
	"Create a backup copy of receiver in a newContainer."

	| newIterator assoc size realSize valueHolder |
	newContainer onNewObjectFileDo: 
			[:index :fileName | 
			objectHolder fileID: index.
			newIterator := (ODBGcBTreeIterator new)
						keyLength: iterator keyLength;
						valueLength: ODBValueHolder sizeInBytes;
						createOn: fileName.
			size := iterator getSizeAt: versionDescriptor oldHolders: oldHolders.
			realSize := 0.
			
			[assoc := iterator getFirst.
			[assoc isNil] whileFalse: 
					[valueHolder := ODBValueHolder createOn: assoc value.
					[versionDescriptor versionOK: valueHolder versionNumber] 
						whileFalse: [valueHolder loadPreviousVersionFrom: oldHolders].
					valueHolder isRemoved 
						ifFalse: 
							[realSize := realSize + 1.
							valueHolder versionNumber: versionNumber.
							newIterator goTo: assoc key put: valueHolder contents].
					assoc := iterator getNext].
			"realSize = size ifFalse: [OmniBase warningMessage: 'Cached dictionary size does not match real size']."
			newIterator putSizeHolder: ((ODBSizeHolder new)
						dictionarySize: realSize;
						previousVersionPosition: 0;
						versionNumber: versionNumber;
						yourself).
			newIterator close] 
					ifCurtailed: [newIterator remove].
			iterator := nil]! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
createOn: anObjectHolder keySize: anInteger 
	objectHolder := anObjectHolder.
	objectHolder container onNewObjectFileDo: 
			[:index :fileName | 
			objectHolder fileID: index.
			iterator := (ODBBTreeIterator new)
						keyLength: anInteger;
						valueLength: ODBValueHolder sizeInBytes;
						createOn: fileName]! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
garbageCollectOn: anODBGarbageCollector 
	anODBGarbageCollector reorganizeIndexSets ifTrue: [self reorganizeBTree]! !

!ODBDBBTreeIndexDictionary methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
iterator

    ^iterator! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
makeTransactionObject: aTransaction 
	iterator version = aTransaction versionDescriptor 
		ifFalse: 
			[iterator
				clearSearchCache;
				version: aTransaction versionDescriptor].
	^(ODBBTreeIndexDictionary new)
		setObjectHolder: objectHolder
			dataBaseObject: self
			transaction: aTransaction;
		keySize: iterator keyLength! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
openOn: anObjectHolder 
	objectHolder := anObjectHolder.
	iterator := objectHolder container openObjectFile: objectHolder fileID
				ifAbsentPut: [:fileName | ODBBTreeIterator openOn: fileName]! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
remove
	iterator isNil 
		ifFalse: 
			[objectHolder container removeObjectFile: objectHolder fileID.
			iterator := nil]! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
reorganizeBTree
	"Reorganize B-Tree dictionary."

	| newIterator assoc oldIndex |
	objectHolder container onNewObjectFileDo: 
			[:index :fileName | 
			oldIndex := objectHolder fileID.
			objectHolder fileID: index.
			newIterator := (ODBGcBTreeIterator new)
						keyLength: iterator keyLength;
						valueLength: ODBValueHolder sizeInBytes;
						createOn: fileName.
			
			[newIterator putSizeHolder: iterator getSizeHolder.
			assoc := iterator getFirst.
			[assoc isNil] whileFalse: 
					[(ODBValueHolder createOn: assoc value) isRemoved 
						ifFalse: [newIterator goTo: assoc key put: assoc value].
					assoc := iterator getNext].
			newIterator close] 
					ifCurtailed: [newIterator remove].
			objectHolder store.
			iterator := nil].
	objectHolder container removeObjectFile: oldIndex! !

!ODBDBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
valuesDo: aBlock 
	| association |
	iterator critical: [association := iterator getFirst].
	[association isNil] whileFalse: 
			[aBlock value: (ODBValueHolder createOn: association value).
			iterator critical: 
					[association := iterator
								goTo: association key;
								getNext]]! !

ODBDBBTreeIndexDictionary subclass: #ODBDBBTreeIntegerIndexDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBDBBTreeIntegerIndexDictionary class methodsFor: 'public' stamp: ''!
classID
	"Answer database object classID."

	^70! !

!ODBDBBTreeIntegerIndexDictionary methodsFor: 'public' stamp: ''!
makeTransactionObject: aTransaction 
	iterator version = aTransaction versionDescriptor 
		ifFalse: 
			[iterator
				clearSearchCache;
				version: aTransaction versionDescriptor].
	^(ODBBTreeIntegerIndexDictionary new)
		setObjectHolder: objectHolder
			dataBaseObject: self
			transaction: aTransaction;
		keySize: iterator keyLength! !

ODBDBBTreeIndexDictionary subclass: #ODBDBBTreeMultiValueDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBDBBTreeMultiValueDictionary class methodsFor: 'public' stamp: ''!
classID
	"Answer database object classID."

	^69! !

!ODBDBBTreeMultiValueDictionary methodsFor: 'public' stamp: ''!
makeTransactionObject: aTransaction 
	iterator version = aTransaction versionDescriptor 
		ifFalse: 
			[iterator
				clearSearchCache;
				version: aTransaction versionDescriptor].
	^(ODBBTreeMultiValueDictionary new)
		setObjectHolder: objectHolder
			dataBaseObject: self
			transaction: aTransaction;
		keySize: iterator keyLength! !

!ODBDBBTreeMultiValueDictionary methodsFor: 'public' stamp: ''!
referencesDo: aBlock 
	| valueHolder association |
	iterator critical: [association := iterator getFirst].
	[association isNil] whileFalse: 
			[(valueHolder := ODBValueHolder createOn: association value) isRemoved 
				ifFalse: [aBlock value: valueHolder objectID].
			iterator critical: 
					[association := iterator
								goTo: association key;
								getNext]]! !

ODBDatabaseObject subclass: #ODBRootObjectDBHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBRootObjectDBHolder class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
classID
        "Answer database object classID."

    ^1! !

!ODBRootObjectDBHolder methodsFor: 'public' stamp: ''!
makeTransactionObject: aTransaction 
	^ODBRootObjectHolder new 
		setObjectHolder: objectHolder
		dataBaseObject: objectHolder rootObjectID
		transaction: aTransaction! !

!ODBRootObjectDBHolder methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:05'!
referencesDo: aBlock

	aBlock value: objectHolder rootObjectID! !

ODBDatabaseObject subclass: #ODBSerializedDBObjectWithoutReferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBSerializedDBObjectWithoutReferences subclass: #ODBSerializedDBObject256References
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBSerializedDBObject256References class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
classID
        "Answer database object classID."

    ^5! !

!ODBSerializedDBObject256References methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
makeTransactionObject: aTransaction

	| mStream bytes referenceManager |
	bytes := objectHolder loadBytes.
	mStream := ODBMemoryReadStream new
				createOn: bytes;
				position: ((referenceManager := ODBReferenceManager new) createMax256From: bytes).
	referenceManager transaction: aTransaction.
	^ODBSerializedObject new
		setObjectHolder: objectHolder
		dataBaseObject: (ODBDeserializer new
						deserializeFrom: mStream
						referenceManager: referenceManager
						transaction: aTransaction)
		transaction: aTransaction! !

!ODBSerializedDBObject256References methodsFor: 'public' stamp: ''!
referencesDo: aBlock 
	(ODBReferenceManager new)
		createMax256From: objectHolder loadBytes;
		referencesDo: aBlock! !

ODBSerializedDBObjectWithoutReferences subclass: #ODBSerializedDBObject65536References
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBSerializedDBObject65536References class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
classID
        "Answer database object classID."

    ^6! !

!ODBSerializedDBObject65536References methodsFor: 'public' stamp: ''!
makeTransactionObject: aTransaction 
	| mStream bytes referenceManager |
	bytes := objectHolder loadBytes.
	mStream := (ODBMemoryReadStream new)
				createOn: bytes;
				position: ((referenceManager := ODBReferenceManager new) createMax65536From: bytes).
	referenceManager transaction: aTransaction.
	^ODBSerializedObject new 
		setObjectHolder: objectHolder
		dataBaseObject: (ODBDeserializer new 
				deserializeFrom: mStream
				referenceManager: referenceManager
				transaction: aTransaction)
		transaction: aTransaction! !

!ODBSerializedDBObject65536References methodsFor: 'public' stamp: ''!
referencesDo: aBlock 
	(ODBReferenceManager new)
		createMax65536From: objectHolder loadBytes;
		referencesDo: aBlock! !

!ODBSerializedDBObjectWithoutReferences class methodsFor: 'defining' stamp: 'cdg 3/13/2003 18:06'!
classID
        "Answer database object classID."

    ^3! !

!ODBSerializedDBObjectWithoutReferences class methodsFor: 'public' stamp: ''!
hasBytes
	"Answer <true> if the object stores its contents as bytes."

	^true! !

!ODBSerializedDBObjectWithoutReferences methodsFor: 'public' stamp: ''!
garbageCollectOn: anODBGarbageCollector 
	objectHolder container 
		addByteStorageRequest: (ODBGarbageCollectorRequest new objectHolder: objectHolder
				bytes: objectHolder loadBytes)! !

!ODBSerializedDBObjectWithoutReferences methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
makeTransactionObject: aTransaction

	| mStream bytes |
	bytes := objectHolder loadBytes.
	mStream := ODBMemoryReadStream new createOn: bytes.
	^ODBSerializedObject new
		setObjectHolder: objectHolder
		dataBaseObject: (ODBDeserializer new
						deserializeFrom: mStream
						referenceManager: nil
						transaction: aTransaction)
		transaction: aTransaction! !

Object subclass: #ODBDemandLoader
	instanceVariableNames: 'objectID transaction proxyObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBDemandLoader methodsFor: 'public' stamp: ''!
getObject
	^proxyObject odbSetTransactionObject: (transaction transactionObjectAt: objectID)! !

!ODBDemandLoader methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
odbObjectID

    ^objectID! !

!ODBDemandLoader methodsFor: 'public' stamp: ''!
odbSerialize: serializer 
	(serializer register: objectID) ifFalse: [^serializer saveExternalReference: objectID]! !

!ODBDemandLoader methodsFor: 'private/intercepted messages' stamp: 'cdg 3/13/2003 18:05'!
perform: selector withArguments: arguments

    ^self getObject
        perform: selector
        withArguments: arguments! !

!ODBDemandLoader methodsFor: 'private/accessing' stamp: 'cdg 3/13/2003 18:05'!
printOn: aStream

    objectID printOn: aStream.
    ^proxyObject! !

!ODBDemandLoader methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
setTransaction: aTransaction objectID: anObjectID proxyObject: anODBReference

    transaction := aTransaction.
    objectID := anObjectID.
    proxyObject := anODBReference! !

!ODBDemandLoader methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
transaction

    ^transaction! !

Object subclass: #ODBDeserializer
	instanceVariableNames: 'classArray classes classesCounter classManager counter objects stream referenceManager transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBDeserializer class
	instanceVariableNames: 'classArray'!

!ODBDeserializer class methodsFor: 'private' stamp: ''!
classArray
	classArray isNil ifTrue: [self init].
	^classArray! !

!ODBDeserializer class methodsFor: 'public' stamp: 'david@inspiron 2/11/2005 12:57'!
deserializeFromBytes: aByteArray 
	| memoryStream referenceManager classManager |
	memoryStream := ODBMemoryReadStream new createOn: aByteArray.
	memoryStream getPositiveInteger = 0 
		ifFalse: [self error: 'External references not defined'].
	classManager := ODBClassManagerForSerialization new.
	classManager loadFromStream: memoryStream.
	^self new 
		deserializeFrom: memoryStream
		referenceManager: nil
		classManager: classManager! !

!ODBDeserializer class methodsFor: 'public' stamp: 'david@inspiron 2/11/2005 12:59'!
deserializeFromBytes: aByteArray externalReferencesLoaderBlock: aBlock 
	| memoryStream referenceManager classManager |
	memoryStream := ODBMemoryReadStream new createOn: aByteArray.
	referenceManager := ODBReferenceManager new.
	referenceManager loadFromStream: memoryStream externalReferencesLoaderBlock: aBlock.
	classManager := ODBClassManagerForSerialization new.
	classManager loadFromStream: memoryStream.
	^self new 
		deserializeFrom: memoryStream
		referenceManager: referenceManager
		classManager: classManager! !

!ODBDeserializer class methodsFor: 'private' stamp: 'mu 8/3/2005 19:26'!
init
	"ODBDeserializer init"
	classArray := Array new: 255.
	classArray
		at: 2 put: ODBNewObjectNewClass;
		at: 3 put: ODBNewObject;
		at: 4 put: ODBExistingObject;
		at: 5 put: ODBExternalReference;
		at: 6 put: ODBClassManagerForSerialization;
		at: 15 put: true;
		at: 16 put: false;
		at: 17 put: Message;
		at: 20 put: MessageSend;
		at: 19 put: Smalltalk;
		at: 22 put: Processor;
		at: 11 put: ODBLargePositiveInteger;
		at: 12 put: ODBLargeNegativeInteger;
		at: 13 put: Character;
		at: 29 put: ODBDoubleByteCharacter;
		at: 14 put: UndefinedObject;
		at: 10 put: nil;
		at: 18 put: Symbol;
		at: 26 put: Class;
		at: 31 put: Association;
		at: 32 put: Date;
		at: 33 put: Time;
		at: 34 put: String;
		at: 35 put: Array;
		at: 36 put: WideString; "Squeak"
		at: 37 put: Dictionary;
		at: 38 put: IdentityDictionary;
		at: 39 put: Fraction;
		at: 40 put: Float;
		at: 41 put: (ODBCopyValue value: 0.0);
		at: 42 put: (ODBCopyValue value: 1.0);
		at: 43 put: ODBFloatAsInteger;
		at: 44 put: ODBFloatAs100Integer;
		at: 45 put: ODB8ByteFloat;
		"should be ScaledDecimal but Squeak has not support for ScaledDecimal class, e.g. 1.0s does not work"
		at: 46 put: Float;
		at: 50 put: 0;
		at: 51 put: 1;
		at: 52 put: 2;
		at: 53 put: 3;
		at: 54 put: 4;
		at: 55 put: 5;
		at: 56 put: 6;
		at: 57 put: 7;
		at: 58 put: 8;
		at: 59 put: 9;
		at: 60 put: 10;
		at: 61 put: 11;
		at: 62 put: 12;
		at: 63 put: 13;
		at: 64 put: 14;
		at: 65 put: 15;
		at: 66 put: 16;
		at: 67 put: -3;
		at: 68 put: -2;
		at: 69 put: -1;
		at: 70 put: ODBEmptyString;
		at: 71 put: ODB1CharacterString;
		at: 72 put: (ODBnCharacterString length: 2);
		at: 73 put: (ODBnCharacterString length: 3);
		at: 74 put: (ODBnCharacterString length: 4);
		at: 75 put: (ODBnCharacterString length: 5);
		at: 76 put: (ODBnCharacterString length: 6);
		at: 77 put: (ODBnCharacterString length: 7);
		at: 78 put: (ODBnCharacterString length: 8);
		at: 79 put: (ODBnCharacterString length: 9);
		at: 80 put: ByteArray;
		at: 81 put: OrderedCollection;
		at: 82 put: ODBIdentityDictionary;
		at: 83 put: ODBPersistentDictionary;
		at: 84 put: ODBTransaction;
		yourself.! !

!ODBDeserializer class methodsFor: 'public' stamp: 'david@inspiron 2/9/2005 11:47'!
registerDeserializer: anObject withId: anInteger 
	self classArray at: anInteger put: anObject! !

!ODBDeserializer methodsFor: 'public' stamp: 'david@inspiron 2/9/2005 10:25'!
deserializeFrom: aStream referenceManager: aReferenceManager classManager: aClassManager 
	stream := aStream.
	referenceManager := aReferenceManager.
	classManager := aClassManager.
	classArray := self class classArray.
	objects := Array new: stream getLong.
	classes := OrderedCollection new: 30.
	counter := 0.
	classesCounter := 0.
	^self nextObject! !

!ODBDeserializer methodsFor: 'public' stamp: 'ac 3/14/2004 19:52'!
deserializeFrom: aStream
	referenceManager: aReferenceManager
	transaction: aTransaction

	stream := aStream.
	referenceManager := aReferenceManager.
	classManager := aTransaction environment classManager.
	transaction := aTransaction.
	classArray := self class classArray.
	objects := Array new: stream getLong.
	classes := OrderedCollection new: 30.
	counter := 0.
	classesCounter := 0.
	^self odbNextObject! !

!ODBDeserializer methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
existingObject

	^objects at: stream getPositiveInteger! !

!ODBDeserializer methodsFor: 'private' stamp: ''!
loadError
	| id |
	stream position: stream position - 1.
	id := stream getByte.
	OmniBase 
		signalError: 'OmniBase deserializer: Unknown serialization id (' , id printString , ')'! !

!ODBDeserializer methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
loadReference

	^self register: (referenceManager referenceAt: stream getPositiveInteger)! !

!ODBDeserializer methodsFor: 'private' stamp: ''!
newObjectNewClass
	| classInfo |
	classInfo := classManager classDescriptionAt: stream getPositiveInteger.
	classesCounter := classesCounter + 1.
	classes add: classInfo.
	^classInfo realClass odbLoadVariables: self classInfo: classInfo! !

!ODBDeserializer methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
newObjectOldClass

	| classInfo |
	^(classInfo := classes at: stream getPositiveInteger) realClass
		odbLoadVariables: self
		classInfo: classInfo! !

!ODBDeserializer methodsFor: 'private' stamp: 'ac 3/14/2004 19:52'!
odbNextObject

	^(classArray at: stream getByte) odbDeserialize: self! !

!ODBDeserializer methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
register: anObject

	^objects at: (counter := counter + 1) put: anObject! !

!ODBDeserializer methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
stream

	^stream! !

!ODBDeserializer methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
transaction

	^transaction! !

Object subclass: #ODBDeserializers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBDeserializers subclass: #ODB1CharacterString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODB1CharacterString class methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

    | str |
    (str := String new: 1) at: 1 put: deserializer stream getChar.
    ^deserializer register: str! !

ODBDeserializers subclass: #ODB8ByteFloat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODB8ByteFloat class methodsFor: 'accessing' stamp: 'david@inspiron 12/1/2003 21:06'!
odbDeserialize: deserializer 
	| float |
	float := Float basicNew: 8.
	deserializer stream getBytesFor: (ExternalAddress fromInteger: float yourAddress) len: 8.
	^float! !

ODBDeserializers subclass: #ODBCopyValue
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBCopyValue class methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
value: anObject

    ^self new value: anObject! !

!ODBCopyValue methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

	^value copy! !

!ODBCopyValue methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
value: anObject

    value := anObject.! !

ODBDeserializers subclass: #ODBDoubleByteCharacter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBDoubleByteCharacter class methodsFor: 'serialization' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

    ^Character value: deserializer stream getWord! !

ODBDeserializers subclass: #ODBEmptyString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBEmptyString class methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
odbDeserialize: deserializer

    ^deserializer register: String new! !

ODBDeserializers subclass: #ODBExistingObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBExistingObject class methodsFor: 'serialization' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

    ^deserializer existingObject! !

ODBDeserializers subclass: #ODBExternalReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBExternalReference class methodsFor: 'serialization' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

	^deserializer loadReference! !

ODBDeserializers subclass: #ODBFloatAs100Integer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBFloatAs100Integer class methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
odbDeserialize: deserializer

    ^deserializer stream getInteger / 100.0! !

ODBDeserializers subclass: #ODBFloatAsInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBFloatAsInteger class methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

    ^deserializer stream getInteger asFloat! !

ODBDeserializers subclass: #ODBLargeNegativeInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBLargeNegativeInteger class methodsFor: 'no category' stamp: 'cdg 3/13/2003 18:06'!
odbDeserialize: deserializer

	^0 - deserializer stream getPositiveInteger! !

ODBDeserializers subclass: #ODBLargePositiveInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBLargePositiveInteger class methodsFor: 'no category' stamp: 'cdg 3/13/2003 18:06'!
odbDeserialize: deserializer

	^deserializer stream getPositiveInteger! !

ODBDeserializers subclass: #ODBNewObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBNewObject class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
odbDeserialize: deserializer

	^deserializer newObjectOldClass! !

ODBDeserializers subclass: #ODBNewObjectNewClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBNewObjectNewClass class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

	^deserializer newObjectNewClass! !

ODBDeserializers subclass: #ODBnCharacterString
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBnCharacterString class methodsFor: 'creation' stamp: 'cdg 3/13/2003 18:05'!
length: anInteger

    ^self new n: anInteger! !

!ODBnCharacterString methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
n: anInteger

    n := anInteger.! !

!ODBnCharacterString methodsFor: 'accessing' stamp: 'cdg 3/13/2003 21:44'!
odbDeserialize: deserializer

    | buf |
    deserializer stream getBytesFor: (buf := ByteArray new: n) len: n.
    ^deserializer register: buf asString! !

Object subclass: #ODBExpiredProxyObject
	instanceVariableNames: 'oid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBExpiredProxyObject class methodsFor: 'public' stamp: 'david@inspiron 10/19/2004 15:29'!
on: oid 
	^self new oid: oid! !

!ODBExpiredProxyObject methodsFor: 'private' stamp: 'david@inspiron 10/19/2004 15:31'!
odbBasicSerialize: serializer 
	OmniBase 
		signalError: 'This object can not be serialized. The transaction in which this proxy was loaded is already aborted.'! !

!ODBExpiredProxyObject methodsFor: 'private' stamp: 'david@inspiron 10/19/2004 15:31'!
odbSerialize: serializer 
	OmniBase 
		signalError: 'This object can not be serialized. The transaction in which this proxy was loaded is already aborted.'! !

!ODBExpiredProxyObject methodsFor: 'public' stamp: 'david@inspiron 10/19/2004 15:29'!
oid: anODBObjectID 
	oid := anODBObjectID! !

!ODBExpiredProxyObject methodsFor: 'public' stamp: 'david@inspiron 10/19/2004 15:32'!
printOn: aStream 
	aStream nextPutAll: 'Expired OmniBase proxy object of OID='.
	oid printOn: aStream! !

!ODBExpiredProxyObject methodsFor: 'private' stamp: 'david@inspiron 10/23/2004 16:44'!
value
	^self! !

Object subclass: #ODBExternalBuffer
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBExternalBuffer subclass: #ODBBTreePage
	instanceVariableNames: 'pagePosition keyLength valueLength iterator indexOnPage itemLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBBTreePage class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
createOnFile: anODBTreeIterator
    position: position
    keyLength: keyLen
    valueLength: valueLen

    ^self basicNew
        createOnFile: anODBTreeIterator
        position: position
        keyLength: keyLen
        valueLength: valueLen! !

!ODBBTreePage class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
loadFromFile: anODBTreeIterator
    position: position
    keyLength: keyLen
    valueLength: valueLen

    ^self basicNew
        loadFromFile: anODBTreeIterator
        position: position
        keyLength: keyLen
        valueLength: valueLen! !

!ODBBTreePage methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
association

    | offset |
    offset := itemLength * indexOnPage + 2.
    ^Association
        key: (contents copyFrom: offset to: offset + keyLength - 1)
        value: (contents copyFrom: offset + keyLength to: offset + keyLength + valueLength - 1)! !

!ODBBTreePage methodsFor: 'private' stamp: ''!
bytesPerPage
	"Private - Answer number of bytes needed to load a page."

	"(keyLen + valueLen + next + lockID) * pageSize + next0 + count"

	^(itemLength + 4) * self pageSize + 5! !

!ODBBTreePage methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:05'!
createOnFile: anODBTreeIterator
    position: position
    keyLength: keyLen
    valueLength: valueLen
        "Private - Create receiver on file."

    iterator := anODBTreeIterator.
    keyLength := keyLen.
    valueLength := valueLen.
    itemLength := keyLength + valueLength + 2. "key+value+lockID"
    pagePosition := position.
    indexOnPage := 0.
    contents := ByteArray new: self bytesPerPage! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
currentAssociation
	"Answer current association or <nil> 
        if upper pages have to be loaded."

	^(indexOnPage == self numberOfItems or: [indexOnPage < 0]) ifFalse: [self association]! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
insertKey: key value: value lockID: lockID 
	"Insert key, value and lockID at current position on page. Answer 
        array with page split information or <nil> if no page split occured."

	| n startOffset |
	startOffset := itemLength * indexOnPage + 1.
	n := self numberOfItems.
	n == self pageSize 
		ifTrue: 
			["split page"
			contents at: 1 put: ((contents at: 1) bitOr: 128).	"this page must be leaf"
			n := ByteArray new: itemLength.
			n
				replaceFrom: 1
					to: keyLength
					with: key
					startingAt: 1;
				replaceFrom: keyLength + 1
					to: keyLength + valueLength
					with: value
					startingAt: 1;
				odbShortAt: itemLength - 1 put: lockID.
			^self 
				splitPageWith: n
				leftNext: 0
				rightNext: 0].
	n > indexOnPage 
		ifTrue: 
			[self bytesAtOffset: startOffset + itemLength
				put: (self bytesAtOffset: startOffset count: (n - indexOnPage) * itemLength)].
	self
		bytesAtOffset: startOffset put: key;
		bytesAtOffset: startOffset + keyLength put: value;
		uShortAtOffset: startOffset + keyLength + valueLength put: lockID.
	self numberOfItems: n + 1.
	^nil! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
insertPageSplit: pageSplit 
	"Insert page split at current position on page. Answer array 
        with page split information if another page split is needed 
        or <nil> if current page is not full."

	| n itemOffset nextOffset pageSize item leftNext rightNext |
	leftNext := (pageSplit at: 1) position.
	item := pageSplit at: 2.
	rightNext := (pageSplit at: 3) position.
	pageSize := self pageSize.
	n := self numberOfItems.
	n == pageSize 
		ifTrue: 
			[^self 
				splitPageWith: item
				leftNext: leftNext
				rightNext: rightNext].
	itemOffset := itemLength * indexOnPage + 1.
	nextOffset := itemLength * pageSize + (indexOnPage * 4) + 1.
	n > indexOnPage 
		ifTrue: 
			[self bytesAtOffset: itemOffset + itemLength
				put: (self bytesAtOffset: itemOffset count: (n - indexOnPage) * itemLength).
			self bytesAtOffset: nextOffset + 8
				put: (self bytesAtOffset: nextOffset + 4 count: (n - indexOnPage) * 4)].
	self
		bytesAtOffset: itemOffset put: item;
		uLongAtOffset: nextOffset put: leftNext;
		uLongAtOffset: nextOffset + 4 put: rightNext;
		numberOfItems: n + 1.
	^nil! !

!ODBBTreePage methodsFor: 'private' stamp: ''!
insertSplitItem: item leftNext: leftNext rightNext: rightNext 
	"Private - Insert aByteArray at indexOnPage. Answer item 
	at pageSize // 2 that is going to be moved up the tree."

	| itemOffset nextOffset n |
	n := self pageSize // 2.
	itemOffset := itemLength * indexOnPage + 1.
	nextOffset := itemLength * self pageSize + (indexOnPage * 4) + 1.
	self bytesAtOffset: itemOffset + itemLength
		put: (self bytesAtOffset: itemOffset count: (n - indexOnPage) * itemLength).
	self bytesAtOffset: nextOffset + 8
		put: (self bytesAtOffset: nextOffset + 4 count: (n - indexOnPage) * 4).
	self
		bytesAtOffset: itemOffset put: item;
		uLongAtOffset: nextOffset put: leftNext;
		uLongAtOffset: nextOffset + 4 put: rightNext! !

!ODBBTreePage methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
leftNext
        "Answer leftmost pointer to next page. And 
        set indexOnPage to zero."

    indexOnPage := 0.
    ^self nextAt: 0! !

!ODBBTreePage methodsFor: 'private' stamp: ''!
loadFromFile: anODBTreeIterator position: position keyLength: keyLen valueLength: valueLen 
	"Private - Load receiver from stream."

	iterator := anODBTreeIterator.
	keyLength := keyLen.
	valueLength := valueLen.
	itemLength := keyLen + valueLen + 2.	"key+value+lockID"
	pagePosition := position.
	contents := ByteArray new: self bytesPerPage.
	iterator stream atPosition: position getBytesFor: contents! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
lockID
	^self uShortAtOffset: (indexOnPage + 1) * itemLength - 1! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
lockID: anInteger 
	self uShortAtOffset: (indexOnPage + 1) * itemLength - 1 put: anInteger! !

!ODBBTreePage methodsFor: 'private' stamp: ''!
nextAt: index 
	(contents at: 1) > 127 ifTrue: [^0].
	^self uLongAtOffset: itemLength * self pageSize + 1 + (index * 4)! !

!ODBBTreePage methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
nextAt: index put: position

    self uLongAtOffset: itemLength * self pageSize + 1 + (index * 4) put: position! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
nextPage
	"Increase indexOnPage and answer pointer to nextPage. 
        Answer <nil> if indexOnPage equals numberOfItems."

	indexOnPage < self numberOfItems ifFalse: [^nil].
	indexOnPage := indexOnPage + 1.
	^self nextAt: indexOnPage! !

!ODBBTreePage methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
numberOfItems

    ^(contents at: 1) bitAnd: 127! !

!ODBBTreePage methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
numberOfItems: anInteger
        "Private - Set number of items on page."

    (contents at: 1) < 128
        ifTrue: [contents at: 1 put: anInteger]
        ifFalse: [contents at: 1 put: anInteger + 128]! !

!ODBBTreePage methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:05'!
pageSize
        "Private - Answer maximum number of keys on page."

    "change methods #positionToCachedKey: and #positionToKey: too!!"
    ^32! !

!ODBBTreePage methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
position

    ^pagePosition! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
positionToCachedKey: aKey 
	"Search for aKey on page. Answer <true> if found. 
        If not answer position of child page where aKey could 
        be located. Answer 0 if this is a leaf page. Answer 
        <nil> if position can not be determined (i.e. indexOnPage 
        is at the start or at the end of this page)."

	| n min max result flag |
	min := 0.
	max := n := (flag := contents at: 1) bitAnd: 127.
	indexOnPage := max bitShift: -1.
	n == 0 ifTrue: [^nil].
	
	[(result := iterator 
				isKey: contents
				at: indexOnPage * itemLength + 1
				lessThan: aKey) isNil 
		ifTrue: [^true].
	result ifTrue: [min := indexOnPage + 1] ifFalse: [max := indexOnPage].
	min == max] 
			whileFalse: [indexOnPage := min + max bitShift: -1].
	(indexOnPage := min) == n ifTrue: [^nil].
	indexOnPage == 0 ifTrue: [^nil].
	"Optimization for: ^self nextAt: indexOnPage"
	flag > 127 ifTrue: [^0].
	"PAGE SIZE=32 (bitShift: 5)"
	^self uLongAtOffset: (itemLength bitShift: 5) + 1 + (indexOnPage bitShift: 2)! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
positionToKey: aKey 
	"Search for aKey on page. Answer <true> if found. 
        If not answer position of child page where aKey could 
        be located. Answer 0 if this is a leaf page."

	| min max result flag |
	min := 0.
	max := (flag := contents at: 1) bitAnd: 127.
	indexOnPage := max bitShift: -1.
	max = 0 ifTrue: [^0].
	
	[(result := iterator 
				isKey: contents
				at: indexOnPage * itemLength + 1
				lessThan: aKey) == nil 
		ifTrue: [^true].
	result ifTrue: [min := indexOnPage + 1] ifFalse: [max := indexOnPage].
	min = max] 
			whileFalse: [indexOnPage := min + max bitShift: -1].
	indexOnPage := min.
	"Optimization for: ^self nextAt: indexOnPage"
	flag > 127 ifTrue: [^0].
	"PAGE SIZE=32 (bitShift: 5)"
	^self uLongAtOffset: (itemLength bitShift: 5) + 1 + (indexOnPage bitShift: 2)! !

!ODBBTreePage methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
position: anInteger

    pagePosition := anInteger! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
previousAssociation
	"Answer previous association or <nil> 
        if upper pages have to be loaded."

	| offset |
	(indexOnPage := indexOnPage - 1) < 0 ifTrue: [^nil].
	offset := indexOnPage * itemLength + 2.
	^Association key: (contents copyFrom: offset to: offset + keyLength - 1)
		value: (contents copyFrom: offset + keyLength to: offset + keyLength + valueLength - 1)! !

!ODBBTreePage methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
previousPage
        "Answer pointer to nextPage or <nil> if none."

    indexOnPage < 0 ifTrue: [^nil].
    ^self nextAt: indexOnPage! !

!ODBBTreePage methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
rightNext
        "Answer rightmost pointer to next page and set 
        indexOnPage to numberOfItems."

    indexOnPage := self numberOfItems.
    ^self nextAt: indexOnPage! !

!ODBBTreePage methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:06'!
shiftPageLeft: count
        "Private - Shift page to left count times. 
        Used for splitting pages."

    | nextOffset |
    indexOnPage := indexOnPage - count.
    nextOffset := self pageSize * itemLength + 1.
    self bytesAtOffset: 1
        put: (contents copyFrom: itemLength * count + 2 to: nextOffset).
    self bytesAtOffset: nextOffset
        put: (contents copyFrom: count * 4 + nextOffset + 1 to: contents size)! !

!ODBBTreePage methodsFor: 'private' stamp: ''!
splitPageWith: item leftNext: leftNext rightNext: rightNext 
	"Private - Split current page into left and right page. 
	Answer array with leftPage, middle item and rightPage."

	| newPage halfPage newItem itemOffset |
	newPage := self class 
				createOnFile: iterator
				position: 0
				keyLength: keyLength
				valueLength: valueLength.
	halfPage := self pageSize // 2.
	(contents at: 1) < 127 
		ifTrue: [contents at: 1 put: halfPage]
		ifFalse: [contents at: 1 put: halfPage + 128].
	indexOnPage == halfPage 
		ifTrue: 
			[self nextAt: halfPage put: leftNext.
			newPage contents: contents shallowCopy.
			self
				shiftPageLeft: halfPage;
				nextAt: 0 put: rightNext.
			^Array 
				with: newPage
				with: item
				with: self].
	itemOffset := halfPage * itemLength + 2.
	indexOnPage < halfPage 
		ifTrue: 
			[newPage
				contents: contents shallowCopy;
				shiftPageLeft: halfPage.
			self 
				insertSplitItem: item
				leftNext: leftNext
				rightNext: rightNext.
			newItem := contents copyFrom: itemOffset to: itemOffset + itemLength - 1.
			^Array 
				with: self
				with: newItem
				with: newPage].
	newPage contents: contents shallowCopy.
	newItem := contents copyFrom: itemOffset to: itemOffset + itemLength - 1.
	self
		shiftPageLeft: halfPage + 1;
		insertSplitItem: item
			leftNext: leftNext
			rightNext: rightNext.
	^Array 
		with: newPage
		with: newItem
		with: self! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
store
	"Store page on iterator stream."

	iterator stream 
		atPosition: pagePosition
		putBytesFrom: contents
		len: ((contents at: 1) > 127 
				ifFalse: [(itemLength + 4) * self pageSize + 5]
				ifTrue: [itemLength * self pageSize + 1])! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
storeItem
	"Store page on iterator stream."

	| offset |
	offset := itemLength * indexOnPage + 1 + keyLength.
	iterator stream atPosition: pagePosition + offset
		putBytesFrom: (contents copyFrom: 1 + offset to: offset + valueLength + 2)! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
storeItemLocked
	"Store item at indexOnPage to iterator stream."

	| offset |
	offset := itemLength * indexOnPage + 1 + keyLength.
	iterator waitForLockAt: pagePosition + offset length: valueLength + 2.
	iterator stream atPosition: pagePosition + offset
		putBytesFrom: (contents copyFrom: 1 + offset to: offset + valueLength + 2).
	iterator unlockAt: pagePosition + offset length: valueLength + 2! !

!ODBBTreePage methodsFor: 'public' stamp: ''!
storeLocked
	"Store page on iterator stream."

	| length |
	(contents at: 1) > 127 
		ifFalse: [length := (itemLength + 4) * self pageSize + 5]
		ifTrue: [length := itemLength * self pageSize + 1].
	iterator waitForLockAt: pagePosition length: length.
	iterator stream 
		atPosition: pagePosition
		putBytesFrom: contents
		len: length.
	iterator unlockAt: pagePosition length: length! !

!ODBBTreePage methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
value: aByteArray

    self bytesAtOffset: itemLength * indexOnPage + 1 + keyLength put: aByteArray! !

ODBBTreePage subclass: #ODBGcBTreePage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBGcBTreePage methodsFor: 'public' stamp: ''!
splitPageWith: item leftNext: leftNext rightNext: rightNext 
	"Private - Split current page into left and right page. 
	Answer array with leftPage, middle item and rightPage. 
	Left page in split will be full up to space for one item. 
	Split item will be put on the right page."

	| pageSize newPage newItem itemOffset leafBit |
	pageSize := self pageSize - 1.
	indexOnPage > pageSize 
		ifFalse: 
			[^super 
				splitPageWith: item
				leftNext: leftNext
				rightNext: rightNext].
	newPage := self class 
				createOnFile: iterator
				position: 0
				keyLength: keyLength
				valueLength: valueLength.
	leafBit := (contents at: 1) bitAnd: 128.
	"make left page"
	contents at: 1 put: pageSize + leafBit.
	itemOffset := pageSize * itemLength + 2.
	newItem := contents copyFrom: itemOffset to: itemOffset + itemLength - 1.
	newPage contents: contents shallowCopy.
	"make right page"
	contents at: 1 put: 1 + leafBit.
	self
		nextAt: 0 put: leftNext;
		nextAt: 1 put: rightNext.
	contents 
		replaceFrom: 2
		to: itemLength + 1
		with: item
		startingAt: 1.
	^Array 
		with: newPage
		with: newItem
		with: self! !

!ODBExternalBuffer class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
createOn: aByteArray

	^self basicNew contents: aByteArray! !

!ODBExternalBuffer class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
new

	^self new: self sizeInBytes! !

!ODBExternalBuffer class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
new: size

	^self basicNew contents: (ByteArray new: size)! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
bytesAtOffset: offset count: count

	^contents copyFrom: offset + 1 to: offset + count! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
bytesAtOffset: offset put: bytes

	^contents
		replaceFrom: offset + 1
		to: offset + bytes size
		with: bytes
		startingAt: 1.! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
contents

	^contents! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
contents: aByteArray

	contents := aByteArray! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
loadFromStream: aStream

	aStream getBytesFor: contents! !

!ODBExternalBuffer methodsFor: 'public' stamp: ''!
loadFromStream: aStream at: position 
	aStream atPosition: position getBytesFor: contents! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
storeOnStream: aStream

	aStream putBytesFrom: contents! !

!ODBExternalBuffer methodsFor: 'public' stamp: ''!
storeOnStream: aStream at: position 
	aStream atPosition: position putBytesFrom: contents! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
uLongAtOffset: offset

	^(contents at: offset + 1) +
		((contents at: offset + 2) bitShift: 8) +
		((contents at: offset + 3) bitShift: 16) +
		((contents at: offset + 4) bitShift: 24)! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
uLongAtOffset: offset put: longValue

	contents
		at: offset + 1 put: (longValue bitAnd: 16rFF);
		at: offset + 2 put: ((longValue bitShift: -8 ) bitAnd: 16rFF);
		at: offset + 3 put: ((longValue bitShift: -16 ) bitAnd: 16rFF);
		at: offset + 4 put: (longValue bitShift: -24).
	^longValue! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
uShortAtOffset: offset

	^(contents at: offset + 1) + ((contents at: offset + 2) bitShift: 8)! !

!ODBExternalBuffer methodsFor: 'converting' stamp: 'cdg 3/13/2003 18:05'!
uShortAtOffset: offset put: longValue

	contents
		at: offset + 1 put: (longValue bitAnd: 16rFF);
		at: offset + 2 put: ((longValue bitShift: -8 ) bitAnd: 16rFF).
	^longValue! !

ODBExternalBuffer subclass: #ODBObjectHolder
	instanceVariableNames: 'container objectID oldVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBObjectHolder class methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
createOn: aByteArray

    ^self basicNew createOn: aByteArray! !

!ODBObjectHolder class methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
new

    ^super new initialize! !

!ODBObjectHolder class methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
sizeInBytes
        "Private - Answer number of bytes required to store receiver into a file."

    ^16! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
container

    ^container! !

!ODBObjectHolder methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
createOn: aByteArray
        "Private - Create and initialize receiver."

    contents := aByteArray.
    oldVersion := false! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
fileID

    ^self uLongAtOffset: 9! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
fileID: anInteger

    self uLongAtOffset: 9 put: anInteger! !

!ODBObjectHolder methodsFor: 'load/store' stamp: 'cdg 3/13/2003 18:05'!
getObject
        "Answer database object."

    ^(ODBDatabaseObject persistentClassAt: self persistentClassID) new openOn: self! !

!ODBObjectHolder methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
initialize
        "Private - Initialize receiver."

    oldVersion := false! !

!ODBObjectHolder methodsFor: 'public' stamp: ''!
isRemoved
	1 to: contents size do: [:i | (contents at: i) == 0 ifFalse: [^false]].
	^true! !

!ODBObjectHolder methodsFor: 'load/store' stamp: 'cdg 3/13/2003 18:05'!
loadBytes
        "Load bytes at object position and answer a byte array."

    ^container loadBytesAt: self objectPosition length: self objectLength! !

!ODBObjectHolder methodsFor: 'load/store' stamp: 'cdg 3/13/2003 18:05'!
loadPreviousVersionFrom: oldHolders
        "Load previous version holder from oldHolders."

    oldVersion := true.
    oldHolders loadAt: self previousVersionPosition for: contents! !

!ODBObjectHolder methodsFor: 'private' stamp: 'jf 2/23/2004 20:57'!
lockStartPosition
        "Answer start position at which object ID locks are set."

		"If using the ODBUnixFileStream, make sure to change #shareModeFlagLocation if you change this value"
    ^1000000000! !

!ODBObjectHolder methodsFor: 'public' stamp: ''!
lockWith: lockID 
	| indexFile |
	oldVersion ifTrue: [^false].
	indexFile := container indexFile.
	
	[(indexFile
		lock: objectID index;
		at: objectID index) = contents 
		ifTrue: [^indexFile stream lockAt: self lockStartPosition + objectID index length: 1].
	oldVersion := true] 
			ensure: [container indexFile unlock: objectID index].
	^false! !

!ODBObjectHolder methodsFor: 'load/store' stamp: 'cdg 3/13/2003 18:05'!
makeNewVersion: oldHolders

        | position |
        self versionNumber = 0 "new object"
                ifTrue: [ position := 0]
                ifFalse: [ position := oldHolders store: contents ].
        ^(self class createOn: contents shallowCopy)
                setContainer: container objectID: objectID;
                previousVersionPosition: position! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
objectID

    ^objectID! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
objectLength

    ^((contents at: 10) bitOr: ((contents at: 11) bitShift: 8)) bitOr: ((contents at: 12) bitShift: 16)! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
objectLength: anInteger

    contents
        at: 10 put: (anInteger bitAnd: 255);
        at: 11 put: ((anInteger bitShift: -8) bitAnd: 255);
        at: 12 put: (anInteger bitShift: -16)! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
objectPosition

    ^self uLongAtOffset: 12! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
objectPosition: anInteger

    self uLongAtOffset: 12 put: anInteger! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
oldVersion

    ^oldVersion! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
persistentClassID

    ^contents at: 9! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
persistentClassID: anInteger

    contents at: 9 put: anInteger! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
previousVersionPosition

    ^self uLongAtOffset: 4! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
previousVersionPosition: anInteger

    self uLongAtOffset: 4 put: anInteger! !

!ODBObjectHolder methodsFor: 'public' stamp: ''!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	objectID printOn: aStream.
	aStream nextPutAll: ';version='.
	self versionNumber printOn: aStream.
	aStream nextPutAll: ';pid='.
	self persistentClassID printOn: aStream.
	aStream nextPut: $)! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
rootObjectID
        "Answer root object ID for root object holder."

    ^ODBObjectID new fromBytes: contents at: 10! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
rootObjectID: anObjectID
        "Set root object ID for root object holder."

    anObjectID putBytesTo: contents at: 10! !

!ODBObjectHolder methodsFor: 'private' stamp: ''!
setContainer: aContainer 
	container := aContainer! !

!ODBObjectHolder methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
setContainer: aContainer objectID: anObjectID

    objectID := anObjectID.
    container := aContainer! !

!ODBObjectHolder methodsFor: 'public' stamp: ''!
store
	"Store contents to indexFile."

	| indexFile index |
	
	[(indexFile := container indexFile)
		lock: (index := objectID index);
		at: index put: contents] 
			ensure: [indexFile unlock: index]! !

!ODBObjectHolder methodsFor: 'load/store' stamp: 'cdg 3/13/2003 18:05'!
storeBytes: aByteArray

    self objectLength: aByteArray size.
    container addByteStorageRequest: (ODBByteStorageRequest new
                                        objectHolder: self bytes: aByteArray)! !

!ODBObjectHolder methodsFor: 'public' stamp: ''!
unlockWith: lockID 
	oldVersion ifTrue: [^false].
	^container indexFile stream unlockAt: self lockStartPosition + objectID index length: 1! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
versionNumber

    ^self uLongAtOffset: 0! !

!ODBObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
versionNumber: anInteger

    self uLongAtOffset: 0 put: anInteger! !

ODBExternalBuffer subclass: #ODBSizeHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBSizeHolder class methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
sizeInBytes

    ^12! !

!ODBSizeHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
dictionarySize

    ^self uLongAtOffset: 0! !

!ODBSizeHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
dictionarySize: anInteger

    self uLongAtOffset: 0 put: anInteger! !

!ODBSizeHolder methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
loadPreviousVersionFrom: oldHolders

    oldHolders loadAt: self previousVersionPosition for: contents! !

!ODBSizeHolder methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
makeNewVersion: oldHolders
        "Store receiver to oldHolders and make new instance 
        of receiver class that points to receiver in oldHolders."

    | newVersion position |
    self versionNumber = 0
        ifTrue: [ position := 0 ]
        ifFalse: [ position := oldHolders store: contents ].
    newVersion := self class new.
    ^newVersion previousVersionPosition: position! !

!ODBSizeHolder methodsFor: 'private/accessing' stamp: 'cdg 3/13/2003 18:06'!
previousVersionPosition

    ^self uLongAtOffset: 8! !

!ODBSizeHolder methodsFor: 'private/accessing' stamp: 'cdg 3/13/2003 18:06'!
previousVersionPosition: anInteger

    self uLongAtOffset: 8 put: anInteger! !

!ODBSizeHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
versionNumber

    ^self uLongAtOffset: 4! !

!ODBSizeHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
versionNumber: anInteger

    self uLongAtOffset: 4 put: anInteger! !

ODBExternalBuffer subclass: #ODBValueHolder
	instanceVariableNames: 'object removed objectSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBValueHolder class methodsFor: 'private' stamp: ''!
sizeInBytes
	"versionNumber          4 bytes
	previousVersionPosition 4 bytes
	objectID                4 bytes
	-------------------------------
	total                   12 bytes"

	^12! !

!ODBValueHolder methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
getObjectIn: aTransaction

	objectSet == true ifTrue: [^object].
	^aTransaction objectAt: self objectID! !

!ODBValueHolder methodsFor: 'public' stamp: ''!
isRemoved
	"Answer <true> if the key has been removed 
	(there is no value associated with it)."

	removed isNil ifFalse: [^removed].
	^removed := (self uLongAtOffset: 8) = 0! !

!ODBValueHolder methodsFor: 'public' stamp: ''!
loadPreviousVersionFrom: oldHolders 
	| previousVersionPosition |
	previousVersionPosition := self previousVersionPosition.
	previousVersionPosition = 0 
		ifTrue: [contents := ByteArray new: contents size]
		ifFalse: [oldHolders loadAt: previousVersionPosition for: contents]! !

!ODBValueHolder methodsFor: 'public' stamp: ''!
makeNewVersion: oldHolders 
	"Store receiver to oldHolders and make new instance
	of receiver class that points to receiver in oldKeys."

	| position |
	self versionNumber = 0 
		ifTrue: [position := 0]
		ifFalse: [position := oldHolders store: contents].
	^(self class new)
		previousVersionPosition: position;
		updateOn: self! !

!ODBValueHolder methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
makeRemoved
        "Mark valueHolder as removed."

    contents at: 8 put: ((contents at: 8) bitOr: 128)! !

!ODBValueHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
object

    ^object! !

!ODBValueHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
objectID

    ^ODBObjectID new fromBytes: contents at: 9! !

!ODBValueHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
objectID: anObjectID

    anObjectID putBytesTo: contents at: 9! !

!ODBValueHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
object: anObject

	object := anObject.
	removed := false.
	objectSet := true.! !

!ODBValueHolder methodsFor: 'private/accessing' stamp: 'cdg 3/13/2003 18:06'!
previousVersionPosition

    ^self uLongAtOffset: 4! !

!ODBValueHolder methodsFor: 'private/accessing' stamp: 'cdg 3/13/2003 18:06'!
previousVersionPosition: anInteger

    self uLongAtOffset: 4 put: anInteger! !

!ODBValueHolder methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
removed
        "Key has been removed."

    object := nil.
    removed := true! !

!ODBValueHolder methodsFor: 'public' stamp: ''!
updateOn: aValueHolder 
	"Private - Make new version from aValueHolder."

	(removed := aValueHolder isRemoved) 
		ifFalse: 
			[object := aValueHolder object.
			objectSet := true]! !

!ODBValueHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
versionNumber

    ^self uLongAtOffset: 0! !

!ODBValueHolder methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
versionNumber: anInteger

    self uLongAtOffset: 0 put: anInteger! !

Object subclass: #ODBFile
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBFile subclass: #ODBBTreeIterator
	instanceVariableNames: 'keyLength valueLength rootPagePosition searchPath currentKey currentKeyExists nextKey searchPathHeight version mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBBTreeIterator methodsFor: 'public' stamp: 'dg 12/20/2003 09:31'!
at: aString ifAbsent: aBlock 
	| key association |
	key := ByteArray new: keyLength.
	key replaceFrom: 1 to: (aString size min: keyLength) with: aString startingAt: 1.
	association := self goToAndGetCurrentAt: key.
	self clearSearchCache.
	association isNil ifTrue: [^aBlock value].
	^association value odbLongAt: 1! !

!ODBBTreeIterator methodsFor: 'public' stamp: 'dg 12/20/2003 09:35'!
at: aString put: anInteger 
	| key value |
	key := ByteArray new: keyLength.
	key 
		replaceFrom: 1
		to: (aString size min: keyLength)
		with: aString
		startingAt: 1.
	value := ByteArray new: 4.
	value odbLongAt: 1 put: anInteger.
	self
		goTo: key put: value;
		clearSearchCache.
	^anInteger! !

!ODBBTreeIterator methodsFor: 'private' stamp: ''!
basicPut: aValue 
	self lockTree.
	
	[self loadCurrentKey.
	currentKeyExists 
		ifTrue: 
			[(self lastPage)
				value: aValue;
				storeItemLocked]
		ifFalse: [self insertValue: aValue lockID: 0]] 
			ensure: [self unlockTree]! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
clearSearchCache
	"Clear search path."

	mutex critical: [self clearSearchPath]! !

!ODBBTreeIterator methodsFor: 'private' stamp: ''!
clearSearchPath
	"Private - Clear search path."

	[searchPathHeight == 0] whileFalse: 
			[searchPath at: searchPathHeight put: nil.
			searchPathHeight := searchPathHeight - 1]! !

!ODBBTreeIterator methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
created
                "Private - File has just been created."

        | buffer bufSize |
        bufSize := ODBSizeHolder sizeInBytes + 4.
        buffer := ByteArray new: bufSize.
        buffer  
                odbShortAt: bufSize - 3 put: keyLength;
                odbShortAt: bufSize - 1 put: valueLength.
        stream putBytesFrom: buffer len: bufSize.
        (self pageClass createOnFile: self
                                        position: rootPagePosition
                                        keyLength: keyLength
                                        valueLength: valueLength) store.
        currentKey := ByteArray new: keyLength.
        nextKey := ByteArray new: keyLength.
        stream flush! !

!ODBBTreeIterator methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
createOn: aString
        "Create a database file."

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeCreateNew
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareAll
                            cacheMode: ODBFileStream cacheModeAtomicWrite.
    ^self writeHeader! !

!ODBBTreeIterator methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
critical: aBlock

	^mutex critical: aBlock! !

!ODBBTreeIterator methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'BTree File
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBBTreeIterator methodsFor: 'public' stamp: 'dg 12/20/2003 09:38'!
fixTemps
	^self! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
getCurrent
	"Answer association at current key or <nil> if none."

	self updateCurrentKey.
	currentKeyExists ifFalse: [^nil].
	^self lastPage association! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
getFirst
	nextKey := ByteArray new: keyLength.
	self updateCurrentKey.
	currentKeyExists ifTrue: [^self lastPage association].
	^self searchNextAssociation! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
getLast
	nextKey := (ByteArray new: keyLength) atAllPut: 255.
	self updateCurrentKey.
	currentKeyExists ifTrue: [^self lastPage association].
	^self searchPreviousAssociation! !

!ODBBTreeIterator methodsFor: 'public/iterator interface' stamp: 'cdg 3/13/2003 18:06'!
getNext
        "Move to the next key and answer association."

    self updateCurrentKey.
    ^self searchNextAssociation! !

!ODBBTreeIterator methodsFor: 'public/iterator interface' stamp: 'cdg 3/13/2003 18:06'!
getPrevious
        "Move to the previous key and answer association."

    self updateCurrentKey.
    ^self searchPreviousAssociation! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
getSizeAt: versionDescriptor oldHolders: oldHolders 
	| sizeHolder |
	sizeHolder := (ODBSizeHolder new)
				loadFromStream: stream at: self headerLength;
				yourself.
	[versionDescriptor versionAtStartOK: sizeHolder versionNumber] 
		whileFalse: [sizeHolder loadPreviousVersionFrom: oldHolders].
	^sizeHolder dictionarySize! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
getSizeHolder
	^(ODBSizeHolder new)
		loadFromStream: stream at: self headerLength;
		yourself! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
goToAndGetCurrentAt: aKey 
	| result |
	mutex critical: 
			[result := self
						goTo: aKey;
						getCurrent].
	^result! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
goTo: aByteArray 
	aByteArray isNil ifFalse: [nextKey := aByteArray]! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
goTo: aByteArray put: aValue 
	mutex critical: 
			[aByteArray isNil ifFalse: [nextKey := aByteArray].
			self basicPut: aValue].
	^aValue! !

!ODBBTreeIterator methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
initialize
		"Private - Initialize receiver."

	searchPath := Array new: 20.
	searchPathHeight := 0.
	rootPagePosition := self headerLength + ODBSizeHolder sizeInBytes + 4.
	mutex := Semaphore forMutualExclusion.! !

!ODBBTreeIterator methodsFor: 'private' stamp: ''!
insertValue: aValue lockID: lockID 
	"Private - Insert aValue and lockID at currentKey. 
        Precondition: search path to currentKey is loaded and 
        currentKey does not exists."

	| page pageSplit |
	page := searchPath at: searchPathHeight.
	pageSplit := page 
				insertKey: currentKey
				value: aValue
				lockID: lockID.
	pageSplit isNil 
		ifTrue: 
			[currentKeyExists := true.
			page storeLocked.
			^self].
	
	[(pageSplit at: 1)
		position: stream setToEnd;
		store.
	(pageSplit at: 3)
		position: stream position;
		store.
	searchPath at: searchPathHeight put: nil.
	searchPathHeight := searchPathHeight - 1.
	searchPathHeight == 0 
		ifFalse: [page := searchPath at: searchPathHeight]
		ifTrue: 
			[page := self pageClass 
						createOnFile: self
						position: rootPagePosition
						keyLength: keyLength
						valueLength: valueLength].
	pageSplit := page insertPageSplit: pageSplit.
	pageSplit isNil] 
			whileFalse: [].
	self clearSearchPath.
	page storeLocked! !

!ODBBTreeIterator methodsFor: 'private/searching' stamp: 'cdg 3/13/2003 18:06'!
isCurrentKeySet
        "Private - Answer <true> if currentKey is the same as the next key."

    nextKey == currentKey ifTrue: [^true].
    1 to: keyLength do: [:i | (currentKey at: i) == (nextKey at: i) ifFalse: [^false]].
    ^true! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
isKey: keyBytes at: startPos lessThan: key2 
	"Private - Answer <true> if key located at keyBytes from startPos + 1 
        is less than key2. Answer <nil> if keys are equal."

	| b1 b2 |
	1 to: keyLength
		do: [:i | (b1 := keyBytes at: startPos + i) == (b2 := key2 at: i) ifFalse: [^b1 < b2]].
	^nil! !

!ODBBTreeIterator methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
isKey: key1 lessOrEqualTo: key2
        "Answer <true> if key1 is less or equal to key2."

    | i |
    i := 1.
    [(key1 at: i) == (key2 at: i) and: [i < keyLength]] whileTrue: [i := i + 1].
    ^(key1 at: i) <= (key2 at: i)! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
isLocked
	"Answer <true> if current key is locked."

	self updateCurrentKey.
	currentKeyExists ifFalse: [^false].
	^self lastPage lockID ~= 0! !

!ODBBTreeIterator methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
keyLength

    ^keyLength! !

!ODBBTreeIterator methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
keyLength: anInteger

    keyLength := anInteger! !

!ODBBTreeIterator methodsFor: 'private/page stack' stamp: 'cdg 3/13/2003 18:06'!
lastPage
        "Private - Answer last page in search path."

    ^searchPath at: searchPathHeight! !

!ODBBTreeIterator methodsFor: 'private/searching' stamp: 'cdg 3/13/2003 18:06'!
loadCurrentKey
        "Private - Load current key from file when it is going to be updated."

    currentKey := nextKey.
    currentKeyExists := false.
    self clearSearchPath; searchCurrentKeyFrom: rootPagePosition! !

!ODBBTreeIterator methodsFor: 'private/page stack' stamp: 'cdg 3/13/2003 18:06'!
loadPageAt: pagePosition
        "Private - Load B-Tree page, store it in searchPath. 
        Answer loaded page."

    | page |
    page := self pageClass loadFromFile: self
                        position: pagePosition
                        keyLength: keyLength
                        valueLength: valueLength.
    searchPathHeight := searchPathHeight + 1.
    ^searchPath at: searchPathHeight put: page! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
lockCurrentValue: value with: lockID 
	"Try to lock currentKey & value with lockID. 
	Answer <true> if successfull."

	| result page |
	result := false.
	self lockTree.
	
	[self loadCurrentKey.
	currentKeyExists 
		ifTrue: 
			[page := self lastPage.
			(result := page lockID == 0 and: [page association value = value]) 
				ifTrue: 
					[page
						lockID: lockID;
						storeItem]]
		ifFalse: 
			[self insertValue: value lockID: lockID.
			result := true]] 
			ensure: [self unlockTree].
	^result! !

!ODBBTreeIterator methodsFor: 'private/locking' stamp: 'cdg 3/13/2003 18:06'!
lockTree
        "Private - Lock tree when it is being updated."

    self waitForAddingLock! !

!ODBBTreeIterator methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
opened
                "Private - File has just been opened."

        | buffer bufSize |
        bufSize := ODBSizeHolder sizeInBytes + 2 + 2.
        buffer := ByteArray new: bufSize.
        stream getBytesFor: buffer.
        keyLength := buffer odbShortAt: bufSize - 3.
        valueLength := buffer odbShortAt: bufSize - 1.
        currentKey := ByteArray new: keyLength.
        nextKey := ByteArray new: keyLength! !

!ODBBTreeIterator methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
openOn: aString
        "Open transaction file. Signal an error if failed."

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeOpenExisting
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareAll
                            cacheMode: ODBFileStream cacheModeAtomicWrite.
    ^self compareHeader! !

!ODBBTreeIterator methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
pageClass
                "Private - Answer B-Tree page class."

        ^ODBBTreePage! !

!ODBBTreeIterator methodsFor: 'public/size holder' stamp: 'cdg 3/13/2003 18:06'!
putSizeHolder: aSizeHolder

    stream position: self headerLength.
    aSizeHolder storeOnStream: stream! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
put: aValue 
	mutex critical: [self basicPut: aValue]! !

!ODBBTreeIterator methodsFor: 'private/page stack' stamp: 'cdg 3/13/2003 18:06'!
removeLastPage
        "Private - Remove last page in search path. 
        Answer current last page in search path."

    searchPath at: searchPathHeight put: nil.
    searchPathHeight := searchPathHeight - 1.
    ^searchPath at: searchPathHeight! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
searchCurrentKeyFrom: pagePosition 
	"Private - Search current key and remember all pages following."

	| currentPage nextPagePosition |
	currentPage := self loadPageAt: pagePosition.
	
	[(nextPagePosition := currentPage positionToKey: currentKey) == true 
		ifTrue: 
			[currentKeyExists := true.
			^self].
	nextPagePosition = 0] 
			whileFalse: [currentPage := self loadPageAt: nextPagePosition]! !

!ODBBTreeIterator methodsFor: 'private' stamp: ''!
searchNextAssociation
	"Private - Search for next association. Answer <nil> if none."

	| page association nextPagePosition |
	page := self lastPage.
	currentKeyExists ifFalse: [association := page currentAssociation].
	[association isNil] whileTrue: 
			[(nextPagePosition := page nextPage) = 0 
				ifFalse: 
					[nextPagePosition isNil 
						ifTrue: 
							[searchPathHeight = 1 
								ifTrue: 
									[nextKey := (ByteArray new: keyLength) atAllPut: 255.
									self clearSearchPath.
									^nil].
							page := self removeLastPage]
						ifFalse: 
							[
							[page := self loadPageAt: nextPagePosition.
							(nextPagePosition := page leftNext) = 0] 
									whileFalse: []]].
			association := page currentAssociation].
	nextKey := currentKey := association key.
	currentKeyExists := true.
	^association! !

!ODBBTreeIterator methodsFor: 'private' stamp: ''!
searchPreviousAssociation
	"Private - Search for the previous association. Answer <nil> if none."

	| page association pagePosition |
	page := self lastPage.
	[association isNil] whileTrue: 
			[(pagePosition := page previousPage) = 0 
				ifFalse: 
					[pagePosition isNil 
						ifTrue: 
							[searchPathHeight = 1 
								ifTrue: 
									[nextKey := ByteArray new: keyLength.
									self clearSearchPath.
									^nil].
							page := self removeLastPage]
						ifFalse: 
							[
							[page := self loadPageAt: pagePosition.
							(pagePosition := page rightNext) = 0] 
									whileFalse: []]].
			association := page previousAssociation].
	nextKey := currentKey := association key.
	currentKeyExists := true.
	^association! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
unlockCurrentWith: lockID 
	"Try to unlock currentKey with lockID. 
        Answer <true> if successfull."

	| fileLockID |
	self lockTree.
	
	[self loadCurrentKey.
	currentKeyExists ifFalse: [^true].
	fileLockID := self lastPage lockID.
	fileLockID == 0 ifTrue: [^true].
	fileLockID == lockID 
		ifTrue: 
			[(self lastPage)
				lockID: 0;
				storeItem.
			^true]] 
			ensure: [self unlockTree].
	^false! !

!ODBBTreeIterator methodsFor: 'private/locking' stamp: 'cdg 3/13/2003 18:06'!
unlockTree
        "Private - Unlock tree after it has been updated."

    self unlockAdding! !

!ODBBTreeIterator methodsFor: 'private' stamp: ''!
updateCurrentKey
	"Private - Check if iterator has been moved
        and update cache if it has been moved."

	| nextPagePosition |
	searchPathHeight = 0 
		ifTrue: 
			[currentKey := nextKey.
			currentKeyExists := false.
			^self searchCurrentKeyFrom: rootPagePosition].
	self isCurrentKeySet ifTrue: [^self].
	currentKey := nextKey.
	currentKeyExists := false.
	[searchPathHeight > 1] whileTrue: 
			[(nextPagePosition := (searchPath at: searchPathHeight) positionToCachedKey: currentKey) 
				== true 
					ifTrue: 
						[currentKeyExists := true.
						^self].
			nextPagePosition isNil 
				ifFalse: 
					[nextPagePosition = 0 ifTrue: [^self].
					^self searchCurrentKeyFrom: nextPagePosition].
			searchPath at: searchPathHeight put: nil.
			searchPathHeight := searchPathHeight - 1].
	(nextPagePosition := (searchPath at: 1) positionToKey: currentKey) == true 
		ifTrue: 
			[currentKeyExists := true.
			^self].
	nextPagePosition = 0 ifFalse: [self searchCurrentKeyFrom: nextPagePosition]! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
updateSizeAt: versionNumber oldHolders: oldHolders deltaSize: deltaSize 
	| oldHolder newHolder pos |
	pos := self headerLength.
	self waitForLockAt: pos length: ODBSizeHolder sizeInBytes.
	
	[oldHolder := (ODBSizeHolder new)
				loadFromStream: stream at: pos;
				yourself.
	oldHolders isNil 
		ifTrue: [newHolder := oldHolder]
		ifFalse: 
			[newHolder := oldHolder makeNewVersion: oldHolders.
			oldHolders flush].
	newHolder
		dictionarySize: oldHolder dictionarySize + deltaSize;
		versionNumber: versionNumber.
	newHolder storeOnStream: stream at: pos] 
			ensure: [self unlockAt: pos length: ODBSizeHolder sizeInBytes]! !

!ODBBTreeIterator methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
valueLength: anInteger

    valueLength := anInteger! !

!ODBBTreeIterator methodsFor: 'public' stamp: ''!
value: key1 value: key2 
	"Answer <true> if key1 is less or equal to key2. 
	Receiver can be used as sortBlock for SortedCollection."

	| s1 s2 a1 a2 |
	s1 := key1 size.
	s2 := key2 size.
	1 to: keyLength
		do: 
			[:i | 
			i > s1 ifTrue: [a1 := 0] ifFalse: [a1 := key1 at: i].
			i > s2 ifTrue: [a2 := 0] ifFalse: [a2 := key2 at: i].
			a1 = a2 ifFalse: [^a1 < a2]].
	^true! !

!ODBBTreeIterator methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
version

    ^version! !

!ODBBTreeIterator methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:06'!
version: anObject

    version := anObject! !

ODBBTreeIterator subclass: #ODBClassInfoFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBClassInfoFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
created
                "Private - File has just been created."

        (self pageClass createOnFile: self
                                        position: rootPagePosition
                                        keyLength: keyLength
                                        valueLength: valueLength) store.
        currentKey := ByteArray new: keyLength.
        stream flush! !

!ODBClassInfoFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'Class Info File
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBClassInfoFile methodsFor: 'public' stamp: ''!
initialize
	"Private - Initialize receiver."

	super initialize.
	keyLength := 128.
	valueLength := 4.
	rootPagePosition := self headerLength! !

!ODBClassInfoFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
opened! !

ODBBTreeIterator subclass: #ODBContainerInfoFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBContainerInfoFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
created
                "Private - File has just been created."

        stream putWord: 0.
        (self pageClass createOnFile: self
                                        position: rootPagePosition
                                        keyLength: keyLength
                                        valueLength: valueLength) store.
        currentKey := ByteArray new: keyLength.
        stream flush! !

!ODBContainerInfoFile methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
defaultObjectSpace

        ^stream position: self headerLength; getByte! !

!ODBContainerInfoFile methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
defaultObjectSpace: anInteger

	stream position: self headerLength; putByte: anInteger! !

!ODBContainerInfoFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'Container Info File
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBContainerInfoFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
initialize
        "Private - Initialize receiver."

    super initialize.
    keyLength := 20.
    valueLength := 4.
    rootPagePosition := self headerLength + 2! !

!ODBContainerInfoFile methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
isLocked

        ^(stream position: self headerLength + 1; getByte) == 1! !

!ODBContainerInfoFile methodsFor: 'public' stamp: ''!
lock
	| pos |
	pos := self headerLength + 1.
	self waitForLockAt: pos length: 1.
	
	[(stream
		position: pos;
		getByte) == 0 
		ifFalse: [^false]
		ifTrue: 
			[stream
				position: pos;
				putByte: 1.
			^true]] 
			ensure: [self unlockAt: pos length: 1]! !

!ODBContainerInfoFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
opened! !

!ODBContainerInfoFile methodsFor: 'public' stamp: ''!
unlock
	| pos |
	pos := self headerLength + 1.
	self waitForLockAt: pos length: 1.
	
	[(stream
		position: pos;
		getByte) == 1 
		ifFalse: [^false]
		ifTrue: 
			[stream
				position: pos;
				putByte: 0.
			^true]] 
			ensure: [self unlockAt: pos length: 1]! !

ODBBTreeIterator subclass: #ODBGcBTreeIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBGcBTreeIterator methodsFor: 'private' stamp: ''!
insertValue: aValue lockID: lockID 
	"Private - Insert aValue and lockID at currentKey. 
	Precondition: search path to currentKey is loaded and 
	currentKey does not exists."

	| page pageSplit |
	page := searchPath at: searchPathHeight.
	pageSplit := page 
				insertKey: currentKey
				value: aValue
				lockID: lockID.
	pageSplit isNil 
		ifTrue: [currentKeyExists := true]
		ifFalse: 
			[
			[searchPathHeight > 1 
				ifTrue: 
					[(pageSplit at: 1)
						position: page position;
						store.
					(pageSplit at: 3)
						position: stream setToEnd;
						store]
				ifFalse: 
					[(pageSplit at: 1)
						position: stream setToEnd;
						store.
					(pageSplit at: 3)
						position: stream position;
						store].
			searchPath at: searchPathHeight put: nil.
			searchPathHeight := searchPathHeight - 1.
			searchPathHeight == 0 
				ifFalse: [page := searchPath at: searchPathHeight]
				ifTrue: 
					[page := self pageClass 
								createOnFile: self
								position: rootPagePosition
								keyLength: keyLength
								valueLength: valueLength].
			pageSplit := page insertPageSplit: pageSplit.
			pageSplit isNil] 
					whileFalse: [].
			self clearSearchPath].
	page store! !

!ODBGcBTreeIterator methodsFor: 'public' stamp: ''!
pageClass
	"Private - Answer B-Tree page class."

	^ODBGcBTreePage! !

!ODBGcBTreeIterator methodsFor: 'public' stamp: ''!
put: aValue 
	self updateCurrentKey.
	currentKeyExists 
		ifTrue: 
			[(self lastPage)
				value: aValue;
				store]
		ifFalse: [self insertValue: aValue lockID: 0]! !

ODBFile subclass: #ODBClientFile
	instanceVariableNames: 'transactions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBClientFile methodsFor: 'public' stamp: ''!
clientDescription
	"Answer client description string."

	| str |
	str := String new: 128.
	stream atPosition: self headerLength getBytesFor: str.
	^(ReadStream on: str) upTo: 0 asCharacter! !

!ODBClientFile methodsFor: 'public' stamp: ''!
clientDescription: aString 
	"Set client description string."

	stream 
		atPosition: self headerLength
		putBytesFrom: ((String new: 128) 
				replaceFrom: 1
				to: (aString size min: 128)
				with: aString
				startingAt: 1)
		len: 128! !

!ODBClientFile methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:06'!
created
                "Private - Put default values into file."

        "client description = 128 bytes"
        "distributed objects hostname=32 bytes"
        "transactions count = 4 bytes"
        stream putBytesFrom: (ByteArray new: 164); flush! !

!ODBClientFile methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
createOn: aString
        "Create client file. Signal an error if failed."

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeCreateNew
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareRead.
    ^self writeHeader! !

!ODBClientFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'OmniBase Client File
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBClientFile methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
openOn: aString
        "Open client file. Signal an error if failed."

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeOpenExisting
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareRead.
    ^self compareHeader! !

!ODBClientFile methodsFor: 'public' stamp: ''!
transactionIDs
	"Answer array of transaction IDs."

	| buf array count |
	buf := ByteArray new: 128.
	stream
		position: self headerLength + 160;
		getBytesFor: buf.
	count := buf odbLongAt: 1.
	array := Array new: count.
	1 to: (count min: 31) do: [:i | array at: i put: (buf odbLongAt: (i * 4) + 1)].
	count > 31 
		ifTrue: 
			[buf := ByteArray new: (count - 31) * 4.
			stream getBytesFor: buf.
			32 to: count do: [:i | array at: i put: (buf odbLongAt: (i * 4) - 127)]].
	^array! !

!ODBClientFile methodsFor: 'public' stamp: ''!
transactionIDs: anArray 
	"Set array of transaction IDs."

	| buf count |
	count := anArray size.
	buf := ByteArray new: count * 4 + 4.
	buf odbLongAt: 1 put: count.
	1 to: count do: [:i | buf odbLongAt: (i * 4) + 1 put: (anArray at: i)].
	stream
		position: self headerLength + 160;
		putBytesFrom: buf;
		flush! !

ODBFile subclass: #ODBClientTable
	instanceVariableNames: 'table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBClientTable class methodsFor: 'public' stamp: ''!
maxClients
	"Answer maximum number of clients connected to database. 
	Valid numbers are from 1 to 255."

	^64! !

!ODBClientTable methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
activateClientID: clientID
        "Mark clientID as active."

    self clientTableAt: clientID lockAndPut: 1! !

!ODBClientTable methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
clientTableAt: index
                "Private - Answer value at client table index."

        ^table at: index + 1! !

!ODBClientTable methodsFor: 'public' stamp: ''!
clientTableAt: index lockAndPut: value 
	"Private - Put value at client table index."

	self waitForLockAt: self headerLength + index length: 1.
	[self clientTableAt: index put: value] 
		ensure: [self unlockAt: self headerLength + index length: 1]! !

!ODBClientTable methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
clientTableAt: index put: value
                "Private - Put value at client table index."

        stream position: self headerLength + index; putByte: value! !

!ODBClientTable methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
created
                "Private - Put default values into file."

        "client table"
        stream putBytesFrom: (ByteArray new: 258); flush! !

!ODBClientTable methodsFor: 'defining' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'OmniBase Client Table
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBClientTable methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
globalLockClientID
                "Private - Answer clientID of client that has set global lock."

        ^table at: 1! !

!ODBClientTable methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
globalLockClientID: clientID
                "Private - Write clientID of client that has put global lock."

        stream position: self headerLength; putByte: clientID! !

!ODBClientTable methodsFor: 'public' stamp: ''!
globalUnlock
	self lockTable.
	[self globalLockClientID: 0] ensure: [self unlockTable]! !

!ODBClientTable methodsFor: 'public' stamp: ''!
initialize
	table := ByteArray new: self class maxClients + 1! !

!ODBClientTable methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
isBeingRemoved: clientID
        "Answer <true> if clientID is being removed."

    ^(self clientTableAt: clientID) == 2! !

!ODBClientTable methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
loadTable
                "Private - Load client table from file."

        stream atPosition: self headerLength getBytesFor: table! !

!ODBClientTable methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
lockTable
                "Private - Lock client table from being changed."

	self waitForLockAt: self headerLength length: table size! !

!ODBClientTable methodsFor: 'public' stamp: ''!
onClientIDsDo: aBlock 
	"Evaluate aBlock on every active or disconnected clientID."

	self loadTable.
	1 to: self class maxClients
		do: [:i | (self clientTableAt: i) == 0 ifFalse: [aBlock value: i]]! !

!ODBClientTable methodsFor: 'public' stamp: ''!
onNewClientIDDo: aBlock 
	"Evaluate aBlock with new clientID.
	aBlock will not be evaluated if no clientID is avaiable."

	self lockTable.
	
	[self loadTable.
	1 to: self class maxClients
		do: 
			[:i | 
			(self clientTableAt: i) == 0 
				ifTrue: 
					[self clientTableAt: i put: 2.
					stream flush.
					aBlock value: i.
					self clientTableAt: i put: 1.
					^self]]] 
			ensure: [self unlockTable]! !

!ODBClientTable methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
removeClientID: clientID
        "Remove clientID."

    self clientTableAt: clientID lockAndPut: 0! !

!ODBClientTable methodsFor: 'public' stamp: ''!
removingClientID: clientID 
	"Client clientID is being removed."

	self lockTable.
	
	[self loadTable.
	self globalLockClientID == clientID ifTrue: [self globalLockClientID: 0].
	(self clientTableAt: clientID) > 0 ifTrue: [self clientTableAt: clientID put: 2]] 
			ensure: [self unlockTable]! !

!ODBClientTable methodsFor: 'public' stamp: ''!
requestLockForClientID: clientID 
	"If global lock has not been set yet, mark that 
	clientID has requested transaction file to store locks. 
	Answer <true> if client can lock objects or <false> if not."

	self lockTable.
	
	[self loadTable.
	self globalLockClientID == 0 ifFalse: [^false].
	self clientTableAt: clientID put: 10.
	^true] 
			ensure: [self unlockTable]! !

!ODBClientTable methodsFor: 'public' stamp: ''!
setGlobalLockFor: clientID 
	"Try to global lock database. Answer <true> if successfull."

	self lockTable.
	
	[self loadTable.
	self globalLockClientID == 0 ifFalse: [^false].
	1 to: self class maxClients do: [:i | (self clientTableAt: i) == 10 ifTrue: [^false]].
	self globalLockClientID: clientID.
	^true] 
			ensure: [self unlockTable]! !

!ODBClientTable methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
unlockTable
                "Private - Unlock client table."

	self unlockAt: self headerLength length: table size! !

!ODBFile class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
createOn: aString

    ^self new createOn: aString! !

!ODBFile class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new initialize! !

!ODBFile class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
openOn: aString

    ^self new openOn: aString! !

!ODBFile methodsFor: 'create/open/close' stamp: 'cdg 3/13/2003 18:05'!
close
        "Close stream associated with receiver."

    stream isNil ifFalse: [
        stream close.
        stream := nil]! !

!ODBFile methodsFor: 'public' stamp: ''!
compareHeader
	"Private - Compare bytes in file with file header. Answer <nil>, 
	if the file does not have the appropriate description string."

	| header |
	header := self header.
	
	[(stream compare: (header copyFrom: 2 to: header size) at: 1) 
		ifFalse: [OmniBase signalError: 'File has bad header'].
	self opened] 
			ifCurtailed: [self close]! !

!ODBFile methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
created
                "Private - Implemented by subclasses."

        stream flush! !

!ODBFile methodsFor: 'create/open/close' stamp: 'cdg 3/13/2003 18:05'!
createOn: aString

    stream := ODBFileStream createOn: aString.
    ^self writeHeader! !

!ODBFile methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
descriptionString

    ^'OmniBase File
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBFile methodsFor: 'finalization' stamp: 'cdg 3/13/2003 18:05'!
finalize

    self close! !

!ODBFile methodsFor: 'locking' stamp: 'cdg 3/13/2003 18:05'!
flush
        "Flush stream."

    stream flush! !

!ODBFile methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
header
        "Private - Answer receiver's header."

	| header desc |
	header := String new: self headerLength.
	desc := self descriptionString.
	header replaceFrom: 1
		to: desc size
		with: desc
		startingAt: 1.
	^header! !

!ODBFile methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
headerLength
        "Private - Answer receiver's header length."

	^128! !

!ODBFile methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
initialize! !

!ODBFile methodsFor: 'create/open/close' stamp: 'cdg 3/13/2003 18:05'!
openExclusivelyOn: aString

	stream := ODBFileStream openExclusivelyOn: aString.
	^self compareHeader! !

!ODBFile methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
opened
        "Private - Implemented by subclasses."! !

!ODBFile methodsFor: 'create/open/close' stamp: 'cdg 3/13/2003 18:05'!
openOn: aString

    stream := ODBFileStream openOn: aString.
    ^self compareHeader! !

!ODBFile methodsFor: 'create/open/close' stamp: 'cdg 3/13/2003 18:05'!
openReadOnlyOn: aString

    stream := ODBFileStream openReadOnlyOn: aString.
    ^self compareHeader! !

!ODBFile methodsFor: 'create/open/close' stamp: 'cdg 3/13/2003 18:05'!
remove
        "Close and remove file coressponding to receiver. 
        Answer <true> if successfull."

    | answer |
    answer := stream remove.
    stream := nil.
    ^answer! !

!ODBFile methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
stream

    ^stream! !

!ODBFile methodsFor: 'public' stamp: ''!
timeOutLength
	"Private - Answer number of seconds to wait for lock."

	^7! !

!ODBFile methodsFor: 'locking' stamp: 'cdg 3/13/2003 18:05'!
unlockAdding
        "Unlock file for writing at the end of file."

    ^stream unlockAt: 0 length: 1! !

!ODBFile methodsFor: 'locking' stamp: 'cdg 3/13/2003 18:05'!
unlockAt: pos length: length
        "Unlock file at pos."

    ^stream unlockAt: pos length: length! !

!ODBFile methodsFor: 'public' stamp: ''!
waitForAddingLock
	"Lock file for writing at the end of the file."

	^self 
		waitForLockAt: 0
		length: 1
		whileWaitingDo: [(Delay forMilliseconds: 250) wait]! !

!ODBFile methodsFor: 'locking' stamp: 'cdg 3/13/2003 18:05'!
waitForAddingLockWhileWaitingDo: aBlock
        "Lock file for writing at the end of the file."

    ^self waitForLockAt: 0 length: 1 whileWaitingDo: aBlock! !

!ODBFile methodsFor: 'public' stamp: ''!
waitForLockAt: pos length: length 
	"Wait for lock at given position."

	^self 
		waitForLockAt: pos
		length: length
		whileWaitingDo: [(Delay forMilliseconds: 250) wait]! !

!ODBFile methodsFor: 'locking' stamp: 'ac 1/9/2004 12:39'!
waitForLockAt: pos length: length whileWaitingDo: aBlock
		"Wait for lock at given position. 
		Evaluate aBlock in each iteration."

	| startTime currentTime |
	(stream lockAt: pos length: length) ifFalse: [
		startTime := Time totalSeconds.
		[stream lockAt: pos length: length] whileFalse: [
			aBlock value.
			currentTime := Time totalSeconds.
			currentTime - startTime < self timeOutLength
				ifFalse: [
					ODBLockNotification signal
						ifTrue: [startTime := currentTime]
						ifFalse: [^ODBCannotLock signal]]]]! !

!ODBFile methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
writeHeader
                "Private - Write file header to file and send #created to self."

        stream putBytesFrom: self header.
        ^self created! !

ODBFile subclass: #ODBGarbageCollectorFile
	instanceVariableNames: 'status'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBGarbageCollectorFile methodsFor: 'public' stamp: ''!
created
	"status=1 byte"

	"new object space=1 byte"

	stream
		putBytesFrom: (ByteArray new: 4);
		flush! !

!ODBGarbageCollectorFile methodsFor: 'public' stamp: ''!
createOn: aString 
	"Create garbage collector file. Answer <nil> if failed."

	stream := ODBFileStream 
				createOn: aString
				createMode: ODBFileStream createModeCreateNew
				accessMode: ODBFileStream accessModeReadWrite
				shareMode: ODBFileStream shareModeShareRead.
	^self writeHeader! !

!ODBGarbageCollectorFile methodsFor: 'public' stamp: ''!
newObjectSpace
	"Answer garbage collector new object space."

	^stream
		position: self headerLength + 1;
		getByte! !

!ODBGarbageCollectorFile methodsFor: 'public' stamp: ''!
newObjectSpace: anInteger 
	"Set garbage collector new object space."

	stream
		position: self headerLength + 1;
		putByte: anInteger;
		flush! !

!ODBGarbageCollectorFile methodsFor: 'public' stamp: ''!
openOn: aString 
	"Open garbage collector file. Signal an error if failed."

	stream := ODBFileStream 
				createOn: aString
				createMode: ODBFileStream createModeOpenExisting
				accessMode: ODBFileStream accessModeReadWrite
				shareMode: ODBFileStream shareModeShareRead.
	^self compareHeader! !

!ODBGarbageCollectorFile methodsFor: 'public' stamp: ''!
status
	"Answer garbage collector status."

	status isNil 
		ifTrue: 
			[status := stream
						position: self headerLength;
						getByte].
	^status! !

!ODBGarbageCollectorFile methodsFor: 'public' stamp: ''!
status: anInteger 
	"Set garbage collector status."

	status := anInteger.
	stream
		position: self headerLength;
		putByte: anInteger;
		flush! !

ODBFile subclass: #ODBIDTable
	instanceVariableNames: 'lastID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBIDTable methodsFor: 'public' stamp: ''!
add: anInteger 
	"Store anInteger and answer its ID."

	lastID := self getLastID + 1.
	stream
		atPosition: lastID * 4 + self headerLength putLong: anInteger;
		atPosition: self headerLength putLong: lastID.
	^lastID! !

!ODBIDTable methodsFor: 'public' stamp: ''!
at: anInteger 
	"Answer <position> at anInteger or <nil> if absent."

	anInteger > lastID ifTrue: [anInteger > self getLastID ifTrue: [^nil]].
	^stream atPositionGetLong: anInteger * 4 + self headerLength! !

!ODBIDTable methodsFor: 'public' stamp: ''!
at: anInteger ifAbsent: aBlock 
	"Answer <position> at anInteger. Evaluate aBlock if absent."

	anInteger > lastID ifTrue: [anInteger > self getLastID ifTrue: [^aBlock value]].
	^stream atPositionGetLong: anInteger * 4 + self headerLength! !

!ODBIDTable methodsFor: 'public' stamp: ''!
at: anInteger put: aPosition 
	"Put aPosition at anInteger."

	^stream atPosition: anInteger * 4 + self headerLength putLong: aPosition! !

!ODBIDTable methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:06'!
created
                "Private - Initialize lastID count."

        stream putLong: 0; flush! !

!ODBIDTable methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'OmniBase ID Table
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBIDTable methodsFor: 'public' stamp: ''!
getLastID
	"Answer value of last ID in file."

	^lastID := stream atPositionGetLong: self headerLength! !

!ODBIDTable methodsFor: 'public' stamp: ''!
indexesAndValuesDo: aBlock 
	1 to: self getLastID do: [:index | aBlock value: index value: (self at: index)]! !

!ODBIDTable methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
initialize

    lastID := 0! !

ODBFile subclass: #ODBIntegerSet
	instanceVariableNames: 'bitField currentPage changed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBIntegerSet methodsFor: 'public' stamp: ''!
add: anInteger 
	| pageNumber i j |
	pageNumber := anInteger bitShift: -15.	"-12-3=-15"
	i := ((anInteger bitAnd: 32767) bitShift: -3) + 1.	"8*4096=32768"
	j := 1 bitShift: (anInteger bitAnd: 7).
	self loadPage: pageNumber.
	((bitField at: i) bitAnd: j) == 0 
		ifTrue: 
			[changed := true.
			bitField at: i put: ((bitField at: i) bitOr: j)]! !

!ODBIntegerSet methodsFor: 'public' stamp: ''!
close
	"Close stream associated with receiver."

	stream isNil 
		ifFalse: 
			[(changed and: [currentPage ~~ nil]) 
				ifTrue: 
					[stream
						position: (currentPage bitShift: 12) + self headerLength;
						putBytesFrom: bitField len: 4096	"2^12=4096"]].
	^super close! !

!ODBIntegerSet methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
includes: anInteger

	| pageNumber i j |
	pageNumber := anInteger bitShift: -15. "-12-3=-15"
	i := ((anInteger bitAnd: 32767) bitShift: -3) + 1. "4096*8=32768"
	j := 1 bitShift: (anInteger bitAnd: 7).
	self loadPage: pageNumber.
	^((bitField at: i) bitAnd: j) == j! !

!ODBIntegerSet methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
initialize

    bitField := ByteArray new: 4096.
    changed := false.! !

!ODBIntegerSet methodsFor: 'public' stamp: ''!
loadPage: pageNumber 
	"Private - Check if page pageNumber is loaded. If not, 
	store current page to disk and load page pageNumber."

	| pagePos |
	pageNumber == currentPage ifTrue: [^self].
	changed 
		ifTrue: 
			[stream 
				atPosition: (currentPage bitShift: 12) + self headerLength
				putBytesFrom: bitField
				len: 4096].
	changed := false.
	(pagePos := (pageNumber bitShift: 12) + self headerLength) < stream size 
		ifTrue: 
			[stream 
				atPosition: pagePos
				getBytesFor: bitField
				len: 4096]
		ifFalse: 
			[1 to: bitField size do: [:i | bitField at: i put: 0].
			
			[stream 
				atPosition: stream size
				putBytesFrom: bitField
				len: 4096.
			pagePos > stream size] 
					whileTrue: []].
	currentPage := pageNumber! !

ODBFile subclass: #ODBObjectIdStack
	instanceVariableNames: 'cache top filePos valueSize bottom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBObjectIdStack methodsFor: 'public' stamp: ''!
add: objectID 
	| oid index pos |
	top > self doubleCacheSize ifTrue: [self makeSpace].
	pos := top.
	top := top + 1.
	pos > self cacheSize ifTrue: [^(cache at: 2) at: pos - self cacheSize put: objectID].
	(cache at: 1) at: pos put: objectID! !

!ODBObjectIdStack methodsFor: 'defining' stamp: 'cdg 3/13/2003 18:06'!
cacheSize

	^5000! !

!ODBObjectIdStack methodsFor: 'defining' stamp: 'cdg 3/13/2003 18:06'!
doubleCacheSize

	^10000! !

!ODBObjectIdStack methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:06'!
initialize

	cache := Array
		with: (Array new: self cacheSize)
		with: (Array new: self cacheSize).
	top := 1.
	bottom := 1.
	filePos := self headerLength.
	valueSize := ODBObjectID sizeInBytes.! !

!ODBObjectIdStack methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
isEmpty

	^top == bottom and: [filePos == self headerLength]! !

!ODBObjectIdStack methodsFor: 'public' stamp: ''!
loadPage
	| count buf pos subCache |
	count := self cacheSize.
	buf := ByteArray new: count * valueSize.
	stream
		position: filePos - buf size;
		getBytesFor: buf.
	pos := 1.
	subCache := cache at: 1.
	1 to: count
		do: 
			[:i | 
			subCache at: i put: (ODBObjectID new fromBytes: buf at: pos).
			pos := pos + valueSize].
	filePos := filePos - buf size.
	top := count + 1.
	bottom := 1! !

!ODBObjectIdStack methodsFor: 'public' stamp: ''!
makeSpace
	"Private - Make space on stack."

	| cache1 pos |
	bottom == 1 ifTrue: [^self storePage].
	cache1 := cache at: 1.
	cache
		at: 1 put: (cache at: 2);
		at: 2 put: cache1.
	bottom > self cacheSize 
		ifTrue: 
			[top := top - self cacheSize.
			bottom := bottom - self cacheSize.
			^self].
	pos := bottom - 1.
	bottom := 1.
	top := top - pos.
	1 to: top - 1 - self cacheSize do: [:i | cache1 at: i put: (cache1 at: i + pos)]! !

!ODBObjectIdStack methodsFor: 'public' stamp: ''!
removeLast
	top == bottom ifTrue: [self loadPage].
	bottom > self cacheSize ifTrue: [^self removeLastCache2].
	^self removeLastCache1! !

!ODBObjectIdStack methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
removeLastCache1

	| cache1 result |
	cache1 := cache at: 1.
	result := cache1 at: bottom.
	cache1 at: bottom put: nil.
	bottom := bottom + 1.
	^result! !

!ODBObjectIdStack methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
removeLastCache2

	| cache2 result |
	cache2 := cache at: 2.
	result := cache2 at: bottom - self cacheSize.
	cache2 at: bottom - self cacheSize put: nil.
	bottom := bottom + 1.
	^result! !

!ODBObjectIdStack methodsFor: 'public' stamp: ''!
storePage
	| count buf pos subCache |
	count := self cacheSize.
	buf := ByteArray new: count * valueSize.
	pos := 1.
	subCache := cache at: 1.
	1 to: count
		do: 
			[:i | 
			(subCache at: i) putBytesTo: buf at: pos.
			subCache at: i put: nil.
			pos := pos + valueSize].
	stream
		position: filePos;
		putBytesFrom: buf.
	filePos := filePos + buf size.
	cache
		at: 1 put: (cache at: 2);
		at: 2 put: subCache.	"swap halves"
	top := count + 1.
	bottom := 1! !

ODBFile subclass: #ODBObjectIndexFile
	instanceVariableNames: 'valueLength pageSize start gcPosition gcBuffer gcCount var1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
addHolders: holders 
	"Add object holders to table and initialize their object ID indexes."

	| lastIndex freeHolders count count2 buffer holder |
	count := holders size.
	count2 := 0.
	buffer := ByteArray new: 8.
	self waitForAddingLock.
	
	[stream 
		atPosition: self headerLength + 4
		getBytesFor: buffer
		len: 8.
	lastIndex := buffer odbLongAt: 1.
	"       (freeHolders := buffer odLongAt: 5) == 0 ifFalse: [
            count2 := count min: freeHolders.
            count := count - count2.
            stream position: self headerLength + 8; putLong: freeHolders - count2; flush.
            buffer := ByteArray new: count2 * 4.
            bufPos := lastIndex * valueLength + start + (freeHolders - count2 * 4).
            stream position: bufPos; getBytesFor: buffer; truncate: bufPos.
            1 to: count2 do: [:i |
                holder := holders at: i.
                bufPos := buffer odLongAt: (i * 4 - 3).
                holder objectID index: bufPos."
	"               self at: bufPos put: holder contents"
	"           ].
            stream flush
        ].
        count == 0 ifTrue: [ ^self ]."
	stream atPosition: self headerLength + 4 putLong: lastIndex + count] 
			ensure: [self unlockAdding].
	buffer := ByteArray new: count * valueLength.
	count2 + 1 to: holders size
		do: 
			[:i | 
			holder := holders at: i.
			lastIndex := lastIndex + 1.
			holder objectID index: lastIndex
			"       buffer replaceFrom: bufPos to: bufPos + valueLength - 1 with: holder contents startingAt: 1.
        bufPos := bufPos + valueLength"].
	stream
		atPosition: lastIndex * valueLength + start putBytesFrom: buffer;
		flush! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
at: anInteger 
	"Answer bytes at index anInteger, <nil> if none."

	| bytes |
	anInteger < 1 ifTrue: [OmniBase signalError: 'Invalid object ID'].
	bytes := ByteArray new: valueLength.
	(stream 
		atPosition: (anInteger - 1) * valueLength + start
		getBytesFor: bytes
		len: valueLength) == valueLength 
		ifFalse: [^nil].
	"   (bytes at: 1) == 0 ifFalse: [ ^bytes ].
    (bytes at: 2) == 0 ifFalse: [ ^bytes ].
    (bytes at: 3) == 0 ifFalse: [ ^bytes ].
    (bytes at: 4) == 0 ifFalse: [ ^bytes ]."
	(bytes at: 9) == 0 ifFalse: [^bytes].
	^nil! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
at: anInteger put: value 
	"Put value at anInteger."

	anInteger < 1 ifTrue: [OmniBase signalError: 'Invalid object ID'].
	stream 
		atPosition: (anInteger - 1) * valueLength + start
		putBytesFrom: value
		len: valueLength! !

!ODBObjectIndexFile methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
created

        stream putBytesFrom: (ByteArray new: 16); flush! !

!ODBObjectIndexFile methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:05'!
createOn: aString

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeCreateNew
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareAll
                            cacheMode: ODBFileStream cacheModeAtomicWrite.
    ^self writeHeader! !

!ODBObjectIndexFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:05'!
descriptionString

    ^'OmniBase Object Index File
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
flushGCBuffer
	stream 
		atPosition: gcPosition
		putBytesFrom: gcBuffer
		len: ((gcCount - 1) \\ 256 + 1) * 4.
	gcPosition := stream position.
	stream
		truncate: gcPosition;
		flush;
		atPosition: self headerLength + 8 putLong: gcCount;
		flush! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
getLastIndex
	"Private - Answer index of last object holder."

	^stream atPositionGetLong: self headerLength + 4! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
indexesAndValuesDo: aBlock 
	| lastIndex buffer bufSize bufPos value |
	buffer := ByteArray new: 400 * valueLength.
	lastIndex := self getLastIndex.
	
	[gcCount := 0.
	gcPosition := lastIndex * valueLength + start.
	gcBuffer := ByteArray new: 1024.
	bufSize := stream
				position: start;
				getBytesFor: buffer.
	bufPos := 1.
	1 to: lastIndex
		do: 
			[:index | 
			value := buffer copyFrom: bufPos to: bufPos + valueLength - 1.
			(value at: 9) == 0 ifFalse: [aBlock value: index value: value].
			bufPos := bufPos + valueLength.
			bufPos >= bufSize 
				ifTrue: 
					[stream position: index * valueLength + start.
					bufSize := stream getBytesFor: buffer.
					bufPos := 1]].
	gcCount \\ 256 = 0 ifFalse: [self flushGCBuffer]] 
			ensure: 
				[gcCount := nil.
				gcBuffer := nil]! !

!ODBObjectIndexFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:05'!
initialize

    start := self headerLength + 16.
    valueLength := ODBObjectHolder sizeInBytes! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
lock: index 
	"Lock <value> at index."

	self waitForLockAt: (index - 1) * valueLength + start length: valueLength! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
newObjectFileID
	"Get new ID for object file. Thread-safe."

	| newID |
	self waitForLockAt: self headerLength length: 4.
	
	[newID := (stream atPositionGetLong: self headerLength) + 1.
	stream atPosition: self headerLength putLong: newID] 
			ensure: [self unlockAt: self headerLength length: 4].
	^newID! !

!ODBObjectIndexFile methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:05'!
openOn: aString
        "Open transaction file. Signal an error if failed."

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeOpenExisting
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareAll
                            cacheMode: ODBFileStream cacheModeAtomicWrite.
    ^self compareHeader! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
removeIndex: index 
	self at: index put: (ByteArray new: valueLength).
	gcCount isNil 
		ifFalse: 
			[gcBuffer odbLongAt: ((gcCount \\ 256) * 4) + 1 put: index.
			gcCount := gcCount + 1.
			gcCount \\ 256 = 0 ifTrue: [self flushGCBuffer]]! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
setLastIndex: anInteger 
	"Private - Answer set index of last object holder."

	^stream atPosition: self headerLength + 4 putLong: anInteger! !

!ODBObjectIndexFile methodsFor: 'public' stamp: ''!
unlock: index 
	"Unlock  <value> at index."

	self unlockAt: (index - 1) * valueLength + start length: valueLength! !

ODBFile subclass: #ODBObjectStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBObjectStorage methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'OmniBase Object Storage
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBObjectStorage methodsFor: 'public' stamp: ''!
isEmpty
	^stream size == self headerLength! !

!ODBObjectStorage methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
removeAll

	stream truncate: self headerLength! !

ODBFile subclass: #ODBOldHoldersFile
	instanceVariableNames: 'buffer bufPos filePos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBOldHoldersFile methodsFor: 'public' stamp: ''!
allocateBuffer
	"Private - Allocate space in file for buffer so that less locking 
	and file I/O calls are needed when transaction is committing."

	self waitForAddingLock.
	
	[filePos := stream setToEnd.
	stream truncate: filePos + 512] ensure: [self unlockAdding].
	buffer := ByteArray new: 512.
	bufPos := 0! !

!ODBOldHoldersFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'OmniBase Old Holders
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBOldHoldersFile methodsFor: 'public' stamp: ''!
flush
	(buffer isNil or: [bufPos == 0]) ifTrue: [^self].
	stream 
		atPosition: filePos
		putBytesFrom: buffer
		len: bufPos.
	buffer size - bufPos < 16 
		ifTrue: [buffer := nil]
		ifFalse: 
			[filePos := filePos + bufPos.
			buffer := buffer copyFrom: bufPos + 1 to: buffer size.
			bufPos := 0]! !

!ODBOldHoldersFile methodsFor: 'public' stamp: ''!
loadAt: anInteger for: aByteArray 
	"Load holder contents at position anInteger."

	anInteger == 0 ifTrue: [OmniBase signalError: 'Previous version position error !!'].
	stream atPosition: anInteger getBytesFor: aByteArray! !

!ODBOldHoldersFile methodsFor: 'public' stamp: ''!
store: aByteArray 
	"Store holder contents and answer its position on the stream."

	| result |
	buffer isNil 
		ifTrue: [self allocateBuffer]
		ifFalse: 
			[buffer size - bufPos < aByteArray size 
				ifTrue: 
					[self
						flush;
						allocateBuffer]].
	buffer 
		replaceFrom: bufPos + 1
		to: bufPos + aByteArray size
		with: aByteArray
		startingAt: 1.
	result := filePos + bufPos.
	bufPos := bufPos + aByteArray size.
	^result! !

!ODBOldHoldersFile methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:06'!
truncate

	stream truncate: self headerLength! !

ODBFile subclass: #ODBTransactionFile
	instanceVariableNames: 'locks transactionID lockPositions recovery newLockPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBTransactionFile methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:06'!
collectLockClassIDsFrom: rootClass to: aDictionary
                "Private - Collect all lock classIDs and store them to aDictionary."

        rootClass lockClassID notNil
                ifTrue: [aDictionary at: rootClass lockClassID put: rootClass].
        rootClass subclasses do: [:each | self collectLockClassIDsFrom: each to: aDictionary]! !

!ODBTransactionFile methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:06'!
created

        stream putBytesFrom: (ByteArray new: 11); flush.
        newLockPosition := self headerLength + 10.! !

!ODBTransactionFile methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
createOn: aString

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeCreateAlways
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareRead
                            cacheMode: ODBFileStream cacheModeAtomicWrite.
    ^self writeHeader! !

!ODBTransactionFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'OmniBase Transaction Log File
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBTransactionFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
initialize

    locks := OrderedCollection new.
    lockPositions := OrderedCollection new! !

!ODBTransactionFile methodsFor: 'public' stamp: ''!
lockAdd: anODBLock 
	"Add lock to transaction file."

	| mStream bytes |
	recovery isNil ifFalse: [OmniBase signalError: 'Can not lock in the middle of commit'].
	anODBLock lockIndex isNil ifFalse: [OmniBase signalError: 'Lock is allready stored'].
	locks add: anODBLock.
	lockPositions add: newLockPosition.
	anODBLock lockIndex: locks size.
	(mStream := ODBMemoryWriteStream new) putByte: 0.
	anODBLock storeOnStream: mStream.
	mStream putByte: 0.
	stream
		position: newLockPosition;
		putBytesFrom: (bytes := mStream asByteArray);
		position: newLockPosition;
		putByte: anODBLock class lockClassID.
	stream flush.
	newLockPosition := newLockPosition + bytes size - 1! !

!ODBTransactionFile methodsFor: 'public' stamp: ''!
lockRemove: anODBLock 
	"Remove lock from transaction file."

	| i |
	(i := anODBLock lockIndex) isNil 
		ifTrue: [OmniBase signalError: 'Lock has not been stored yet'].
	locks at: i put: nil.
	stream position: (lockPositions at: i).
	stream putByte: 100 + anODBLock class lockClassID.
	anODBLock lockIndex: nil.
	stream flush! !

!ODBTransactionFile methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
locks
        "Answer all locks stored in transaction file."

    ^locks select: [:each | each notNil]! !

!ODBTransactionFile methodsFor: 'public' stamp: ''!
opened
	"Private - Load all stored locks and recovery information."

	"collect lock classes class IDs"

	| classes storedID classID obj startingPosition |
	classes := IdentityDictionary new.
	self collectLockClassIDsFrom: ODBLock to: classes.
	"load locks first"
	locks := OrderedCollection new.
	lockPositions := OrderedCollection new.
	stream position: self headerLength + 10.
	
	[startingPosition := stream position.
	(storedID := stream getByte) == 0] whileFalse: 
				[storedID > 100 ifTrue: [classID := storedID - 100] ifFalse: [classID := storedID].	"removed locks have classID > 100"
				obj := (classes at: classID ifAbsent: [OmniBase signalError: 'Unknown lock classID']) new 
							loadFromStream: stream.
				storedID > 100 
					ifFalse: 
						["if lock is still active"
						locks add: obj.
						obj lockIndex: locks size.
						lockPositions add: startingPosition]].
	"load recovery information next"
	stream position: self headerLength + 4.
	(startingPosition := stream getLong) == 0 
		ifFalse: 
			[stream position: startingPosition.
			recovery := ODBChangesPackage new loadFromStream: stream]! !

!ODBTransactionFile methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
openOn: aString
        "Open transaction file. Signal an error if failed."

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeOpenExisting
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareRead
                            cacheMode: ODBFileStream cacheModeAtomicWrite.
    ^self compareHeader! !

!ODBTransactionFile methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
recovery

    ^recovery! !

!ODBTransactionFile methodsFor: 'public' stamp: ''!
recovery: anODBChangesPackage 
	"Set recovery instance variable and save recovery information."

	| recoveryPosition |
	anODBChangesPackage isNil 
		ifTrue: [recoveryPosition := 0]
		ifFalse: 
			[recoveryPosition := newLockPosition + 1.
			stream position: recoveryPosition.
			anODBChangesPackage storeOnStream: stream].
	stream
		atPosition: self headerLength + 4 putLong: recoveryPosition;
		flush.
	recovery := anODBChangesPackage! !

!ODBTransactionFile methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
reinitialize
        "Reinitialize an opened transaction file."

    | bytes |
    newLockPosition := self headerLength + 10.
    bytes := ByteArray new: 11.
    bytes odbShortAt: 9 put: transactionID.
    stream position: newLockPosition - 10; putBytesFrom: bytes.
    recovery := nil.
    self initialize! !

!ODBTransactionFile methodsFor: 'public' stamp: ''!
transactionID
	transactionID isNil 
		ifTrue: 
			[transactionID := stream
						position: self headerLength + 8;
						getWord].
	^transactionID! !

!ODBTransactionFile methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
transactionID: anInteger

    transactionID := anInteger.
    stream position: self headerLength + 8; putWord: anInteger! !

!ODBTransactionFile methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
versionNumber

    ^stream position: self headerLength; getLong! !

!ODBTransactionFile methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
versionNumber: anInteger

    stream position: self headerLength; putLong: anInteger! !

ODBFile subclass: #ODBVersionControlFile
	instanceVariableNames: 'lastReadTime versionDescriptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBVersionControlFile methodsFor: 'public' stamp: ''!
created
	"Create version table for maximum 255 clients."

	stream
		putBytesFrom: (ByteArray new: (255 + 1) * 4);
		flush! !

!ODBVersionControlFile methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
createOn: aString

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeCreateAlways
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareAll
                            cacheMode: ODBFileStream cacheModeAtomicWrite.
    ^self writeHeader! !

!ODBVersionControlFile methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:06'!
descriptionString

    ^'OmniBase Version Control
OmniBase 1.0, David Gorisek (c) 1998

'! !

!ODBVersionControlFile methodsFor: 'public' stamp: ''!
getNewVersionNumberFor: clientID 
	"Answer new version number for clientID."

	| versionNumber |
	(clientID > 0 and: [clientID <= ODBClientTable maxClients]) 
		ifFalse: [OmniBase signalError: 'Bad OmniBase connection ID'].
	self waitForLockAt: self headerLength length: 4.
	versionNumber := (stream atPositionGetLong: self headerLength) + 1.
	stream
		atPosition: self headerLength putLong: versionNumber;
		atPosition: clientID * 4 + self headerLength putLong: versionNumber;
		flush.
	self unlockAt: self headerLength length: 4.
	^versionNumber! !

!ODBVersionControlFile methodsFor: 'public/create/open/close' stamp: 'cdg 3/13/2003 18:06'!
openOn: aString
        "Open transaction file. Signal an error if failed."

    stream := ODBFileStream createOn: aString
                            createMode: ODBFileStream createModeOpenExisting
                            accessMode: ODBFileStream accessModeReadWrite
                            shareMode: ODBFileStream shareModeShareAll
                            cacheMode: ODBFileStream cacheModeAtomicWrite.
    ^self compareHeader! !

!ODBVersionControlFile methodsFor: 'public' stamp: ''!
removeCommittingFor: clientID 
	"Remove committing version number for clientID."

	(clientID > 0 and: [clientID <= ODBClientTable maxClients]) 
		ifFalse: [OmniBase signalError: 'Bad client ID'].
	stream atPosition: clientID * 4 + self headerLength putLong: 0.
	versionDescriptor := nil! !

!ODBVersionControlFile methodsFor: 'public' stamp: ''!
versionDescriptor
	"Answer read versionDescriptor."

	| versionTable size time |
	(versionDescriptor isNil 
		or: [((time := Time millisecondClockValue) - lastReadTime) abs > 500]) 
			ifTrue: 
				[size := (ODBClientTable maxClients + 1) * 4.
				versionTable := ByteArray new: size.
				stream 
					atPosition: self headerLength
					getBytesFor: versionTable
					len: size.
				lastReadTime := time isNil ifTrue: [Time millisecondClockValue] ifFalse: [time].
				versionDescriptor := ODBVersionDescriptor new fromVersionTable: versionTable].
	^versionDescriptor! !

Object subclass: #ODBGarbageCollector
	instanceVariableNames: 'containers gcFile objectManager progressDialog progressValue reorganizeDictionaries reorganizeIndexSets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
basicRun
	
	[self progressNotification: 'Starting garbage collection' value: 0.
	self lockObjectManager.	"doesn't realy lock it, see method #lockObjectManager"
	containers := objectManager containers.
	self checkDiskSpace ifFalse: [^false].
	self
		createNewObjectSpaces;
		selectNewObjectSpace;
		swapObjectSpaces;
		walkObjects;
		copyObjects;
		complete] 
			ensure: 
				[self close.
				objectManager reopen.
				objectManager environment globalUnlock]! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
checkDiskSpace
	"Private - Check for avaiable disk space and set total number of objects in wait dialog."

	"       | totalObjects maxContainerSize n gcSpace |
        maxContainerSize := 0.
        gcSpace := 0.
        totalObjects := 0.
        containers do: [:container |
                n := container numberOfObjects.
                gcSpace := n // 8 + gcSpace.
                maxContainerSize := container bytesAllocated max: maxContainerSize.
                totalObjects := totalObjects + n
        ].
        waitDialog maxValue: totalObjects.
        maxContainerSize + gcSpace < objectManager environment freeDiskSpace ifTrue: [ ^true ].
        ^OmniBase confirmationMessage: 'Disk space low.
Are you sure you want to continue ?'!!
"

	^true! !

!ODBGarbageCollector methodsFor: 'public' stamp: ''!
close
	gcFile notNil ifTrue: [gcFile close]! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
complete
	"Private - Complete garbage collection."

	gcFile status = 6 ifFalse: [^self].
	objectManager environment transactionManager oldHolders truncate.
	objectManager unlock.
	gcFile remove.
	gcFile := nil! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
copyObjects
	"Private - Copy objects from oldObject space to new object space."

	| set objectSpace dbObject index count |
	gcFile status = 5 ifFalse: [^self].
	objectSpace := objectManager defaultObjectSpace.
	containers do: 
			[:container | 
			[set := ODBIntegerSet openOn: (self oidSetFilenameFor: container)] on: Error
				do: [set := nil].
			set isNil 
				ifFalse: 
					[count := 0.
					self progressNotification: 'Compacting container ' , container name value: 0.
					container objectHoldersDo: 
							[:holder | 
							count := count + 1.
							self progressNotification: nil value: count / container numberOfObjects.
							index := holder objectID index.
							dbObject := holder getObject.
							(set includes: index) 
								ifTrue: [dbObject garbageCollectOn: self]
								ifFalse: 
									[dbObject remove.
									container removeHolderAt: index]].
					container flushBytes.
					set remove.
					container removeObjectSpace: 1 - objectSpace]].
	gcFile status: 6! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
createNewObjectSpaces
	"Private - Create new object space for each container."

	gcFile status = 1 ifFalse: [^self].
	containers do: [:each | each createNewObjectSpace].
	"new object spaces created"
	gcFile status: 2! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
gcFileName
	^objectManager environment dirName , ODBFileStream pathSeparatorString , 'GC.log'! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
lockObjectManager
	gcFile status = 0 ifFalse: [^self].
	"objectManager lock."	"don't lock it because db is allready opened exclusively"
	"object manager has been locked"
	gcFile status: 1! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
message: aString 
	OmniBase warningMessage: aString! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
oidSetFilenameFor: anODBContainer 
	^anODBContainer dirName , ODBFileStream pathSeparatorString , 'Marked.set'! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
oidStackFileName
	^objectManager environment dirName , ODBFileStream pathSeparatorString , 'GC.oid'! !

!ODBGarbageCollector methodsFor: 'public' stamp: ''!
openOn: anOmniBase 
	"Open garbage collector on anOmnibase. If garbage collector file exists
		then previous garbage collection was interrupted. Answer <nil> if none."

	objectManager := anOmniBase objectManager.
	(gcFile := ODBGarbageCollectorFile openOn: self gcFileName) isNil 
		ifTrue: [^nil]
		ifFalse: 
			[gcFile status < 3 
				ifTrue: 
					[gcFile remove.
					^nil]].
	^self! !

!ODBGarbageCollector methodsFor: 'private' stamp: 'dg 12/20/2003 23:10'!
progressNotification: aString value: aFraction 
	progressDialog isNil 
		ifFalse: 
			[aFraction isNil ifFalse: [progressValue value: 100 * aFraction]].! !

!ODBGarbageCollector methodsFor: 'public' stamp: ''!
reorganizeDictionaries
	^reorganizeDictionaries == true! !

!ODBGarbageCollector methodsFor: 'public' stamp: ''!
reorganizeDictionaries: aBoolean 
	reorganizeDictionaries := aBoolean! !

!ODBGarbageCollector methodsFor: 'public' stamp: ''!
reorganizeIndexSets
	"Answer <true> if B-Tree index sets should be reorganized."

	^reorganizeIndexSets == true! !

!ODBGarbageCollector methodsFor: 'public' stamp: ''!
reorganizeIndexSets: aBoolean 
	reorganizeIndexSets := aBoolean! !

!ODBGarbageCollector methodsFor: 'public' stamp: ''!
run
	^self run: false! !

!ODBGarbageCollector methodsFor: 'public' stamp: ''!
runOn: anOmniBase 
	"Run garbage collection on anOmniBase."

	^self runOn: anOmniBase silentMode: false! !

!ODBGarbageCollector methodsFor: 'public' stamp: ''!
runOn: anOmniBase silentMode: silenceBool 
	"Run garbage collection on anOmniBase."

	objectManager := anOmniBase objectManager.
	[gcFile := ODBGarbageCollectorFile openOn: self gcFileName] on: Error
		do: 
			[:ex | 
			objectManager isLocked ifTrue: [OmniBase signalError: 'Object manager is locked !!'].
			gcFile := ODBGarbageCollectorFile createOn: self gcFileName].
	^self run: silenceBool! !

!ODBGarbageCollector methodsFor: 'public' stamp: 'dg 12/20/2003 23:12'!
run: silenceBool 
	(objectManager environment globalLock and: [objectManager reopenExclusively]) 
		ifFalse: 
			[objectManager environment globalUnlock.
			self close.
			silenceBool = true 
				ifFalse: [OmniBase warningMessage: 'Database is still being accessed by other users !!'].
			^false].
	silenceBool = true 
		ifTrue: [self basicRun]
		ifFalse: 
			['OmniBase garbage collection in progress'
				displayProgressAt: Sensor cursorPoint
				from: 0 to: 100
				during:
					[:bar |
						progressDialog := bar.
						progressValue := bar.
						self basicRun]].
	^true! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
selectNewObjectSpace
	"Private - Select new object space."

	gcFile status = 2 ifFalse: [^self].
	gcFile newObjectSpace: 1 - objectManager defaultObjectSpace.
	gcFile status: 3! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
swapObjectSpaces
	"Private - Swap default object spaces."

	| newObjectSpace |
	gcFile status = 3 ifFalse: [^self].
	newObjectSpace := gcFile newObjectSpace.
	objectManager defaultObjectSpace == newObjectSpace 
		ifFalse: 
			[containers do: [:each | each lockObjectSpace: 1 - newObjectSpace].
			objectManager defaultObjectSpace: newObjectSpace].
	"object spaces have been swaped"
	gcFile status: 4! !

!ODBGarbageCollector methodsFor: 'private' stamp: ''!
walkObjects
	"Private - Object traversal."

	| toDo firstToDo oidSets set containerID totalObjects objectID holder dbObject count |
	gcFile status = 6 ifTrue: [^self].
	"create OID sets"
	oidSets := OrderedCollection new.
	
	[totalObjects := 0.
	containers do: 
			[:container | 
			set := ODBIntegerSet createOn: (self oidSetFilenameFor: container).
			[oidSets size < container id] whileTrue: [oidSets add: nil].
			oidSets at: container id put: set.
			totalObjects := totalObjects + container numberOfObjects].
	count := 0.
	self progressNotification: 'Traversing objects' value: 0.
	"first load all from rootObject"
	firstToDo := OrderedCollection new.
	"create OID stack"
	toDo := ODBObjectIdStack createOn: self oidStackFileName.
	"walk objects"
	(oidSets at: 1) add: 1.	"mark (1:1)"
	firstToDo add: (ODBObjectID containerID: 1 index: 1).
	[firstToDo size = 1] whileTrue: 
			[objectID := firstToDo removeLast.
			self progressNotification: nil value: (count := count + 1) / (totalObjects * 2).
			(holder := objectManager holderAt: objectID) isNil 
				ifFalse: 
					[dbObject := holder getObject.
					dbObject referencesDo: 
							[:oid | 
							containerID := oid containerID.
							(containerID == 0 or: [(oidSets at: containerID) includes: oid index]) 
								ifFalse: 
									[(oidSets at: containerID) add: oid index.
									firstToDo add: oid.
									self progressNotification: nil value: (count := count + 1) / (totalObjects * 2)]].
					dbObject close]
				ifTrue: [OmniBase signalError: 'Invalid object ID']].
	firstToDo do: 
			[:eachOID | 
			self progressNotification: nil value: (count := count + 1) / (totalObjects * 2).
			(holder := objectManager holderAt: eachOID) == nil 
				ifFalse: 
					[dbObject := holder getObject.
					dbObject referencesDo: 
							[:oid | 
							containerID := oid containerID.
							(containerID == 0 or: [(oidSets at: containerID) includes: oid index]) 
								ifFalse: 
									[(oidSets at: containerID) add: oid index.
									toDo add: oid.
									self progressNotification: nil value: (count := count + 1) / (totalObjects * 2)]].
					dbObject close]
				ifTrue: [OmniBase signalError: 'Invalid object ID']].
	[toDo isEmpty] whileFalse: 
			[objectID := toDo removeLast.
			self progressNotification: nil value: (count := count + 1) / (totalObjects * 2).
			(holder := objectManager holderAt: objectID) == nil 
				ifFalse: 
					[dbObject := holder getObject.
					dbObject referencesDo: 
							[:oid | 
							containerID := oid containerID.
							(containerID == 0 or: [(oidSets at: containerID) includes: oid index]) 
								ifFalse: 
									[(oidSets at: containerID) add: oid index.
									toDo add: oid.
									self progressNotification: nil value: (count := count + 1) / (totalObjects * 2)]].
					dbObject close]
				ifTrue: [OmniBase signalError: 'Invalid object ID']]] 
			ensure: 
				["remove OID stack"
				toDo isNil ifFalse: [toDo remove].
				"close OID sets"
				oidSets do: [:each | each notNil ifTrue: [each close]]].
	gcFile status: 5! !

Object subclass: #ODBIdentityDictionary
	instanceVariableNames: 'elementCount emptySlotMarker keys sizeLimit values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBIdentityDictionary class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
new

    ^self new: 30! !

!ODBIdentityDictionary class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
new: anInteger

    ^super new initialize: anInteger * 2 + 1! !

!ODBIdentityDictionary class methodsFor: 'public' stamp: 'ac 3/14/2004 19:53'!
odbDeserialize: deserializer 
	| size dict key |
	size := deserializer stream getPositiveInteger.
	dict := self new: size.
	deserializer register: dict.
	size timesRepeat: 
			[key := deserializer odbNextObject.
			dict at: key put: deserializer odbNextObject].
	^dict! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
associationsDo: aBlock 
	"Evaluate aBlock for each value in dictionary."

	| key |
	1 to: keys size
		do: 
			[:i | 
			key := keys at: i.
			(key isNil or: [key == emptySlotMarker]) 
				ifFalse: [aBlock value: (Association key: key value: (values at: i))]]! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
at: anObject 
	"Answer value at anObject, <nil> if absent."

	| index lastIndex key |
	lastIndex := keys size.
	index := anObject identityHash \\ lastIndex.
	[anObject == (key := keys at: (index := index + 1))] whileFalse: 
			[key isNil ifTrue: [^nil].
			index == lastIndex ifTrue: [index := 0]].
	^values at: index! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
at: aKey ifAbsentPutValue: anObject 
	^self at: aKey ifAbsent: [self at: aKey put: anObject]! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
at: anObject ifAbsentPut: aBlock 
	^self at: anObject ifAbsent: [self at: anObject put: aBlock value]! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
at: anObject ifAbsent: aBlock 
	| index lastIndex key |
	anObject isNil ifTrue: [^aBlock value].
	lastIndex := keys size.
	index := anObject identityHash \\ lastIndex.
	[anObject == (key := keys at: (index := index + 1))] whileFalse: 
			[key isNil ifTrue: [^aBlock value].
			index == lastIndex ifTrue: [index := 0]].
	^values at: index! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
at: aKey put: anObject 
	"Answer anObject. If aKey exists in the receiver,
	replace the corresponding value with anObject, else
	add the aKey/anObject pair to the receiver."

	| index lastIndex key |
	lastIndex := keys size.
	index := aKey identityHash \\ lastIndex.
	[aKey == (key := keys at: (index := index + 1))] whileFalse: 
			[key isNil 
				ifTrue: 
					[keys at: index put: aKey.
					values at: index put: anObject.
					(elementCount := elementCount + 1) < sizeLimit ifFalse: [self grow].
					^anObject].
			key == emptySlotMarker 
				ifTrue: 
					[keys at: index put: aKey.
					^values at: index put: anObject].
			index == lastIndex ifTrue: [index := 0]].
	^values at: index put: anObject! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
do: aBlock 
	"Evaluate aBlock for each value in dictionary."

	| key |
	1 to: keys size
		do: 
			[:i | 
			key := keys at: i.
			(key isNil or: [key == emptySlotMarker]) ifFalse: [aBlock value: (values at: i)]]! !

!ODBIdentityDictionary methodsFor: 'private' stamp: ''!
grow
	"Private - Grow the receiver to double size to accomodate more key/value pairs."

	| oldSize oldValues oldKeys key value |
	oldKeys := keys.
	oldSize := keys size.
	oldValues := values.
	self initialize: oldSize * 2.
	1 to: oldSize
		do: 
			[:index | 
			key := oldKeys at: index.
			(key isNil 
				or: [key == emptySlotMarker or: [(value := oldValues at: index) == emptySlotMarker]]) 
					ifFalse: [self at: key put: value]]! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
includesKey: anObject 
	| index lastIndex key |
	lastIndex := keys size.
	index := anObject identityHash \\ lastIndex.
	[anObject == (key := keys at: (index := index + 1))] whileFalse: 
			[key isNil ifTrue: [^false].
			index == lastIndex ifTrue: [index := 0]].
	^true! !

!ODBIdentityDictionary methodsFor: 'private' stamp: 'dg 12/20/2003 09:04'!
initialize: anInteger 
	elementCount := 0.
	keys := Array new: anInteger.
	values := Array new: anInteger.
	sizeLimit := (anInteger - 2) * 11 // 23.
	emptySlotMarker := UndefinedObject! !

!ODBIdentityDictionary methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
isEmpty

    ^self size == 0! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
keysAndValuesDo: aBlock 
	"Evaluate aBlock for each value in dictionary."

	| key |
	1 to: keys size
		do: 
			[:i | 
			key := keys at: i.
			(key isNil or: [key == emptySlotMarker]) 
				ifFalse: [aBlock value: key value: (values at: i)]]! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
removeKey: aKey 
	"Remove aKey from receiver. Do nothing if absent."

	| index lastIndex key |
	lastIndex := keys size.
	index := aKey identityHash \\ lastIndex.
	[aKey == (key := keys at: (index := index + 1))] whileFalse: 
			[key isNil ifTrue: [^self].
			index == lastIndex ifTrue: [index := 0]].
	keys at: index put: emptySlotMarker.
	^values at: index put: nil! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
removeKey: aKey ifAbsent: aBlock 
	"Remove aKey from receiver. Evaluate aBlock if absent."

	| index lastIndex key |
	lastIndex := keys size.
	index := aKey identityHash \\ lastIndex.
	[aKey == (key := keys at: (index := index + 1))] whileFalse: 
			[key isNil ifTrue: [^aBlock value].
			index == lastIndex ifTrue: [index := 0]].
	keys at: index put: emptySlotMarker.
	^values at: index put: nil! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
size
	"Answer number of elements in dictionary."

	| count key |
	count := 0.
	1 to: keys size
		do: 
			[:i | 
			key := keys at: i.
			(key isNil or: [key == emptySlotMarker]) ifFalse: [count := count + 1]].
	^count! !

!ODBIdentityDictionary methodsFor: 'public' stamp: ''!
values
	| coll key |
	coll := OrderedCollection new: elementCount.
	1 to: values size
		do: 
			[:i | 
			key := keys at: i.
			(key isNil or: [key == emptySlotMarker]) ifFalse: [coll add: (values at: i)]].
	^coll! !

ODBIdentityDictionary subclass: #ODBWeakValueIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBWeakValueIdentityDictionary methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
at: anObject
		"Answer value at anObject, <nil> if absent."

	| index lastIndex key value |
	lastIndex := keys size.
	index := anObject identityHash \\ lastIndex.
	[ anObject == (key := keys at: (index := index + 1)) ]
		whileFalse: [
			key == nil ifTrue: [ ^nil ].
			index == lastIndex ifTrue: [ index := 0 ]].
	(value := values at: index) == 0 ifFalse: [ ^value ].
	^nil! !

!ODBWeakValueIdentityDictionary methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
at: anObject ifAbsent: aBlock

	| index lastIndex key value |
	lastIndex := keys size.
	index := anObject identityHash \\ lastIndex.
	[ anObject == (key := keys at: (index := index + 1)) ]
		whileFalse: [
			key == nil ifTrue: [ ^aBlock value ].
			index == lastIndex ifTrue: [ index := 0 ]].
	(value := values at: index) == 0 ifFalse: [ ^value ].
	^aBlock value! !

!ODBWeakValueIdentityDictionary methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
at: aKey put: anObject
		"Answer anObject. If aKey exists in the receiver,
		replace the corresponding value with anObject, else
		add the aKey/anObject pair to the receiver."

	| index lastIndex key |
	lastIndex := keys size.
	index := aKey identityHash \\ lastIndex.
	[ aKey == (key := keys at: (index := index + 1)) ]
		whileFalse: [
			key == nil ifTrue: [
				keys at: index put: aKey.
				values at: index put: anObject.
				(elementCount := elementCount + 1) >= sizeLimit ifTrue: [ self grow ].
				^anObject ].
			(values at: index) == 0
				ifTrue: [
					keys at: index put: aKey.
					^values at: index put: anObject ].
			index == lastIndex ifTrue: [ index := 0 ]].
	^values at: index put: anObject! !

!ODBWeakValueIdentityDictionary methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
do: aBlock
		"Evaluate aBlock for each value in dictionary."

	| value key |
	1 to: keys size do: [:i |
		key := keys at: i.
		(key == nil or: [(value := values at: i) == 0])
			ifFalse: [ aBlock value: value ]]! !

!ODBWeakValueIdentityDictionary methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
initialize: anInteger

	elementCount := 0.
	keys := Array new: anInteger.
	values := WeakArray new: anInteger.
	sizeLimit := anInteger - 2 * 11 // 23! !

Object subclass: #ODBLock
	instanceVariableNames: 'transaction lockIndex objectID lockID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBLock subclass: #ODBKeyLock
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBKeyLock class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
lockClassID
        "Answer unique class ID used for storing locks 
        or <nil> if lock does not need to be stored."

    ^2! !

!ODBKeyLock methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
key

    ^key! !

!ODBKeyLock methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
key: aString

    key := aString! !

!ODBKeyLock methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:05'!
loadFromStream: aStream

    objectID := ODBObjectID new loadFromStream: aStream.
    lockID := aStream getLong.
    key := aStream getString asByteArray! !

!ODBKeyLock methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:05'!
storeOnStream: aStream

        objectID storeOnStream: aStream.
        aStream putLong: lockID.
        aStream putString: key! !

!ODBKeyLock methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
unlock

    self transactionObject dataBaseObject unlockKey: key with: lockID! !

!ODBLock class methodsFor: 'public' stamp: ''!
lockClassID
	"Answer unique class ID used for storing locks 
        or <nil> if lock does not need to be stored."

	self subclassResponsibility! !

!ODBLock methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
lockID

    ^lockID! !

!ODBLock methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
lockID: anInteger

    lockID := anInteger! !

!ODBLock methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
lockIndex

    ^lockIndex! !

!ODBLock methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
lockIndex: anInteger

    lockIndex := anInteger.! !

!ODBLock methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
objectID

    ^objectID! !

!ODBLock methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
objectID: anObjectID

    objectID := anObjectID! !

!ODBLock methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
transactionObject
        "Private - Get transaction object corresponding to objectID."

    ^transaction transactionObjectAt: objectID! !

!ODBLock methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
transaction: aTransaction

    transaction := aTransaction! !

ODBLock subclass: #ODBObjectLock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBObjectLock class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:05'!
lockClassID
        "Answer unique class ID used for storing locks 
        or <nil> if lock does not need to be stored."

    ^1! !

!ODBObjectLock methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:06'!
loadFromStream: aStream

    objectID := ODBObjectID new loadFromStream: aStream.
    lockID := aStream getLong! !

!ODBObjectLock methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:06'!
storeOnStream: aStream

        objectID storeOnStream: aStream.
        aStream putLong: lockID! !

!ODBObjectLock methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:06'!
unlock

    ^(transaction objectHolderAt: objectID) unlockWith: lockID! !

Object subclass: #ODBObjectID
	instanceVariableNames: 'containerID index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBObjectID class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:05'!
containerID: containerID index: index

    ^super new containerID: containerID index: index! !

!ODBObjectID class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new containerID: 0 index: 0! !

!ODBObjectID class methodsFor: 'private' stamp: ''!
sizeInBytes
	"Answer OID size in bytes.
	Note: If you change ODBObjectID>>sizeInBytes, then 
        you have to update ODBValueHolder>>sizeInBytes too."

	^4! !

!ODBObjectID methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
containerID

    ^containerID! !

!ODBObjectID methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
containerID: byte index: ulong

    containerID := byte.
    index := ulong! !

!ODBObjectID methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
contents
        "Answer ByteArray representing receiver."

    | bytes |
    bytes := ByteArray new: 4.
    bytes odbLongAt: 1 put: index; at: 4 put: containerID.
    ^bytes! !

!ODBObjectID methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
contents: aByteArray
        "Initialize receiver from aByteArray."

    containerID := aByteArray at: 4.
    index := ((aByteArray at: 3) bitShift: 16) + ((aByteArray at: 2) bitShift: 8) + (aByteArray at: 1)! !

!ODBObjectID methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
fromBytes: aByteArray at: pos
        "Initialize receiver from aByteArray at pos."

    containerID := aByteArray at: pos + 3.
    index := ((aByteArray at: pos + 2) bitShift: 16) +
                ((aByteArray at: pos + 1) bitShift: 8) +
                (aByteArray at: pos)! !

!ODBObjectID methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
hash

    ^index + (containerID bitShift: 17)! !

!ODBObjectID methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
index

    ^index! !

!ODBObjectID methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
index: ulong

    index := ulong! !

!ODBObjectID methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:05'!
loadFromStream: aStream

    | bytes |
    bytes := ByteArray new: self class sizeInBytes.
    aStream getBytesFor: bytes.
    self fromBytes: bytes at: 1! !

!ODBObjectID methodsFor: 'public' stamp: ''!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	containerID printOn: aStream.
	aStream nextPut: $:.
	index printOn: aStream.
	aStream nextPut: $)! !

!ODBObjectID methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
putBytesTo: bytes at: pos

	bytes
		odbLongAt: pos put: index;
		at: pos + 3 put: containerID! !

!ODBObjectID methodsFor: 'public/load/store' stamp: 'cdg 3/13/2003 18:05'!
storeOnStream: aStream

    aStream putBytesFrom: self contents! !

!ODBObjectID methodsFor: 'public/unclassified' stamp: 'ac 11/17/2004 12:23'!
= other

    ^ self species = other species
		and: [other index == index] 
		and: [other containerID == containerID]! !

Object subclass: #ODBObjectIDDictionary
	instanceVariableNames: 'dictionaries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBObjectIDDictionary class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new initialize! !

!ODBObjectIDDictionary methodsFor: 'public' stamp: ''!
at: objectID 
	"Answer transaction object at objectID or <nil> if absent."

	| dict |
	(dict := dictionaries at: objectID containerID) isNil ifTrue: [^nil].
	^dict at: objectID index! !

!ODBObjectIDDictionary methodsFor: 'public' stamp: ''!
at: objectID ifAbsentPutValue: anObject 
	| dict |
	(dict := dictionaries at: objectID containerID) isNil 
		ifTrue: [dictionaries at: objectID containerID put: (dict := ODBIdentityDictionary new)].
	^dict at: objectID index ifAbsentPutValue: anObject! !

!ODBObjectIDDictionary methodsFor: 'public' stamp: ''!
at: objectID put: anObject 
	| dict |
	(dict := dictionaries at: objectID containerID) isNil 
		ifTrue: [dictionaries at: objectID containerID put: (dict := ODBIdentityDictionary new)].
	^dict at: objectID index put: anObject! !

!ODBObjectIDDictionary methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:05'!
initialize

    dictionaries := Array new: 255! !

!ODBObjectIDDictionary methodsFor: 'public' stamp: ''!
removeKey: objectID 
	"Remove transaction object association with objectID. 
	Do nothing if objectID is absent."

	| dict |
	(dict := dictionaries at: objectID containerID) isNil 
		ifFalse: [dict removeKey: objectID index]! !

Object subclass: #ODBObjectManager
	instanceVariableNames: 'containers environment idTable infoFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBObjectManager class methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new initialize! !

!ODBObjectManager methodsFor: 'create/open/close' stamp: 'cdg 3/13/2003 18:05'!
close
        "Close object manager and all opened containers."

    | cnt |
    1 to: containers size do: [:i |
        (cnt := containers at: i) notNil ifTrue: [
            cnt close.
            containers at: i put: nil]].
    containers := OrderedCollection new.
    idTable isNil ifFalse: [idTable close].
    infoFile isNil ifFalse: [infoFile close]! !

!ODBObjectManager methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
containerAt: containerID
        "Answer container at containerID or default container if none."

    ^self containerAt: containerID ifAbsent: [^self defaultContainer]! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
containerAt: containerID ifAbsent: aBlock 
	"Answer container at containerID. Evaluate aBlock if absent."

	| cont pos |
	containerID < 1 ifTrue: [^aBlock value].
	containerID > containers size 
		ifFalse: [(cont := containers at: containerID) isNil ifFalse: [^cont]].
	pos := idTable at: containerID ifAbsent: [^aBlock value].
	pos == 0 ifTrue: [^aBlock value].
	^self initContainerAt: pos! !

!ODBObjectManager methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
containerNamed: containerName
        "Answer container with containerName or 
        default container, if container is not found."

    ^self containerNamed: containerName ifAbsent: [^self defaultContainer]! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
containerNamed: containerName ifAbsent: aBlock 
	"Answer container with containerName. 
        Evaluate aBlock, if container is not found."

	| name pos |
	name := self unifyContainerName: containerName.
	containers do: [:each | (each isNil or: [each name ~= name]) ifFalse: [^each]].
	pos := infoFile at: name ifAbsent: [^aBlock value].
	pos == 0 ifTrue: [^aBlock value].
	^self initContainerAt: pos! !

!ODBObjectManager methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
containerNew: aString
        "Create new container named aString.
        Answer container created."

    ^self containerNew: aString path: ''! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
containerNew: aString path: path 
	"Private - Create new container named aString 
	on given path. Signal an error if failed."

	| containerName containerID containerPath dirName cont pos stream |
	path = '' ifFalse: [OmniBase signalError: 'Not supported'].
	infoFile isLocked ifTrue: [OmniBase signalError: 'Object manager is currently locked !!'].
	idTable waitForAddingLock.
	
	[(cont := self containerNamed: aString ifAbsent: []) isNil 
		ifFalse: [OmniBase signalError: 'Container with this name allready exists'].
	containerName := self unifyContainerName: aString.
	containerID := idTable add: 0.
	pos := 0.
	dirName := self convert: aString.
	
	[containerPath := (path isEmpty ifTrue: [self dirName] ifFalse: [path]) 
				, ODBFileStream pathSeparatorString , dirName.
	ODBFileStream directoryExists: containerPath] 
			whileTrue: 
				[pos := pos + 1.
				dirName := (dirName copyFrom: 1 to: (dirName size min: 7)) , pos printString].
	ODBFileStream directoryCreate: containerPath.
	cont := (ODBContainer new)
				name: containerName;
				id: containerID;
				objectManager: self;
				createOn: containerPath.
	stream := infoFile stream.
	pos := stream setToEnd.
	stream
		putWord: containerID;
		putString: containerName;
		putString: path;
		putString: dirName.
	idTable at: containerID put: pos.
	infoFile at: containerName put: pos] 
			ensure: [idTable unlockAdding].
	containerID > containers size 
		ifTrue: 
			[pos := Array new: containerID.
			pos 
				replaceFrom: 1
				to: containers size
				with: containers
				startingAt: 1.
			containers := pos].
	^containers at: containerID put: cont! !

!ODBObjectManager methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
containers
        "Answer collection of all containers in database."

    | coll |
    coll := OrderedCollection new.
    idTable indexesAndValuesDo: [:i :pos | coll add: (self containerAt: i)].
    ^coll! !

!ODBObjectManager methodsFor: 'private' stamp: ''!
convert: containerName 
	"Private - Answer a String which is a directory name 
	abbreviated from containerName. Lower case
	vowels are dropped from the right of containerName
	until it is less than or equal to 8 characters."

	| size dirName asciiInteger |
	dirName := containerName select: 
					[:char | 
					asciiInteger := char asInteger.
					((asciiInteger > 96 and: [asciiInteger < 123]) 
						or: [asciiInteger > 64 and: [asciiInteger < 91]]) 
							or: [asciiInteger > 47 and: [asciiInteger < 58]]].
	size := dirName size.
	dirName := (dirName reverse select: 
					[:char | 
					(char isVowel and: [char isLowercase]) ifTrue: [(size := size - 1) < 8] ifFalse: [true]]) 
				reverse.
	^dirName isEmpty 
		ifTrue: ['Contanr0']
		ifFalse: [dirName copyFrom: 1 to: (dirName size min: 8)]! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
createOn: anOmniBase 
	"Create new object manager."

	environment := anOmniBase.
	
	[(ODBFileStream directoryExists: self dirName) 
		ifFalse: [ODBFileStream directoryCreate: self dirName].
	idTable := ODBIDTable createOn: self idFileName.
	infoFile := ODBContainerInfoFile createOn: self infoFileName.
	self containerNew: 'Default'] 
			ifCurtailed: [self close]! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
defaultContainer
	"Answer default container."

	| cont |
	^(cont := containers at: 1) isNil 
		ifFalse: [cont]
		ifTrue: [self initContainerAt: (idTable at: 1)]! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
defaultObjectSpace
	^infoFile defaultObjectSpace! !

!ODBObjectManager methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
defaultObjectSpace: anInteger

	^infoFile defaultObjectSpace: anInteger! !

!ODBObjectManager methodsFor: 'private' stamp: ''!
dirName
	"Private - Answer directory where containers are placed."

	^environment dirName , ODBFileStream pathSeparatorString , 'Objects'! !

!ODBObjectManager methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
environment

    ^environment! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
flushContainers
	"Flush all containers before commit."

	containers do: [:each | each isNil ifFalse: [each flushBytes]]! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
holderAt: objectID 
	"Answer persistent object holder at objectID."

	^(self containerAt: objectID containerID ifAbsent: [^nil]) at: objectID index! !

!ODBObjectManager methodsFor: 'private' stamp: ''!
idFileName
	^environment dirName , ODBFileStream pathSeparatorString , 'omnibase.cid'! !

!ODBObjectManager methodsFor: 'private' stamp: ''!
infoFileName
	^environment dirName , ODBFileStream pathSeparatorString , 'omnibase.cif'! !

!ODBObjectManager methodsFor: 'private' stamp: ''!
initContainerAt: position 
	"Private - Initialize container stored in infoFile at position.
	Answer container."

	| id name path cont dirName stream newArray |
	stream := infoFile stream.
	stream position: position.
	id := stream getWord.
	name := stream getString.
	path := stream getString.
	path isEmpty ifTrue: [path := self dirName].
	dirName := stream getString.
	id > containers size 
		ifTrue: 
			[newArray := Array new: id.
			newArray 
				replaceFrom: 1
				to: containers size
				with: containers
				startingAt: 1.
			containers := newArray].
	cont := (ODBContainer new)
				name: name;
				id: id;
				objectManager: self;
				openOn: path , ODBFileStream pathSeparatorString , dirName.
	^containers at: id put: cont! !

!ODBObjectManager methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
initialize
        "Private - Initialize receiver."

    containers := Array new: 32! !

!ODBObjectManager methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
isLocked
        "Answer <true> if object manager is locked."

    ^infoFile isLocked! !

!ODBObjectManager methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
lock
        "Lock object manager."

    ^infoFile lock! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
openOn: anOmniBase 
	"Open receiver. Trigger an exception if failed."

	environment := anOmniBase.
	
	[idTable := ODBIDTable openOn: self idFileName.
	infoFile := ODBContainerInfoFile openOn: self infoFileName] 
			ifCurtailed: [self close]! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
reopen
	idTable close.
	[idTable := ODBIDTable openOn: self idFileName] ifCurtailed: [environment close]! !

!ODBObjectManager methodsFor: 'public' stamp: ''!
reopenExclusively
	| result |
	result := false.
	idTable close.
	
	[idTable := ODBIDTable new openExclusivelyOn: self idFileName.
	result := true] on: Error
			do: [:ex | [idTable := ODBIDTable openOn: self idFileName] ifCurtailed: [environment close]].
	^result! !

!ODBObjectManager methodsFor: 'private' stamp: ''!
unifyContainerName: aString 
	"Private - unifies aString that represents a container name."

	aString trimBlanks.
	^aString size > 20 ifTrue: [aString copyFrom: 1 to: 20] ifFalse: [aString]! !

!ODBObjectManager methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
unlock
        "Unlock object manager."

    ^infoFile unlock! !

Object subclass: #ODBReferenceManager
	instanceVariableNames: 'references'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBReferenceManager methodsFor: 'public' stamp: ''!
addReference: aReference 
	references isNil ifTrue: [references := OrderedCollection new].
	references add: aReference.
	^references size! !

!ODBReferenceManager methodsFor: 'public' stamp: ''!
asBytesWith: endBytes 
	"Answer aByteArray with reference manager and endBytes as a single byte array."

	| pos oidSize bytes refsSize len |
	references isNil ifTrue: [^endBytes].
	refsSize := references size.
	oidSize := ODBObjectID sizeInBytes.
	len := refsSize * oidSize + endBytes size.
	references size > 256 
		ifFalse: 
			[bytes := ByteArray new: len + 1.
			bytes at: 1 put: refsSize - 1.
			pos := 2]
		ifTrue: 
			[bytes := ByteArray new: len + 2.
			bytes
				at: 1 put: (refsSize - 1 bitAnd: 255);
				at: 2 put: (refsSize - 1 bitShift: -8).
			pos := 3].
	references do: 
			[:each | 
			each putBytesTo: bytes at: pos.
			pos := pos + oidSize].
	bytes 
		replaceFrom: pos
		to: bytes size
		with: endBytes
		startingAt: 1.
	^bytes! !

!ODBReferenceManager methodsFor: 'public' stamp: ''!
createMax256From: bytes 
	"Update receiver from bytes. Answer number of bytes used."

	| pos oidSize refsSize |
	references := Array new: (refsSize := (bytes at: 1) + 1).
	pos := 2.
	oidSize := ODBObjectID sizeInBytes.
	1 to: refsSize
		do: 
			[:i | 
			references at: i put: (ODBObjectID new fromBytes: bytes at: pos).
			pos := pos + oidSize].
	^pos - 1! !

!ODBReferenceManager methodsFor: 'public' stamp: ''!
createMax65536From: bytes 
	"Update receiver from bytes. Answer number of bytes used."

	| pos oidSize refsSize |
	references := Array new: (refsSize := ((bytes at: 2) bitShift: 8) + (bytes at: 1) + 1).
	pos := 3.
	oidSize := ODBObjectID sizeInBytes.
	1 to: refsSize
		do: 
			[:i | 
			references at: i put: (ODBObjectID new fromBytes: bytes at: pos).
			pos := pos + oidSize].
	^pos - 1! !

!ODBReferenceManager methodsFor: 'public' stamp: ''!
databaseObjectClassID
	references isNil ifTrue: [^ODBSerializedDBObjectWithoutReferences classID].
	references size < 257 ifTrue: [^ODBSerializedDBObject256References classID].
	references size < 65537 ifTrue: [^ODBSerializedDBObject65536References classID]! !

!ODBReferenceManager methodsFor: 'load/store' stamp: 'david@inspiron 2/9/2005 10:23'!
loadFromStream: stream 
	| n |
	n := stream getPositiveInteger.
	n > 10000 ifTrue: [self error: '[Deserialization] Too many external references'].
	n > 0 
		ifTrue: 
			[references := OrderedCollection new: n.
			n timesRepeat: [references add: (ODBObjectID new loadFromStream: stream)]]! !

!ODBReferenceManager methodsFor: 'load/store' stamp: 'david@inspiron 2/11/2005 12:58'!
loadFromStream: stream externalReferencesLoaderBlock: referencedObjectLoaderBlock 
	| n |
	n := stream getPositiveInteger.
	n > 10000 ifTrue: [self error: '[Deserialization] Too many external references'].
	n > 0 
		ifTrue: 
			[references := OrderedCollection new: n.
			n timesRepeat: [references add: (referencedObjectLoaderBlock value: stream)]]! !

!ODBReferenceManager methodsFor: 'public' stamp: ''!
referenceAt: index 
	^references at: index! !

!ODBReferenceManager methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
referencesDo: aBlock

	references do: aBlock! !

!ODBReferenceManager methodsFor: 'load/store' stamp: 'david@inspiron 2/9/2005 10:43'!
saveOnStream: stream 
	references isNil 
		ifTrue: [stream putPositiveInteger: 0]
		ifFalse: 
			[stream putPositiveInteger: references size.
			references do: [:each | each storeOnStream: stream]]! !

!ODBReferenceManager methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
transaction: aTransaction

    1 to: references size do: [:index |
        references at: index put: (aTransaction referenceAt: (references at: index))]! !

Object subclass: #ODBSerializer
	instanceVariableNames: 'mainObject classCollection classes classesCounter classManager counter externalObjects objects stream referenceManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBSerializer class methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
classDescriptionFor: aClass

    ^ODBClassDescription new createFor: aClass! !

!ODBSerializer class methodsFor: 'public' stamp: ''!
classDescriptionFrom: aStream 
	^ODBClassDescription new loadFromStream: aStream! !

!ODBSerializer class methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
new

	^super new initialize! !

!ODBSerializer class methodsFor: 'public' stamp: 'david@inspiron 2/10/2005 15:25'!
serializeToBytes: anObject 
	"Serialize anObject to bytes."

	| classManager byteStream byteStream2 |
	classManager := ODBClassManagerForSerialization new initializeForSerialization.
	byteStream := ODBMemoryWriteStream new.
	self new 
		serialize: anObject
		onStream: byteStream
		referenceManager: nil
		classManager: classManager.
	byteStream2 := ODBMemoryWriteStream new.
	"brez reference manager-ja"
	byteStream2 putPositiveInteger: 0.
	classManager saveOnStream: byteStream2.
	^byteStream2 asByteArray , byteStream asByteArray! !

!ODBSerializer class methodsFor: 'public' stamp: 'david@inspiron 2/10/2005 15:26'!
serialize: anObject on: aWriteStream 
	| classManager byteStream byteStream2 |
	classManager := ODBClassManagerForSerialization new initializeForSerialization.
	byteStream := ODBMemoryWriteStream new.
	self new 
		serialize: anObject
		onStream: byteStream
		referenceManager: nil
		classManager: classManager.
	byteStream2 := ODBMemoryWriteStream new.
	byteStream2 putPositiveInteger: 0.
	classManager saveOnStream: byteStream2.
	byteStream2 writeOn: aWriteStream.
	byteStream writeOn: aWriteStream! !

!ODBSerializer methodsFor: 'public' stamp: 'david@inspiron 2/11/2005 13:35'!
addExternalReference: anObject objectId: anObjectId 
	"Adds anObject as externaly referenced object.
	If this anObject is encountered during the serialization it will be replaced with an external reference to anObjectId and will not be serialized together."

	| dict |
	(dict := externalObjects at: anObject class) isNil 
		ifTrue: [dict := externalObjects at: anObject class put: anObject class odbGetRegDictionary].
	dict at: anObject put: anObjectId! !

!ODBSerializer methodsFor: 'private' stamp: ''!
cantSave: anObject 
	anObject class name , ' can''t be stored!!' odbSerialize: self! !

!ODBSerializer methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
initialize

	externalObjects := ODBIdentityDictionary new: 127! !

!ODBSerializer methodsFor: 'private' stamp: ''!
registerClass: class 
	| index classInfo |
	(index := classes at: class) isNil 
		ifTrue: 
			[classInfo := classManager register: class.
			stream
				putByte: 2;
				putPositiveInteger: classInfo classID.
			classCollection add: classInfo.
			classes at: class put: (classesCounter := classesCounter + 1).
			^classInfo].
	stream
		putByte: 3;
		putPositiveInteger: index.
	classInfo := classCollection at: index.
	^classInfo! !

!ODBSerializer methodsFor: 'private' stamp: ''!
register: anObject 
	| class dict id |
	(dict := objects at: (class := anObject class)) isNil 
		ifTrue: 
			[(objects at: class put: class odbGetRegDictionary) at: anObject
				put: (counter := counter + 1).
			anObject == mainObject ifTrue: [^false].
			(dict := externalObjects at: class) isNil 
				ifFalse: 
					[(id := dict at: anObject) isNil 
						ifFalse: 
							[self saveExternalReference: id.
							^true]].
			^false].
	(id := dict at: anObject ifAbsentPutValue: counter + 1) > counter 
		ifTrue: 
			[counter := id.
			anObject == mainObject 
				ifFalse: 
					[(dict := externalObjects at: class) isNil 
						ifFalse: 
							[(id := dict at: anObject) isNil 
								ifFalse: 
									[self saveExternalReference: id.
									^true]]].
			^false].
	self saveInternalReference: id.
	^true! !

!ODBSerializer methodsFor: 'private' stamp: ''!
saveExternalReference: anObjectId 
	stream
		putByte: 5;
		putPositiveInteger: (referenceManager addReference: anObjectId)! !

!ODBSerializer methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
saveInternalReference: anInteger
		"Shrani referenco na interni objekt z indeksom anInteger."

	stream putByte: 4; putPositiveInteger: anInteger! !

!ODBSerializer methodsFor: 'public' stamp: 'david@inspiron 2/11/2005 13:51'!
serializeToBytes: anObject 
	| byteStream2 |
	self 
		serialize: anObject
		onStream: ODBMemoryWriteStream new
		referenceManager: ODBReferenceManager new
		classManager: ODBClassManagerForSerialization new initializeForSerialization.
	byteStream2 := ODBMemoryWriteStream new.
	referenceManager saveOnStream: byteStream2.
	classManager saveOnStream: byteStream2.
	^byteStream2 asByteArray , stream asByteArray! !

!ODBSerializer methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
serialize: anObject
	onStream: aStream
	referenceManager: aReferenceManager
	classManager: aClassManager

	| startPos endPos |
	stream := aStream.
	referenceManager := aReferenceManager.
	classManager := aClassManager.
	mainObject := anObject.
	classes := ODBIdentityDictionary new: 31.
	objects := ODBIdentityDictionary new: 63.
	counter := 0.
	classesCounter := 0.
	classCollection := OrderedCollection new: 30.
	startPos := stream position.
	stream putLong: 0.

	mainObject odbSerialize: self.

	endPos := stream position.
	stream
		position: startPos;
		putLong: counter;
		position: endPos.! !

!ODBSerializer methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
stream

    ^stream! !

Object subclass: #ODBSortedDictionary
	instanceVariableNames: 'keys values elementCount currentIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBSortedDictionary class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new initialize! !

!ODBSortedDictionary methodsFor: 'public' stamp: ''!
at: aKey 
	| index |
	(index := self findKey: aKey) > 0 ifTrue: [^values at: index].
	^nil! !

!ODBSortedDictionary methodsFor: 'public/unclassified' stamp: 'cdg 3/14/2003 22:49'!
at: aKey put: value 
	| index |
	(index _ self findKey: aKey) > 0
		ifTrue: [^ values at: index put: value].
	index _ 0 - index.
	elementCount = keys size
		ifTrue: [
			keys _ (Array new: elementCount * 2)
						replaceFrom: 1
						to: elementCount
						with: keys
						startingAt: 1.
			values _ (Array new: elementCount * 2)
						replaceFrom: 1
						to: elementCount
						with: values
						startingAt: 1].
	elementCount _ elementCount + 1.
	"avoid primitive here, it seems Squeak's #replaceFrom:... doesn't handle  
	overlaps."
	elementCount to: index + 1 by: -1 do: [:i | 
		keys at: i put: (keys at: i - 1).
		values at: i put: (values at: i - 1)].
	"keys replaceFrom: index + 1 to: elementCount with: keys startingAt:  
	index. values replaceFrom: index + 1 to: elementCount with: values  
	startingAt: index."
	keys at: index put: aKey.
	^ values at: index put: value! !

!ODBSortedDictionary methodsFor: 'public' stamp: ''!
do: aBlock 
	1 to: elementCount do: [:i | aBlock value: (values at: i)]! !

!ODBSortedDictionary methodsFor: 'private' stamp: ''!
findKey: aKey 
	"Private - Answer index of aKey. If aKey does not 
        exist answer its index as negative integer."

	| a b key i |
	elementCount == 0 ifTrue: [^-1].
	a := 1.
	b := elementCount + 1.
	
	[key := keys at: (i := (a + b) // 2).
	(aKey odbIsLessOrEqualTo: key) 
		ifTrue: 
			[key = aKey ifTrue: [^i].
			b := i]
		ifFalse: [a := i + 1].
	a == b] 
			whileFalse: [].
	^0 - a! !

!ODBSortedDictionary methodsFor: 'public' stamp: ''!
getCurrent
	currentIndex < 1 ifTrue: [^nil].
	^ODBBTreeDictionaryAssociation new setKey: (keys at: currentIndex)
		value: (values at: currentIndex)! !

!ODBSortedDictionary methodsFor: 'public/iterator' stamp: 'cdg 3/13/2003 18:05'!
getFirst

    currentIndex := 1.
    ^ODBBTreeDictionaryAssociation new setKey: (keys at: 1) value: (values at: 1)! !

!ODBSortedDictionary methodsFor: 'public/iterator' stamp: 'cdg 3/13/2003 18:05'!
getLast

    currentIndex := elementCount.
    ^ODBBTreeDictionaryAssociation new
        setKey: (keys at: currentIndex) value: (values at: currentIndex)! !

!ODBSortedDictionary methodsFor: 'public' stamp: ''!
goToNext
	currentIndex := (currentIndex < 1 ifTrue: [0 - currentIndex] ifFalse: [currentIndex + 1]) 
				min: elementCount! !

!ODBSortedDictionary methodsFor: 'public' stamp: ''!
goToPrevious
	currentIndex := currentIndex abs - 1 max: 1! !

!ODBSortedDictionary methodsFor: 'public/iterator' stamp: 'cdg 3/13/2003 18:05'!
goTo: aKey

    currentIndex := self findKey: aKey! !

!ODBSortedDictionary methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
includes: aKey

    ^(self findKey: aKey) > 0! !

!ODBSortedDictionary methodsFor: 'private/initialization' stamp: 'cdg 3/13/2003 18:05'!
initialize

    keys := Array new: 128.
    values := Array new: 128.
    elementCount := 0! !

!ODBSortedDictionary methodsFor: 'public' stamp: ''!
keysAndValuesDo: aBlock 
	1 to: elementCount do: [:i | aBlock value: (keys at: i) value: (values at: i)]! !

!ODBSortedDictionary methodsFor: 'public' stamp: ''!
peekNext
	| i |
	currentIndex < 1 ifTrue: [i := 0 - currentIndex] ifFalse: [i := currentIndex + 1].
	i > elementCount ifTrue: [^nil].
	^ODBBTreeDictionaryAssociation new setKey: (keys at: i) value: (values at: i)! !

!ODBSortedDictionary methodsFor: 'public' stamp: ''!
peekPrevious
	| i |
	i := currentIndex abs - 1.
	i < 1 ifTrue: [^nil].
	^ODBBTreeDictionaryAssociation new setKey: (keys at: i) value: (values at: i)! !

Object subclass: #ODBStream
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBStream class
	instanceVariableNames: 'locks lockingMutex'!

ODBStream subclass: #ODBFileStream
	instanceVariableNames: 'fileHandle mutex pathName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'dg 12/20/2003 19:53'!
accessModeReadOnly
	^#accessModeReadonly! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'cdg 3/13/2003 16:59'!
accessModeReadWrite

	
	^#accessModeReadWrite! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'dg 12/20/2003 19:54'!
cacheModeAtomicWrite
	^#cacheModeAtomicWrite! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'cdg 3/13/2003 16:59'!
createModeCreateAlways

	
	^#createModeCreateAlways! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'dg 12/20/2003 19:54'!
createModeCreateNew
	^#createModeCreateNew! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'ac 2/4/2004 10:22'!
createModeOpenAlways
	^#createModeOpenAlways! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'dg 12/20/2003 19:55'!
createModeOpenExisting
	^#createModeOpenExisting! !

!ODBFileStream class methodsFor: 'create/open' stamp: ''!
createNewOn: pathName
        "Create new file on pathName. Trigger an error 
        if the file allready exists or if it can not be created."

    ^self createOn: pathName
        createMode: self createModeCreateNew
        accessMode: self accessModeReadWrite
        shareMode: self shareModeShareAll! !

!ODBFileStream class methodsFor: 'create/open' stamp: ''!
createOn: pathName
        "Create new file on pathName. Trigger an 
        exception if the file can not be created."

    ^self createOn: pathName
        createMode: self createModeCreateAlways
        accessMode: self accessModeReadWrite
        shareMode: self shareModeShareAll! !

!ODBFileStream class methodsFor: 'create/open' stamp: 'dg 12/20/2003 19:59'!
createOn: pathName createMode: createMode accessMode: accessMode shareMode: shareMode
		"Create new instance of file stream on pathName with given flags."

	^self createOn: pathName
		createMode: createMode
		accessMode: accessMode
		shareMode: shareMode
		cacheMode: nil! !

!ODBFileStream class methodsFor: 'create/open' stamp: 'ac 1/22/2004 16:17'!
createOn: pathName createMode: createMode accessMode: accessMode shareMode: shareMode cacheMode: cacheMode
		"Create new instance of file stream on pathName with given flags."

	| stream fileStreamClass |
	fileStreamClass _
		Smalltalk platformName
			caseOf: 
				{['Win32'] -> [ODBWin32FileStream].
				['unix'] -> [ODBUnixFileStream].}
			otherwise: 
				[self notify: 'File sharing & locking not implemented for this platform'.
				^ self 
					createWithoutSharingAndLockingOn: pathName 
					accessMode: accessMode].
			
	^ fileStreamClass
		createOn: pathName 
		createMode: createMode 
		accessMode: accessMode 
		shareMode: shareMode 
		cacheMode: cacheMode! !

!ODBFileStream class methodsFor: 'create/open' stamp: 'ac 1/22/2004 16:07'!
createWithoutSharingAndLockingOn: pathName accessMode: accessMode
	| stream  |
	stream := FileStream fileNamed: pathName.
	accessMode = #accessModeReadOnly ifTrue: [stream readOnly].
	^self new openOn: pathName fileHandle: stream.! !

!ODBFileStream class methodsFor: 'directory operations' stamp: 'cdg 3/13/2003 16:55'!
directoryCreate: aString


	FileDirectory default createDirectory: aString.
	^true! !

!ODBFileStream class methodsFor: 'directory operations' stamp: 'ac 2/4/2004 14:07'!
directoryExists: aString

	^FileDirectory default directoryExists: aString! !

!ODBFileStream class methodsFor: 'directory operations' stamp: 'cdg 3/13/2003 16:54'!
exists: fileName
		
	"Answer <true> if file named fileName exists."

	
	^FileDirectory default fileExists: fileName! !

!ODBFileStream class methodsFor: 'locking' stamp: 'cdg 6/29/2003 22:35'!
lockAt: pos length: length pathName: pathName fileHandle: fileHandle seekingMutex: seekingMutex position: position
		"Lock portion of file starting at position pos.
		Answer <true> if successfull, <false> otherwise."

	| result lockInterval fileLocks |
	lockInterval := 0 @ pos extent: 1 @ length.
	seekingMutex critical: [
	self lockingMutex critical: [
	(fileLocks := locks at: pathName ifAbsent: []) isNil
		ifFalse: [fileLocks do: [:each | (each first intersects: lockInterval) ifTrue: [^false]]].
	result := true.
	[ fileHandle position: pos; lock: true for: length ]
		on: Error
		do: [ :error | result := false ].
	result
		ifTrue: [
			fileLocks isNil ifTrue: [locks at: pathName put: (fileLocks := OrderedCollection new)].
			fileLocks add: (Array with: lockInterval with: fileHandle) ].
	fileHandle position: position.
	]].
	^result! !

!ODBFileStream class methodsFor: 'locking' stamp: ''!
lockingMutex

	lockingMutex isNil
		ifTrue: [
			lockingMutex := Semaphore forMutualExclusion.
			locks := Dictionary new ].
	^lockingMutex! !

!ODBFileStream class methodsFor: 'create/open' stamp: 'dg 12/20/2003 19:58'!
openExclusivelyOn: pathName
		"Open an existing file on pathName exclusively so that no-one else can open it.
		Trigger an exception if the file can not be opened."

	^self createOn: pathName
		createMode: self createModeOpenExisting
		accessMode: self accessModeReadWrite
		shareMode: self shareModeShareNone! !

!ODBFileStream class methodsFor: 'create/open' stamp: ''!
openOn: pathName
        "Open an existing file on pathName. Trigger an 
        exception if the file can not be opened."

    ^self createOn: pathName
        createMode: self createModeOpenExisting
        accessMode: self accessModeReadWrite
        shareMode: self shareModeShareAll! !

!ODBFileStream class methodsFor: 'create/open' stamp: 'dg 12/20/2003 19:58'!
openReadOnlyOn: pathName 
	"Open an existing file on pathName. Trigger an 
        exception if the file can not be opened."

	^self 
		createOn: pathName
		createMode: self createModeOpenExisting
		accessMode: self accessModeReadOnly
		shareMode: self shareModeShareAll! !

!ODBFileStream class methodsFor: 'public' stamp: 'dg 12/20/2003 09:15'!
pathSeparatorString

	^(String with: FileDirectory pathNameDelimiter)
! !

!ODBFileStream class methodsFor: 'locking' stamp: 'cdg 6/29/2003 22:34'!
releaseAllLocksFor: pathName fileHandle: fileHandle

	| newFileLocks fileLocks |
	self lockingMutex critical: [
	fileLocks := locks at: pathName ifAbsent: [^self].
	newFileLocks := OrderedCollection new.
	fileLocks do: [:each |
		each last == fileHandle
			ifFalse: [newFileLocks add: each]
			ifTrue: [
				[ fileHandle position: each first top; lock: false for: each first height ]
					on: Error
					do: [ :error | ]]].
	newFileLocks isEmpty
		ifTrue: [locks removeKey: pathName]
		ifFalse: [locks at: pathName put: newFileLocks].
	].! !

!ODBFileStream class methodsFor: 'directory operations' stamp: 'ac 2/4/2004 12:05'!
remove: fileName
	"Remove file named fileName. Answer <true> if successful, <false> if failed."

	[ (FileDirectory default 
		deleteFileNamed: fileName 
		ifAbsent: [FileDoesNotExistException signal]). ^true ]
			on: Error
			do: [:ex | ^false ]! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'dg 12/20/2003 19:55'!
shareModeShareAll
	^#shareModeShareAll! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'dg 12/20/2003 19:55'!
shareModeShareNone
	^#shareModeShareNone! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'dg 12/20/2003 19:55'!
shareModeShareRead
	^#shareModeShareRead! !

!ODBFileStream class methodsFor: 'create/open flags' stamp: 'jf 2/6/2004 11:54'!
shareModeShareWrite
	^#shareModeShareWrite! !

!ODBFileStream class methodsFor: 'locking' stamp: 'cdg 6/29/2003 22:42'!
unlockAt: pos length: length pathName: pathName fileHandle: fileHandle seekingMutex: seekingMutex position: position
		"Unlock portion of file at position pos. 
		Answer <true> if successfull, <false> if failed."

	| result lockInterval newFileLocks fileLocks |
	seekingMutex critical: [
	self lockingMutex critical: [
	(fileLocks := locks at: pathName ifAbsent: []) isNil ifTrue: [^false].
	lockInterval := 0 @ pos extent: 1 @ length.
	newFileLocks := OrderedCollection new.
	fileLocks do: [:each |
		((each first intersects: lockInterval) and: [each last == fileHandle])
			ifFalse: [newFileLocks add: each]
			ifTrue: [each first = lockInterval ifFalse: [self error: 'Partial unlock is not allowed']]].
	newFileLocks isEmpty
		ifTrue: [locks removeKey: pathName]
		ifFalse: [locks at: pathName put: newFileLocks].
	result := true.
	[ fileHandle position: pos; lock: false for: length ]
		on: Error
		do: [ :error | result := false ].
	fileHandle position: position.
	]].
	^result! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 09:07'!
atPositionGetLong: pos 
	"Read long integer from stream. 
	Answer <nil> if end of file has been reached."

	| buf |
	buf := ByteArray new: 4.
	^(self 
		atPosition: pos
		getBytesFor: buf
		len: 4) == 4 
		ifTrue: [buf odbLongAt: 1]! !

!ODBFileStream methodsFor: 'public' stamp: ''!
atPosition: anInteger getBytesFor: aByteCollection 
	"Read bytes from stream at position anInteger. 
        Answer number of bytes actualy read."

	| result |
	mutex critical: 
			[result := self
						basicPosition: anInteger;
						basicGetBytesFor: aByteCollection len: aByteCollection size].
	^result! !

!ODBFileStream methodsFor: 'public' stamp: ''!
atPosition: anInteger getBytesFor: aByteCollection len: len 
	"Read len bytes from stream at position anInteger to aByteCollection. 
        Answer number of bytes actualy read."

	| result |
	mutex critical: 
			[result := self
						basicPosition: anInteger;
						basicGetBytesFor: aByteCollection len: len].
	^result! !

!ODBFileStream methodsFor: 'public' stamp: ''!
atPosition: pos putBytesFrom: aByteCollection 
	"Write bytes from aByteCollection to file."

	mutex critical: 
			[self
				basicPosition: pos;
				basicPutBytesFrom: aByteCollection len: aByteCollection size]! !

!ODBFileStream methodsFor: 'public' stamp: ''!
atPosition: pos putBytesFrom: aByteCollection len: len 
	"Write len bytes from aByteCollection to file."

	mutex critical: 
			[self
				basicPosition: pos;
				basicPutBytesFrom: aByteCollection len: len]! !

!ODBFileStream methodsFor: 'public' stamp: ''!
atPosition: pos putLong: anInteger 
	| buf |
	buf := ByteArray new: 4.
	buf odbLongAt: 1 put: anInteger.
	self 
		atPosition: pos
		putBytesFrom: buf
		len: 4! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 09:11'!
basicGetBytesFor: aByteCollection len: len
		"Read len bytes from stream to aByteCollection. 
		Answer number of bytes actualy read."

	^fileHandle flush; readInto: aByteCollection startingAt: 1 for: len! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 09:12'!
basicPosition: anInteger
	"Positiones stream to anInteger. Answer anInteger."

	fileHandle position: anInteger.
	^position := anInteger
! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 09:12'!
basicPutBytesFrom: aByteArray len: length 
	(fileHandle
		writeFrom: aByteArray
		startingAt: 1
		for: length)
		= length ifFalse: [OmniBase signalError: 'Could not write the whole data'].
	fileHandle flush.
	position := position + length.
	^self
! !

!ODBFileStream methodsFor: 'public' stamp: 'jf 5/26/2004 11:53'!
close
		"Close file associatied with receiver."

	fileHandle notNil ifTrue: [
		self class releaseAllLocksFor: pathName fileHandle: fileHandle.
		fileHandle closed ifFalse: [fileHandle close]].
	fileHandle := nil.! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 09:59'!
compare: aString at: pos 
	"Answer <true>, if aString is stored at pos."

	| str str2 len |
	len := aString size.
	str := String new: len.
	(self 
		atPosition: pos
		getBytesFor: str
		len: len) == len ifFalse: [^false].
	str := str select: [:each | each isDigit or: [each isLetter]].
	str2 := aString select: [:each | each isDigit or: [each isLetter]].
	^str = str2! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 21:05'!
finalize
	self close! !

!ODBFileStream methodsFor: 'public' stamp: 'cdg 3/13/2003 19:07'!
flush
		"Force all data written to the 
		receiver to be recorded on disk."

	fileHandle flush! !

!ODBFileStream methodsFor: 'public' stamp: ''!
getByte
	"Read byte from file stream. Answer <nil> if
	end of file has been reached."

	| buf |
	buf := ByteArray new: 1.
	^(self getBytesFor: buf len: 1) == 1 ifTrue: [buf at: 1]! !

!ODBFileStream methodsFor: 'public' stamp: ''!
getBytesFor: aByteCollection len: len 
	"Read len bytes from stream to aByteCollection. 
	Answer number of bytes actualy read."

	| result |
	mutex critical: [result := self basicGetBytesFor: aByteCollection len: len].
	^result! !

!ODBFileStream methodsFor: 'public' stamp: ''!
getLong
	"Read long integer from stream. 
	Answer <nil> if end of file has been reached."

	| buf |
	buf := ByteArray new: 4.
	^(self getBytesFor: buf len: 4) == 4 ifTrue: [buf odbLongAt: 1]! !

!ODBFileStream methodsFor: 'public' stamp: ''!
getWord
	"Read word from file stream.
	Answer <nil> if end of file has been reached."

	| buf |
	buf := ByteArray new: 2.
	^(self getBytesFor: buf len: 2) == 2 ifTrue: [buf odbShortAt: 1]! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 09:08'!
lockAt: pos length: length
		"Lock portion of file starting at position pos. 
		Answer <true> if successfull, <false> if failed.
		Also sets an internal lock to prevent setting lock twice.
		Unix style fcntl locking will answer true if a lock is set twice.
		For OmniBase this is not allowed."

	^self class lockAt: pos length: length pathName: pathName fileHandle: fileHandle seekingMutex: mutex position: position! !

!ODBFileStream methodsFor: 'public' stamp: ''!
name

    ^pathName! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 09:08'!
openOn: aString fileHandle: anIOAccessor
		"Private - Initialize receiver."

	pathName := aString.
	fileHandle := anIOAccessor.
	position := 0.
	mutex := Semaphore forMutualExclusion.! !

!ODBFileStream methodsFor: 'public' stamp: ''!
pathName

    ^pathName! !

!ODBFileStream methodsFor: 'public' stamp: ''!
position

	^position! !

!ODBFileStream methodsFor: 'public' stamp: ''!
position: anInteger 
	"Positiones stream to anInteger. Answer anInteger."

	| result |
	mutex critical: [result := self basicPosition: anInteger].
	^result! !

!ODBFileStream methodsFor: 'private' stamp: ''!
printOn: aStream 
	aStream nextPutAll: 'ODBFileStream on: ''' , pathName , ''''! !

!ODBFileStream methodsFor: 'public' stamp: ''!
putBytesFrom: aByteCollection len: len 
	"Write len bytes from aByteCollection to file."

	mutex critical: [self basicPutBytesFrom: aByteCollection len: len]! !

!ODBFileStream methodsFor: 'public' stamp: ''!
putByte: anInteger

    self putBytesFrom: (ByteArray with: anInteger) len: 1! !

!ODBFileStream methodsFor: 'public' stamp: ''!
putLong: anInteger 
	| buf |
	buf := ByteArray new: 4.
	buf odbLongAt: 1 put: anInteger.
	self putBytesFrom: buf len: 4! !

!ODBFileStream methodsFor: 'public' stamp: ''!
putWord: anInteger 
	| buf |
	buf := ByteArray new: 2.
	buf odbShortAt: 1 put: anInteger.
	self putBytesFrom: buf len: 2! !

!ODBFileStream methodsFor: 'public' stamp: ''!
remove
        "Close and remove receiver. Answer <true> if removed."

    self close.
    ^self class remove: pathName! !

!ODBFileStream methodsFor: 'public' stamp: 'cdg 3/13/2003 19:22'!
size
		"Answer the size of the file in bytes or
		signal a FileException if the operation fails."

	^fileHandle size! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 09:09'!
truncate: anInteger 
	"Truncate stream so that its size will be anInteger. 
        Position to anInteger."

	mutex critical: 
			[self basicPosition: anInteger.
			fileHandle truncate: anInteger]! !

!ODBFileStream methodsFor: 'public' stamp: 'dg 12/20/2003 09:09'!
unlockAt: pos length: length
		"Unlock portion of file at position pos.
		Answer <true> if successfull, <false> if failed."

	^self class unlockAt: pos length: length pathName: pathName fileHandle: fileHandle seekingMutex: mutex position: position! !

ODBFileStream subclass: #ODBUnixFileStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBUnixFileStream commentStamp: '' prior: 0!
This class implements an ODBFileStream for *nix filesystems using the locking mechanism provided in the OSProcess package.

The main thing it needs to do is map the various windows-like mode flags to Unix equivalents.  The ugliest ones to map (aside from FILE_FLAG_ATOMIC_WRITE and FILE_FLAG_SEQUENTIAL_SCAN, which we ignore) are the share mode flags.

In Windows, when you open a file you can specify what read modes will succeed on future calls to open the same file.  So, if you specify FILE_SHARE_READ but not FILE_SHARE_WRITE, another application would be able to open the file in read mode but not in read-write mode. Unix does not support this concept since locks are advisory and have no effect on an whether another application can open a file for reading or writing later.
	
The best approximation I can come up with is to lock a special byte.  If you want to write to the file you need to able to get a write-lock on that byte.  If you only want to read the file, you only need to be able to read-lock that byte.  Note that you don't actually perform this lock, you just test for it.  Then you lock the byte based on what you want to allow other applications to do.!

!ODBUnixFileStream class methodsFor: 'private' stamp: 'jf 2/23/2004 20:07'!
createFileStreamForPath: pathString createMode: createMode
	^ FileStream concreteStream
			perform: (self streamCreationSelectorForMode: createMode)
			with: pathString! !

!ODBUnixFileStream class methodsFor: 'create/open' stamp: 'jf 2/23/2004 20:11'!
createOn: pathString createMode: createMode accessMode: accessMode shareMode: shareMode cacheMode: cacheMode
	| stream needsWrite |

	stream _ self createFileStreamForPath: pathString createMode: createMode.
	
	^	[self ensureAccessMode: accessMode forFileStream: stream.
		self setShareMode: shareMode forFileStream: stream.
	
		self new openOn: pathString fileHandle: stream]
			ifCurtailed: [stream close. nil]! !

!ODBUnixFileStream class methodsFor: 'private' stamp: 'jf 2/23/2004 20:05'!
ensureAccessMode: accessMode forFileStream: aFileStream
	"Check the special byte is appropriately set to allow the desired access mode.  Signal a locking conflict if there is a problem.
	See the class comment for more information on what's going on here."
	
	| needsWriteAccess |
	needsWriteAccess _ (accessMode = self accessModeReadOnly) not.
	(OSProcess accessor
		isLockableFile: aFileStream
		from: self shareModeFlagLocation
		to: self shareModeFlagLocation
		exclusive: needsWriteAccess)
			ifFalse: [ODBLockingConflict signal].! !

!ODBUnixFileStream class methodsFor: 'locking' stamp: 'jf 2/26/2004 20:25'!
releaseAllLocksFor: pathName fileHandle: fileHandle
	OSProcess accessor unlockAllForFile: fileHandle! !

!ODBUnixFileStream class methodsFor: 'private' stamp: 'jf 2/23/2004 20:16'!
setShareMode: shareMode forFileStream: aFileStream
	"Set the special byte appropriately for the desired share mode.  Signal a locking conflict if there is a problem.
	See the class comment for more information on what's going on here."
	
	| flagState |
	flagState _ shareMode caseOf: {
			[self shareModeShareAll] -> [nil].
			[self shareModeShareRead] -> [false].
			[self shareModeShareNone] -> [true].
			[self shareModeShareWrite] -> [self halt] "don't know how to implement this on unix and it is currently unused"}.

	flagState ifNotNil:
		[(OSProcess accessor
			lockFile: aFileStream
			from: self shareModeFlagLocation
			to: self shareModeFlagLocation
			exclusive: flagState)
				ifNil: [ODBLockingConflict signal]].! !

!ODBUnixFileStream class methodsFor: 'private' stamp: 'jf 2/23/2004 21:01'!
shareModeFlagLocation
	"This is the byte location at which the share mode lock is made (see the class comment for details).  This value should probably be less than ODBObjectHolder>>lockStartPosition to avoid conflicts, though it appears that the index file is currently always opened with #shareModeShareAll, so we are actually probably fine in practice."
	
	^ 999999999! !

!ODBUnixFileStream class methodsFor: 'private' stamp: 'jf 2/23/2004 20:07'!
streamCreationSelectorForMode: createMode
	^ createMode caseOf:  {
		[self createModeCreateAlways] -> [#forceNewFileNamed:].
		[self createModeCreateNew] -> [#newFileNamed:].
		[self createModeOpenAlways] -> [#fileNamed:].
		[self createModeOpenExisting] -> [#oldFileNamed:]}
! !

!ODBUnixFileStream methodsFor: 'public' stamp: 'jf 2/23/2004 19:09'!
lockAt: pos length: length
	^ (OSProcess accessor lockFile: fileHandle from: pos to: pos + length -1) notNil! !

!ODBUnixFileStream methodsFor: 'as yet unclassified' stamp: 'avi 5/17/2005 15:46'!
size
	"the unix Squeak VM gives the wrong answer for #size"
	| file |
	fileHandle flush.
	file _ fileHandle readOnlyCopy.
	^ [file size] ensure: [file close]
	

! !

!ODBUnixFileStream methodsFor: 'public' stamp: 'jf 2/23/2004 19:08'!
unlockAt: pos length: length
	^ (OSProcess accessor unlockFile: fileHandle from: pos to: pos + length -1) notNil! !

ODBFileStream subclass: #ODBWin32FileStream
	instanceVariableNames: 'externalLong'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBWin32FileStream class methodsFor: 'instance creation' stamp: 'dg 12/20/2003 20:14'!
createOn: pathName createMode: createMode accessMode: accessMode shareMode: shareMode cacheMode: cacheMode
	"Private - Create new instance of file stream on pathName with given flags.
	This is Win32 API specific implementation."

	| crMode acMode shMode caMode |
	crMode := 0.
	createMode = #createModeCreateAlways ifTrue: [crMode := 2 "CREATE_ALWAYS"].
	createMode = #createModeCreateNew ifTrue: [crMode := 1 "CREATE_NEW"].
	createMode = #createModeOpenAlways ifTrue: [crMode := 4 "OPEN_ALWAYS"].
	createMode = #createModeOpenExisting ifTrue: [crMode := 3 "OPEN_EXISTING"].
	acMode := 0.
	accessMode = #accessModeReadOnly ifTrue: [acMode := 2147483648 "GENERIC_READ"].
	accessMode = #accessModeReadWrite ifTrue: [acMode := 3221225472 "GENERIC_READ | GENERIC_WRITE"].
	accessMode = #accessModeWriteOnly ifTrue: [acMode := 1073741824 "GENERIC_WRITE"].
	shMode := 0.
	shareMode = #shareModeShareAll ifTrue: [shMode := 3 "FILE_SHARE_READ | FILE_SHARE_WRITE"].
	shareMode = #shareModeShareNone ifTrue: [shMode := 0].
	shareMode = #shareModeShareRead ifTrue: [shMode := 1 "FILE_SHARE_READ"].
	shareMode = #shareModeShareWrite ifTrue: [shMode := 2 "FILE_SHARE_WRITE"].
	caMode := 0.
	cacheMode = #cacheModeAtomicWrite ifTrue: [caMode := 512  "FILE_FLAG_ATOMIC_WRITE"].
	cacheMode = #cacheModeSequentialScan ifTrue: [caMode := 134217728 "FILE_FLAG_SEQUENTIAL_SCAN"].
	^self new createOn: pathName createMode: crMode accessMode: acMode shareMode: shMode cacheMode: caMode
! !

!ODBWin32FileStream methodsFor: 'private' stamp: 'dg 12/20/2003 22:11'!
basicGetBytesFor: aByteCollection len: len 
	"Private - Read len bytes from stream to aByteCollection. 
	Answer number of bytes actualy read."

	| startTime currentTime errorCode |
	(self 
		readFile: fileHandle
		lpBuffer: aByteCollection
		nNumberOfBytesToRead: len
		lpNumberOfBytesRead: externalLong
		lpOverlapped: nil) = 0
			ifTrue: 
				[currentTime := startTime := Time millisecondClockValue.
				
				[errorCode := self getLastError.
				errorCode = 33 or: [errorCode = 5	"access denied"]	"lock violation"] 
						whileTrue: 
							[currentTime - startTime < 12 
								ifFalse: 
									[ODBStreamLockedNotification signal 
										ifTrue: [startTime := currentTime]
										ifFalse: [self fileIOError: errorCode]].
							(self 
								readFile: fileHandle
								lpBuffer: aByteCollection
								nNumberOfBytesToRead: len
								lpNumberOfBytesRead: externalLong
								lpOverlapped: nil) = 0 ifFalse: [^externalLong odbLongAt: 1].
							currentTime := Time millisecondClockValue.
							currentTime < startTime ifTrue: [currentTime := currentTime + 86400000]].
				self fileIOError: errorCode].
	^externalLong odbLongAt: 1! !

!ODBWin32FileStream methodsFor: 'private' stamp: 'dg 12/20/2003 21:07'!
basicPosition: anInteger 
	"Private - Positiones stream to anInteger. Answer anInteger."

	| result |
	result := self 
				setFilePointer: fileHandle
				lDistanceToMove: anInteger
				lpDistanceToMoveHigh: nil
				dwMoveMethod: 0. "FILE_BEGIN"
	^16rFFFFFFFF = result ifFalse: [result] ifTrue: [self fileIOError]! !

!ODBWin32FileStream methodsFor: 'private' stamp: 'dg 12/20/2003 22:03'!
basicPutBytesFrom: aByteCollection len: len 
	"Private - Write len bytes from aByteCollection to file."

	(self 
		writeFile: fileHandle
		lpBuffer: aByteCollection asByteArray
		nNumberOfBytesToWrite: len
		lpNumberOfBytesWritten: externalLong
		lpOverlapped: nil) = 0 ifTrue: [self fileIOError]! !

!ODBWin32FileStream methodsFor: 'public' stamp: 'dg 12/20/2003 21:04'!
close
	"Close file associatied with receiver."

	self closeHandle: fileHandle.
	fileHandle := nil.! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:00'!
closeHandle: aHandle
	"Close an open Win32 object handle, freeing any resources held by it.
	Once closed a handle is no longer valid. Answer whether the function
	succeeds.	 See Win32 SDK help for more information.

	BOOL CloseHandle(
		HANDLE  hObject 	// handle of object to close  
	);"

	<apicall: ulong 'CloseHandle' (long) module:'kernel32.dll'>
	^self externalCallFailed! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:00'!
createFile: aStringFileName dwDesiredAccess: anIntegerAccessMode dwSharedMode: anIntegerShareMode 
		lpSecurityAttributes: aSECURITYATTRIBUTES dwCreationDistribution: anIntegerCreateMode 
		dwFlagsAndAttributes: anIntegerAttributeFlag hTemplateFile: aHandle
	"The CreateFile function creates, opens, or truncates a file, pipe, communications resource, disk device,
	or console. Answer a handle that can be used to access the object. It can also open and return a handle to a directory.

	HANDLE CreateFile(
		LPCTSTR lpFileName, // address of name of the file 
		DWORD dwDesiredAccess, // access (read-write) mode 
		DWORD dwShareMode, // share mode 
		LPSECURITY_ATTRIBUTES lpSecurityAttributes, // address of security descriptor 
		DWORD dwCreationDistribution, // how to create 
		DWORD dwFlagsAndAttributes, // file attributes 
		HANDLE hTemplateFile // handle of file with attributes to copy  
	);
	Please see Win32 SDK help for more information."

	<apicall: long 'CreateFileA' (char* ulong ulong void* ulong ulong long) module:'kernel32.dll'>
	^self externalCallFailed! !

!ODBWin32FileStream methodsFor: 'private' stamp: 'dg 12/20/2003 22:43'!
createOn:  aPathname createMode: createMode accessMode: accessMode shareMode: shareMode cacheMode: cacheMode 
	| fd |
	2 timesRepeat: [(fd := self
				createFile: aPathname
				dwDesiredAccess: accessMode
				dwSharedMode: shareMode
				lpSecurityAttributes: nil
				dwCreationDistribution: createMode
				dwFlagsAndAttributes: (128 bitOr: cacheMode) "FILE_ATTRIBUTE_NORMAL | cacheMode"
				hTemplateFile: nil) = -1 "INVALID_HANDLE_VALUE "
		ifFalse: [^self openOn: aPathname fileHandle: fd].
	(Delay forMilliseconds: 500) wait.
	].
	self fileIOError! !

!ODBWin32FileStream methodsFor: 'private' stamp: 'dg 12/20/2003 22:11'!
fileIOError
	self fileIOError: self getLastError! !

!ODBWin32FileStream methodsFor: 'private' stamp: 'dg 12/20/2003 22:46'!
fileIOError: errorCode

	| description |
	description := '<no error description available>'.
	errorCode = 6 ifTrue: [description := 'Invalid handle'].
	errorCode = 183 ifTrue: [description := 'File already exists'].
	errorCode = 2 ifTrue: [description := 'File not found'].
	errorCode = 5 ifTrue: [description := 'Access denied'].
	errorCode = 80 ifTrue: [description := 'The file exists'].
	OmniBase signalError: 'File I/O error number ', errorCode printString, ' ', description! !

!ODBWin32FileStream methodsFor: 'public' stamp: 'dg 12/20/2003 21:13'!
flush
	"Force all data written to the receiver to be recorded on disk."

	(self flushFileBuffers: fileHandle) = 0 ifTrue: [self fileIOError]! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:00'!
flushFileBuffers: aHandle
	"The FlushFileBuffers function clears the buffers for the specified file
	and causes all buffered data to be written to the file. 
	Answer a boolean indicating if the operation was successful.

	BOOL FlushFileBuffers(
		HANDLE hFile // open handle to file whose buffers are to be flushed 
		);"

	<apicall: ulong 'FlushFileBuffers' (long) module:'kernel32.dll'>
	^self externalCallFailed! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:00'!
getFileSize: aHandle lpFileSizeHigh: aDWORD
	"Answers the low-order dword of the size, in bytes, of the specified file. 

		DWORD GetFileSize(
			HANDLE hFile, // handle of file to get size of
			LPDWORD lpFileSizeHigh, // address of high-order word for file size if required.
		);"

	<apicall: ulong 'GetFileSize' (long ulong) module:'kernel32.dll'>
	^self externalCallFailed
! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:10'!
getLastError
	"Answer the last Win32 error code which occurred.
		DWORD GetLastError(VOID)"
  
	<apicall: ulong 'GetLastError' () module:'kernel32.dll'>
	^self externalCallFailed! !

!ODBWin32FileStream methodsFor: 'public' stamp: 'dg 12/20/2003 22:09'!
lockAt: pos length: length 
	"Lock portion of file starting at position pos. 
	Answer <true> if successfull."

	| errorCode |
	(self 
		lockFile: fileHandle
		offsetLow: pos
		offsetHigh: 0
		lengthLow: length
		lengthHigh: 0) = 0 ifFalse: [^true].
	"is lock violation ?"
	(errorCode := self getLastError) = 33 ifTrue: [^false].
	^self fileIOError: errorCode! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:00'!
lockFile: aHandle
    offsetLow: loPos offsetHigh: hiPos
    lengthLow: loLength lengthHigh: hiLength

	<apicall: long 'LockFile' (long ulong ulong ulong ulong) module: 'kernel32.dll'>
	^self externalCallFailed! !

!ODBWin32FileStream methodsFor: 'private' stamp: 'dg 12/20/2003 21:14'!
openOn: aString fileHandle: win32Handle
	"Private - Initialize receiver."

	pathName := aString.
	fileHandle := win32Handle.
	mutex := Semaphore forMutualExclusion.
	externalLong := ByteArray new: 4.! !

!ODBWin32FileStream methodsFor: 'public' stamp: 'dg 12/20/2003 21:11'!
position
	| pos |
	pos := self 
				setFilePointer: fileHandle
				lDistanceToMove: 0
				lpDistanceToMoveHigh: nil
				dwMoveMethod: 1. "FILE_CURRENT"
	^16rFFFFFFFF = pos ifFalse: [pos] ifTrue: [self fileIOError]! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:06'!
readFile: aHandle lpBuffer: anAddress nNumberOfBytesToRead: anIntegerBytesToRead
		lpNumberOfBytesRead: anAddressBytesRead lpOverlapped: anOVERLAPPED
	"The ReadFile function reads data from a file, starting at the position indicated by the file pointer.
	After the read operation has been completed, the file pointer is adjusted by the number of bytes actually read,
	unless the file handle is created with the overlapped attribute. If the file handle is created for overlapped
	input and output (I/O), the application must adjust the position of the file pointer after the read operation. 

	BOOL ReadFile(
		HANDLE hFile, // handle of file to read 
		LPVOID lpBuffer, // address of buffer that receives data  
		DWORD nNumberOfBytesToRead, // number of bytes to read 
		LPDWORD lpNumberOfBytesRead, // address of number of bytes read 
		LPOVERLAPPED lpOverlapped // address of structure for data 
		);

	Answer a boolean indicating whether the function succeeds. If successful and bytesRead is left set to zero,
	the file pointer was beyond the current end of the file at the time of the read operation."

	<apicall: long 'ReadFile' (long void* ulong void* void*) module:'kernel32.dll'>
	^self externalCallFailed! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:00'!
setEndOfFile: aHandle

	<apicall: long 'SetEndOfFile' (long) module: 'kernel32.dll'>
	^self externalCallFailed! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:00'!
setFilePointer: aHandle lDistanceToMove: loInteger lpDistanceToMoveHigh: anAddress dwMoveMethod: senseOfMove
	"Moves the file pointer of an open file. 

	DWORD SetFilePointer(
		HANDLE hFile, 				// handle of file 
		LONG lDistanceToMove, 		// number of bytes to move file pointer 
		PLONG lpDistanceToMoveHigh, // address of high-order word of distance to move  
		DWORD dwMoveMethod 			// how to move 
		);"

	<apicall: ulong 'SetFilePointer' (long long void* ulong) module: 'kernel32.dll'>
	^self externalCallFailed! !

!ODBWin32FileStream methodsFor: 'public' stamp: 'dg 12/20/2003 21:01'!
size
	"Answer the size of the file in bytes or
	signal a FileException if the operation fails."

	| result |
	result := self getFileSize: fileHandle lpFileSizeHigh: nil.
	^16rFFFFFFFF = result ifFalse: [result] ifTrue: [self fileIOError]! !

!ODBWin32FileStream methodsFor: 'public' stamp: 'dg 12/20/2003 20:56'!
truncate: anInteger 
	"Truncate stream so that its size will be anInteger. 
	Position to anInteger."

	mutex critical: 
			[self basicPosition: anInteger.
			(self setEndOfFile: fileHandle) = 0 ifTrue: [self fileIOError]]! !

!ODBWin32FileStream methodsFor: 'public' stamp: 'dg 12/20/2003 20:58'!
unlockAt: pos length: length 
	"Unlock portion of file at position pos. 
	Answer <true> if successfull, <false> if failed."

	^(self
		unlockFile: fileHandle
		offsetLow: pos
		offsetHigh: 0
		lengthLow: length
		lengthHigh: 0) ~= 0! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:07'!
unlockFile: aHandle
    offsetLow: loPos offsetHigh: hiPos
    lengthLow: loLength lengthHigh: hiLength

	<apicall: long 'UnlockFile' (long ulong ulong ulong ulong) module: 'kernel32.dll'>
	^self externalCallFailed! !

!ODBWin32FileStream methodsFor: 'Win32 primitives' stamp: 'dg 12/20/2003 22:04'!
writeFile: aHandle lpBuffer: anAddress nNumberOfBytesToWrite: anIntegerBytesToWrite 
		lpNumberOfBytesWritten: anAddressBytesWritten lpOverlapped: anOVERLAPPED
	"The WriteFile function writes data to a file and is designed for both synchronous and asynchronous operation.
	The function starts writing data to the file at the position indicated by the file pointer. After the write
	operation has been completed, the file pointer is adjusted by the number of bytes actually written, except when
	the file is opened with FILE_FLAG_OVERLAPPED. If the file handle was created for overlapped input and output
	(I/O), the application must adjust the position of the file pointer after the write operation is finished. 

	BOOL WriteFile(
		HANDLE hFile, // handle of file to write to 
		LPCVOID lpBuffer, // address of data to write to file 
		DWORD nNumberOfBytesToWrite, // number of bytes to write 
		LPDWORD lpNumberOfBytesWritten, // address of number of bytes written 
		LPOVERLAPPED lpOverlapped // addr. of structure needed for overlapped I/O  
		);

	Answer a boolean indicating whether the function succeeds."

	<apicall: long 'WriteFile' (long void* ulong void* void*) module:'kernel32.dll'>
	^self externalCallFailed! !

ODBStream subclass: #ODBMemoryReadStream
	instanceVariableNames: 'current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBMemoryReadStream class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
createOn: bytes

    ^self new createOn: bytes! !

!ODBMemoryReadStream class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
readFrom: aStream

    ^self new readFrom: aStream! !

!ODBMemoryReadStream methodsFor: 'initializing' stamp: 'cdg 3/13/2003 18:06'!
createOn: aByteArray

    position := 0.
    current := aByteArray! !

!ODBMemoryReadStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
getByte

    ^current at: (position := position + 1)! !

!ODBMemoryReadStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
getBytesFor: aByteCollection len: len

    aByteCollection
        replaceFrom: 1
        to: len
        with: current
        startingAt: position + 1.
    position := position + len! !

!ODBMemoryReadStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
getChar

    ^Character value: (current at: (position := position + 1))! !

!ODBMemoryReadStream methodsFor: 'public' stamp: 'dg 4/30/2005 16:02'!
getLong
	position := position + 4.
	^current odbLongAt: position - 3! !

!ODBMemoryReadStream methodsFor: 'public' stamp: 'dg 4/30/2005 16:03'!
getPositiveInteger
	"Answer the next Integer encoded in the receiver. 
	Works for one collection only."

	| answer |
	(answer := current at: (position := position + 1)) > 127 ifFalse: [^answer].
	^(self getPositiveInteger bitShift: 7) bitOr: (answer bitAnd: 127)! !

!ODBMemoryReadStream methodsFor: 'public' stamp: 'dg 4/30/2005 16:02'!
getWord
	position := position + 2.
	^current odbShortAt: position - 1! !

!ODBMemoryReadStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
position
        "Answer current position on stream."

    ^position! !

!ODBMemoryReadStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
position: anInteger

    position := anInteger! !

!ODBMemoryReadStream methodsFor: 'initializing' stamp: 'cdg 3/13/2003 18:06'!
readFrom: aStream
        "Read receivers contents from aStream."

    | size |
    size := aStream getLong.
    aStream position + size > aStream size ifTrue: [^self error: 'Read beyond stream size !!'].
    current := ByteArray new: size.
    aStream getBytesFor: current len: size.
    position := 0! !

!ODBMemoryReadStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
size

    ^current size! !

ODBStream subclass: #ODBMemoryWriteStream
	instanceVariableNames: 'collections current readLimit lastSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBMemoryWriteStream class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:06'!
new

    ^super new initialize! !

!ODBMemoryWriteStream methodsFor: 'public' stamp: ''!
asByteArray
	"Answer receiver as byte array."

	| i bytes pos len coll bytesSize |
	bytes := ByteArray new: (bytesSize := self size).
	pos := 0.
	i := 1.
	
	[coll := collections at: i.
	len := coll size.
	pos + len < bytesSize] whileTrue: 
				[bytes 
					replaceFrom: pos + 1
					to: (pos := pos + len)
					with: coll
					startingAt: 1.
				i := i + 1].
	bytes 
		replaceFrom: pos + 1
		to: bytesSize
		with: coll
		startingAt: 1.
	^bytes! !

!ODBMemoryWriteStream methodsFor: 'public' stamp: ''!
asStringObject
	"Answer receiver as string
        (selector #asString is not used because of printing on screen)."

	| i string pos len coll bytesSize |
	string := String new: (bytesSize := self size).
	pos := 0.
	i := 1.
	
	[coll := collections at: i.
	len := coll size.
	pos + len < bytesSize] whileTrue: 
				[string 
					replaceFrom: pos + 1
					to: (pos := pos + len)
					with: coll
					startingAt: 1.
				i := i + 1].
	string 
		replaceFrom: pos + 1
		to: bytesSize
		with: coll
		startingAt: 1.
	^string! !

!ODBMemoryWriteStream methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
initialize

    collections := OrderedCollection new.
    readLimit := 0.
    position := 0! !

!ODBMemoryWriteStream methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
makeSpace
        "Private - Add space on end of stream (add new collection)."

    collections add: (current := ByteArray new: (readLimit := 1024)).
    position := 0.
    lastSize := 0! !

!ODBMemoryWriteStream methodsFor: 'private' stamp: ''!
moveToNext
	"Private - Move to next collection or
        add space on end of stream if at last collection."

	position := 0.
	(current isNil or: [current == collections last]) 
		ifTrue: 
			[collections add: (current := ByteArray new: (readLimit := 1024)).
			lastSize := 0]
		ifFalse: 
			[1 to: collections size
				do: [:i | (collections at: i) == current ifTrue: [^current := collections at: i + 1]]]! !

!ODBMemoryWriteStream methodsFor: 'public' stamp: ''!
position
	"Answer current position on stream."

	| i size coll |
	current isNil ifTrue: [^0].
	i := 1.
	size := 0.
	[(coll := collections at: i) == current] whileFalse: 
			[i := i + 1.
			size := size + coll size].
	^size + position! !

!ODBMemoryWriteStream methodsFor: 'public' stamp: ''!
position: anInteger 
	"Set current position on stream."

	collections last == current ifTrue: [lastSize < position ifTrue: [lastSize := position]].
	position := anInteger.
	1 to: collections size
		do: 
			[:i | 
			current := collections at: i.
			position <= (readLimit := current size) ifTrue: [^self].
			position := position - readLimit].
	^self error: 'Position outside of stream !!'! !

!ODBMemoryWriteStream methodsFor: 'public' stamp: ''!
putBytesFrom: aByteCollection len: len 
	"Write aByteCollection to stream."

	len > (readLimit - position) 
		ifTrue: 
			[(current notNil 
				and: [collections last == current and: [len > 64 and: [len <= aByteCollection size]]]) 
					ifTrue: 
						[collections at: collections size put: (current copyFrom: 1 to: position).
						aByteCollection size = len 
							ifTrue: [collections add: aByteCollection]
							ifFalse: [collections add: (aByteCollection copyFrom: 1 to: len)].
						self makeSpace]
					ifFalse: [1 to: len do: [:i | self putByte: (aByteCollection at: i) asInteger]]]
		ifFalse: 
			[current 
				replaceFrom: position + 1
				to: position + len
				with: aByteCollection
				startingAt: 1.
			position := position + len]! !

!ODBMemoryWriteStream methodsFor: 'public' stamp: ''!
putByte: aByte 
	position < readLimit ifFalse: [self moveToNext].
	current at: (position := position + 1) put: aByte! !

!ODBMemoryWriteStream methodsFor: 'public' stamp: ''!
size
	"Answer stream size."

	| size count |
	current isNil ifTrue: [^0].
	size := 0.
	count := collections size.
	1 to: count - 1 do: [:i | size := size + (collections at: i) size].
	current == (collections at: count) 
		ifTrue: [lastSize < position ifTrue: [lastSize := position]].
	^size + lastSize! !

!ODBMemoryWriteStream methodsFor: 'public' stamp: ''!
writeOn: aStream 
	"Write receivers contents on aStream."

	| count |
	aStream putLong: self size.
	(count := collections size) == 0 
		ifFalse: 
			[1 to: count - 1 do: [:i | aStream putBytesFrom: (collections at: i)].
			aStream putBytesFrom: (collections at: count) len: lastSize]! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
atEnd
        "Answer <true> if at end of stream."

    ^self position == self size! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
flush! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
getBoolean

    ^self getByte = 1! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
getBytesFor: aByteCollection

    ^self getBytesFor: aByteCollection len: aByteCollection size! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
getChar

    ^Character value: self getByte! !

!ODBStream methodsFor: 'public' stamp: ''!
getInteger
	"Answer the next Integer encoded in the receiver."

	| int |
	((int := self getPositiveInteger) bitAnd: 1) == 0 ifTrue: [^int bitShift: -1].
	^0 - (int bitShift: -1)! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
getLong

    ^self getWord bitOr: (self getWord bitShift: 16)! !

!ODBStream methodsFor: 'public' stamp: ''!
getPositiveInteger
	"Answer the next Integer encoded in the receiver."

	| answer |
	(answer := self getByte) < 128 ifTrue: [^answer].
	^(self getPositiveInteger bitShift: 7) bitOr: (answer bitAnd: 127)! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
getString

	| size bytes |
	^(size := self getPositiveInteger) = 0
		ifTrue: [String new]
		ifFalse: [
			bytes := ByteArray new: size.
			self getBytesFor: bytes len: size.
			bytes asString ]! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
getWord

    ^self getByte bitOr: (self getByte bitShift: 8)! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
putBoolean: aBool

    self putByte: (aBool ifTrue: [ 1] ifFalse: [0])! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
putBytesFrom: aByteCollection

    ^self putBytesFrom: aByteCollection len: aByteCollection size! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
putChar: aCharacter

	self putByte: aCharacter asInteger! !

!ODBStream methodsFor: 'public' stamp: ''!
putInteger: anInteger 
	anInteger < 0 ifTrue: [^self putPositiveInteger: (0 - anInteger bitShift: 1) + 1].
	self putPositiveInteger: (anInteger bitShift: 1)! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
putLong: anInteger

    self putWord: (anInteger bitAnd: 65535); putWord: (anInteger bitShift: -16)! !

!ODBStream methodsFor: 'public' stamp: ''!
putPositiveInteger: anInteger 
	anInteger < 128 ifTrue: [^self putByte: anInteger].
	self
		putByte: ((anInteger bitAnd: 127) bitOr: 128);
		putPositiveInteger: (anInteger bitShift: -7)! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
putString: aString

	self putPositiveInteger: aString basicSize.
	aString basicSize > 0 ifTrue: [ self putBytesFrom: aString asByteArray len: aString basicSize ]! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
putWord: anInteger

    self putByte: (anInteger bitAnd: 255); putByte: (anInteger bitShift: -8)! !

!ODBStream methodsFor: 'public' stamp: 'cdg 3/13/2003 18:05'!
setToEnd
        "Set to stream to end and answer position."

    ^self position: self size! !

Object subclass: #ODBTransaction
	instanceVariableNames: 'cacheMutex client dbConnection locks objectIndex objects transactionFile transactionManager versionDescriptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBTransaction subclass: #ODBLocalTransaction
	instanceVariableNames: 'application changesPackage inconsistent newObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBLocalTransaction subclass: #ODBGlobalLockedTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBGlobalLockedTransaction methodsFor: 'private' stamp: ''!
addLock: aLock 
	"Private - Add aLock to receiver."

	OmniBase signalError: 'Global transaction should not set locks'! !

!ODBGlobalLockedTransaction methodsFor: 'public' stamp: ''!
isGlobalLocked
	"Answer <true> if transaction was started in a global locked database session."

	^true! !

!ODBGlobalLockedTransaction methodsFor: 'private' stamp: ''!
removeLock: aLock 
	"Private - Remove aLock from receiver."

	OmniBase signalError: 'Global transaction should not set locks'! !

!ODBLocalTransaction methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
addLock: aLock
        "Private - Add aLock to receiver."

    locks add: aLock! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
addLoggedLock: aLock 
	"Private - Add aLock to receiver and store it to transaction file."

	locks add: aLock.
	transactionFile lockAdd: aLock! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
application
	^application! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
application: anObject 
	"Set application object for the transaction.
	This is just a value holder that can be used by the end user.
	Setting application has no effect in OmniBase."

	application := anObject! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
becomeInconsistent
	"Mark that transaction changes are inconsistent. 
	If transaction is inconsistent, it can not be committed!! "

	inconsistent := true! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
changesPackage
	^changesPackage! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
checkpoint
	"Checkpoint transaction i.e. write all persistent objects that are marked as dirty or new into database.
	Only changes are written into the database. This is an atomic operation which will either complete successfully
	or fail completely with no changes whatsoever written into the database. After writing changes all locks on already
	existing object will still be set. Objects that were new, had no locks set and are thus not locked. Transaction can
	be checkpointed more than once. As seen below the whole process of writing changes into the database (files)
	is executed using a semaphore therefore only one transaction per database session can write its changes at a time."

	self isInconsistent ifTrue: [OmniBase signalError: 'Transaction is inconsistent'].
	transactionManager critical: 
			[[self prepare] ifCurtailed: 
					[self becomeInconsistent.
					transactionManager transactionCommitEnd: self].
			[changesPackage commit] ifCurtailed: 
					[self
						becomeInconsistent;
						basicAbort]].
	self committed! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
commit
	self
		checkpoint;
		abort! !

!ODBLocalTransaction methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
committed
        "Private - Transaction has just been committed."

    "End of transaction"
    transactionFile recovery: nil.
    transactionManager transactionCommitEnd: self.
    "Update transaction objects"        
    changesPackage committed.
    changesPackage := nil.! !

!ODBLocalTransaction methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:06'!
initialize
        "Private - Initialize receiver."

    super initialize.
    newObjects := Array new: 16! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
isChanged
	"Answer true if changes were made to objects in this transaction."

	objectIndex do: [:transactionObject | transactionObject isChanged ifTrue: [^true]].
	^false! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
isInconsistent
	"Answer true if transaction changes are inconsistent. 
	If transaction is inconsistent, it can not be committed."

	^inconsistent == true! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
lockID
	"Private - Answer unique lock ID. Create transaction 
	file, if no locks have been set before. Answer <nil> 
	if database is globally locked by another user and no 
	locks can currently be set."

	locks isNil 
		ifTrue: 
			[(transactionFile := client newTransactionFileFor: self) isNil ifTrue: [^nil].
			locks := OrderedCollection new].
	^transactionFile transactionID! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
lock: anObject 
	"Lock anObject."

	| transactionObject |
	transactionObject := self getTransactionObject: anObject ifAbsent: [^true].
	transactionObject objectID index == 0 ifTrue: [^true].
	^transactionObject lock! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
makePersistent: anObject 
	^self makePersistent: anObject in: dbConnection objectManager defaultContainer! !

!ODBLocalTransaction methodsFor: 'public' stamp: 'mu 8/18/2005 19:13'!
makePersistent: anObject in: aContainerOrContainerName 
	"Store anObject into specified container if it is not stored yet, else do nothing.
	Answer anObject."

	| container |
	anObject odbObjectID isNil ifFalse: [^anObject].
	self getTransactionObject: anObject
		ifAbsent: 
			[aContainerOrContainerName isString 
				ifTrue: 
					[container := dbConnection objectManager containerNamed: aContainerOrContainerName
								ifAbsent: [OmniBase signalError: 'Container does not exist']]
				ifFalse: [container := aContainerOrContainerName].
			self storeNewObject: anObject inContainer: container].
	^anObject! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
markDirty: anObject 
	"Mark anObject as dirty so that it will be written to the 
	database when message #commit is sent.
	Note: if an object is not loaded yet i.e. the message #markDirty is sent to an unresolved ODBReference the object will not be marked as dirty.
	Therefore send #markDirty after you've loaded and changed the object, not before, else use #odbResolve before sending #markDirty."

	| objectToStore transactionObject |
	cacheMutex isNil 
		ifTrue: 
			["transaction is already aborted"
			OmniBase signalError: 'Transaction is already aborted.'].
	(objectToStore := anObject) odbObjectID isNil 
		ifFalse: 
			[anObject isODBReference ifFalse: [^self].
			anObject odbNotLoaded ifTrue: [^self].
			anObject odbTransaction == self ifFalse: [objectToStore := anObject odbResolve]].
	transactionObject := self getTransactionObject: objectToStore
				ifAbsent: 
					[OmniBase 
						signalError: 'Object is not persistent or is a part of composite persistent object'].
	transactionObject objectID index = 0 ifTrue: [^true].
	transactionObject lock ifFalse: [^self signalLockingConflictAt: anObject].
	transactionObject objectChanged! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
peekTransactionObjectAt: objectID 
	"Answer transaction object at objectID but do not cache it in transaction."

	| holder transactionObject |
	(transactionObject := self cachedTransactionObjectAt: objectID) isNil 
		ifFalse: [^transactionObject].
	(holder := dbConnection objectManager holderAt: objectID) == nil 
		ifTrue: [OmniBase signalError: 'Invalid object ID'].
	[versionDescriptor versionOK: holder versionNumber] 
		whileFalse: [holder loadPreviousVersionFrom: self oldHolders].
	transactionObject := holder getObject makeTransactionObject: self.
	^transactionObject objectLoaded! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
prepare
	"Private - Prepare for commit."

	| serializer coll holder array index allObjects lastSize notFirstPass |
	allObjects := IdentitySet new: objectIndex size.
	notFirstPass := false.
	"send #odbAboutToCommitIn: to every persistent object in cache"
	"if any object stores additional objects do it again for new objects"
	
	[lastSize := objectIndex size.
	objectIndex values do: 
			[:each | 
			(notFirstPass and: [allObjects includes: each]) 
				ifFalse: 
					[each odbAboutToCommitIn: self.
					allObjects add: each]].
	lastSize = objectIndex size] 
			whileFalse: [notFirstPass := true].
	cacheMutex critical: 
			["initialize object ID indexes for new objects & lock & store them"
			1 to: newObjects size
				do: 
					[:i | 
					(coll := newObjects at: i) isNil 
						ifFalse: 
							[array := Array new: coll size.
							index := 0.
							coll do: 
									[:each | 
									index := index + 1.
									holder := each objectHolder.
									array at: index put: holder].
							holder container initHolders: array.
							coll do: [:each | objects at: each objectHolder objectID put: each].
							newObjects at: i put: nil]].
			self lockID isNil 
				ifTrue: [OmniBase signalError: 'Database is globaly locked by another user'].
			"make reference map"
			serializer := ODBSerializer new.
			self transactionReferences 
				do: [:each | serializer addExternalReference: each key objectId: each value].
			objectIndex 
				keysAndValuesDo: [:key :value | serializer addExternalReference: key objectId: value objectID]].
	"get new version number"
	transactionManager transactionCommitBegin: self.
	transactionFile versionNumber: versionDescriptor versionNumber.
	"collect changes on transaction objects"
	changesPackage := ODBChangesPackage new.
	allObjects do: [:transactionObject | transactionObject commit: serializer].
	dbConnection objectManager flushContainers.
	self oldHolders flush.
	transactionFile recovery: changesPackage! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
removeCachedObjectID: objectID 
	"Remove transaction object associated with objectID."

	objects isNil ifFalse: [cacheMutex critical: [objects removeKey: objectID]]! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
removeLock: aLock 
	"Private - Remove aLock from collection of set locks."

	locks remove: aLock ifAbsent: []! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
removeLoggedLock: aODBLock 
	"Private - Remove anODBLock from receiver and remove it from transaction file."

	locks remove: aODBLock ifAbsent: [].
	transactionFile lockRemove: aODBLock! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
root: anObject 
	"Set the root object of the database."

	| rootObjectHolder rootOID |
	rootOID := ODBObjectID containerID: 1 index: 1.
	(rootObjectHolder := self objectAt: rootOID) isNil 
		ifTrue: 
			[rootObjectHolder := ODBRootObjectHolder new.
			self store: rootObjectHolder.
			cacheMutex critical: [objects at: rootOID put: rootObjectHolder]].
	rootObjectHolder rootObject: anObject! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
signalLockingConflictAt: anObject 
	"Private - anObject could not have been locked. 
	Signal an error."

	| transactionObject |
	transactionObject := self getTransactionObject: anObject
				ifAbsent: [OmniBase signalError: 'Internal locking error'].
	transactionObject objectHolder oldVersion 
		ifTrue: 
			[ODBCannotLockObject signal: 'Object has already been changed in another transaction']
		ifFalse: [ODBCannotLockObject signal: 'Object is already locked in another transaction']! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
start
	"Start transaction. Transaction is read-only 
	until no objects are locked."

	transactionManager transactionStart: self! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
startFrom: aTransaction 
	"Start transaction.
	Transaction is read-only until no objects are locked.
	Version descriptor from aTransaction is valid at start."

	versionDescriptor := aTransaction versionDescriptor copy! !

!ODBLocalTransaction methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:06'!
startInVersion: aVersionDescriptor

    versionDescriptor := aVersionDescriptor! !

!ODBLocalTransaction methodsFor: 'private' stamp: ''!
storeNewObject: anObject inContainer: aContainer 
	"Store anObject into specified container."

	| transactionObject holder coll id |
	holder := aContainer newObjectHolder.
	anObject isODBTransactionObject 
		ifFalse: [transactionObject := ODBSerializedObject new value: anObject]
		ifTrue: [transactionObject := anObject].
	transactionObject setObjectHolder: holder transaction: self.
	cacheMutex critical: 
			[(id := aContainer id) > newObjects size 
				ifTrue: 
					[(coll := Array new: id) 
						replaceFrom: 1
						to: newObjects size
						with: newObjects
						startingAt: 1.
					newObjects := coll].
			(coll := newObjects at: id) isNil 
				ifTrue: 
					[coll := OrderedCollection new: 32.
					newObjects at: id put: coll].
			coll add: transactionObject.
			objectIndex at: anObject put: transactionObject].
	transactionObject objectStored! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
store: anObject 
	^self 
		store: anObject
		in: dbConnection objectManager defaultContainer
		ifLocked: [self signalLockingConflictAt: anObject]! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
store: anObject ifLocked: aBlock 
	^self 
		store: anObject
		in: dbConnection objectManager defaultContainer
		ifLocked: aBlock! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
store: anObject in: aContainerOrContainerName 
	^self 
		store: anObject
		in: aContainerOrContainerName
		ifLocked: [self signalLockingConflictAt: anObject]! !

!ODBLocalTransaction methodsFor: 'public' stamp: 'mu 8/18/2005 19:13'!
store: anObject in: anODBContainerOrString ifLocked: aBlock 
	"Store anObject into given container anODBContainerOrString which can be either a String (container name) or an ODBContainer.
	Evaluate aBlock if anObject can not be locked."

	| objectToStore transactionObject container |
	(objectToStore := anObject) odbObjectID isNil 
		ifFalse: 
			[anObject isODBReference ifFalse: [^self].
			anObject odbNotLoaded ifTrue: [^self].
			anObject odbTransaction == self ifFalse: [objectToStore := anObject odbResolve]].
	transactionObject := self getTransactionObject: objectToStore
				ifAbsent: 
					[anODBContainerOrString isString 
						ifTrue: 
							[container := dbConnection objectManager containerNamed: anODBContainerOrString
										ifAbsent: [OmniBase signalError: 'Invalid container name']]
						ifFalse: [container := anODBContainerOrString].
					^self storeNewObject: objectToStore inContainer: container].
	"* namesto: (self lock: anObject) ifFalse: [ ^aBlock value ]."
	transactionObject objectID index == 0 ifTrue: [^true].	"*"
	transactionObject lock ifFalse: [^aBlock value].	"*"
	transactionObject objectChanged! !

!ODBLocalTransaction methodsFor: 'public' stamp: ''!
unlock: anObject 
	"Unlock anObject."

	| transactionObject |
	transactionObject := self getTransactionObject: anObject ifAbsent: [^true].
	transactionObject isChanged ifTrue: [^false].	"Changed objects can not be unlocked."
	^transactionObject unlock! !

ODBLocalTransaction subclass: #ODBReadOnlyTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBReadOnlyTransaction methodsFor: 'private' stamp: ''!
addLock: aLock 
	"Private - Add anODBLock to receiver."

	OmniBase signalError: 'Read-only transaction should not set locks'! !

!ODBReadOnlyTransaction methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
checkpoint
		"Do nothing."! !

!ODBReadOnlyTransaction methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
commit
		"Do nothing."

	self abort! !

!ODBReadOnlyTransaction methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
isChanged

	^false! !

!ODBReadOnlyTransaction methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
isReadOnly
		"Answer <true> if this is a read-only transaction."

	^true! !

!ODBReadOnlyTransaction methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
lock: anObject

	^true! !

!ODBReadOnlyTransaction methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
makePersistent: anObject in: aContainerOrContainerName
		"Do nothing."

	^anObject! !

!ODBReadOnlyTransaction methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
markDirty: anObject
		"Do nothing."! !

!ODBReadOnlyTransaction methodsFor: 'private' stamp: ''!
removeLock: aLock 
	"Private - Remove anODBLock from receiver."

	OmniBase signalError: 'Read-only transaction should not set locks'! !

!ODBReadOnlyTransaction methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
store: anObject in: containerName ifLocked: aBlock
		"Do nothing."

	^anObject! !

!ODBReadOnlyTransaction methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
unlock: anObject

	^true! !

ODBTransaction subclass: #ODBTerminatedTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBTerminatedTransaction methodsFor: 'public/start/commit/abort' stamp: 'cdg 3/13/2003 18:05'!
start
        "Start transaction. Transaction has been terminated 
        without being aborted in previous session."

    transactionManager transactionStart: self.
    versionDescriptor versionNumber: transactionFile versionNumber.
    locks := transactionFile locks! !

!ODBTerminatedTransaction methodsFor: 'private/accessing' stamp: 'cdg 3/13/2003 18:05'!
transactionFile: aTransactionFile

    transactionFile := aTransactionFile! !

!ODBTransaction class methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
new

	^super new initialize! !

!ODBTransaction class methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

	^deserializer transaction! !

!ODBTransaction methodsFor: 'public' stamp: ''!
abort
	"Abort transaction. After aborting it, it can not be used anymore."

	transactionManager isNil ifFalse: [transactionManager critical: [self basicAbort]]! !

!ODBTransaction methodsFor: 'private' stamp: ''!
basicAbort
	"Private - Abort transaction. After aborting it, it can not be used anymore."

	| changes |
	dbConnection isNil 
		ifFalse: 
			[locks isNil 
				ifFalse: 
					[(changes := transactionFile recovery) isNil 
						ifFalse: 
							[changes
								transaction: self;
								rollback.
							transactionFile recovery: nil].
					locks do: 
							[:each | 
							each
								transaction: self;
								unlock]].
			transactionManager transactionAborted: self.
			client transactionRemove: self].
	objectIndex := nil.
	objects := nil.
	client := nil.
	dbConnection := nil.
	transactionManager := nil.
	cacheMutex isNil 
		ifFalse: 
			[cacheMutex terminateProcess.
			cacheMutex := nil]! !

!ODBTransaction methodsFor: 'public' stamp: ''!
cachedObjectAt: objectID 
	"Answer object identified by the given objectID.
	Answer <nil> if the object is not found in the local transaction cache.
	This method will not load the object from the disk drive."

	| transactionObject |
	^(objects isNil 
		or: [(transactionObject := self cachedTransactionObjectAt: objectID) isNil]) 
			ifFalse: [transactionObject value]! !

!ODBTransaction methodsFor: 'private' stamp: ''!
cachedTransactionObjectAt: objectID 
	"Private - Answer cached transaction object at objectID."

	| obj |
	cacheMutex critical: [obj := objects at: objectID].
	^obj! !

!ODBTransaction methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
client

    ^client! !

!ODBTransaction methodsFor: 'public' stamp: ''!
environment
	^dbConnection! !

!ODBTransaction methodsFor: 'public' stamp: ''!
getLoadedObjects
	"Answer collection of associations of all objects loaded in current transaction."

	| coll |
	coll := OrderedCollection new.
	objectIndex do: [:each | each objectID containerID > 0 ifTrue: [coll add: each value]].
	^coll! !

!ODBTransaction methodsFor: 'private' stamp: ''!
getObjectIDOrNil: anObject 
	"Private - Answer <objectID> coresponding to anObject 
        or <nil> if not allready stored."

	| transactionObject oid |
	anObject odbObjectID isNil ifFalse: [^anObject odbObjectID].
	cacheMutex critical: [transactionObject := objectIndex at: anObject].
	^transactionObject isNil 
		ifFalse: [(oid := transactionObject objectID) index == 0 ifFalse: [oid]]! !

!ODBTransaction methodsFor: 'public' stamp: ''!
getObjectID: anObject 
	"Answer <objectID> coresponding to anObject."

	| transactionObject oid |
	anObject odbObjectID isNil ifFalse: [^anObject odbObjectID].
	cacheMutex critical: [transactionObject := objectIndex at: anObject].
	transactionObject isNil 
		ifTrue: 
			[OmniBase 
				signalError: 'Object is not persistent or is contained in another persistent object'].
	(oid := transactionObject objectID) index == 0 
		ifTrue: 
			[OmniBase 
				signalError: 'Object ID is not allocated yet. Object ID will be allocated after transaction checkpoint or commit.'].
	^oid! !

!ODBTransaction methodsFor: 'private' stamp: ''!
getTransactionObject: anObject ifAbsent: aBlock 
	"Private - Answer transaction object corresponding to anObject.
	Evaluate aBlock if none."

	| transactionObject |
	anObject isODBReference 
		ifTrue: 
			[anObject odbTransaction == self 
				ifFalse: [OmniBase signalError: 'Reference from another transaction'].
			^anObject odbTransactionObject].
	cacheMutex critical: [transactionObject := objectIndex at: anObject].
	^transactionObject isNil ifTrue: [aBlock value] ifFalse: [transactionObject]! !

!ODBTransaction methodsFor: 'private' stamp: ''!
initialize
	cacheMutex := Semaphore forMutualExclusion.
	objects := ODBObjectIDDictionary new.
	objectIndex := ODBIdentityDictionary new! !

!ODBTransaction methodsFor: 'public' stamp: ''!
isChanged
	"Answer <true> if changes were made to the database."

	^false! !

!ODBTransaction methodsFor: 'public' stamp: ''!
isGlobalLocked
	"Answer <true> if transaction was started in 
	a global locked database session."

	^false! !

!ODBTransaction methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
isReadOnly
		"Answer <true> if this is a read-only transaction."

	^false! !

!ODBTransaction methodsFor: 'public' stamp: ''!
objectAt: objectID 
	"Answer object at objectID, <nil> if it does not exist."

	| transactionObject |
	objects isNil ifTrue: [OmniBase signalError: 'Transaction was already aborted'].
	objectID containerID == 0 ifTrue: [^self transactionReferenceAt: objectID index].
	^(transactionObject := self transactionObjectAt: objectID) isNil 
		ifFalse: [transactionObject value]! !

!ODBTransaction methodsFor: 'private' stamp: ''!
objectHolderAt: objectID 
	"Private - Answer object holder at objectID."

	| trObj |
	^(trObj := self cachedTransactionObjectAt: objectID) isNil 
		ifFalse: [trObj objectHolder]
		ifTrue: [dbConnection objectManager holderAt: objectID]! !

!ODBTransaction methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
odbBasicSerialize: serializer

	serializer stream putByte: 84! !

!ODBTransaction methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
odbObjectID

    ^ODBObjectID containerID: 0 index: 1000! !

!ODBTransaction methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
odbSerialize: serializer

	serializer stream putByte: 84! !

!ODBTransaction methodsFor: 'private/accessing' stamp: 'cdg 3/13/2003 18:05'!
oldHolders
        "Private - Answer file used to store old holder versions."

    ^transactionManager oldHolders! !

!ODBTransaction methodsFor: 'private' stamp: ''!
referenceAt: objectID 
	"Private - Answer reference at objectID. If object is already loaded, answer its value."

	| refObj |
	objectID containerID == 0 ifTrue: [^self transactionReferenceAt: objectID index].
	(refObj := self cachedTransactionObjectAt: objectID) isNil ifFalse: [^refObj value].
	refObj := ODBReference new.
	^refObj odbSetLoader: (ODBDemandLoader new 
				setTransaction: self
				objectID: objectID
				proxyObject: refObj)! !

!ODBTransaction methodsFor: 'public' stamp: ''!
root
	"Answer the database root object. Root object represents an entry point into the database.
	Only objects that are being referenced from the root object will remain after the garbage
	collection on the database."

	| rootObjectHolder |
	^(rootObjectHolder := self objectAt: (ODBObjectID containerID: 1 index: 1)) isNil 
		ifFalse: [rootObjectHolder rootObject]! !

!ODBTransaction methodsFor: 'private' stamp: ''!
setClient: aClient environment: anOmniBase 
	client := aClient.
	dbConnection := anOmniBase.
	transactionManager := dbConnection transactionManager! !

!ODBTransaction methodsFor: 'private/accessing' stamp: 'cdg 3/13/2003 18:05'!
transactionFile

    ^transactionFile! !

!ODBTransaction methodsFor: 'private' stamp: ''!
transactionObjectAt: objectID 
	"Private - Answer transaction object at objectID."

	| holder transactionObject t2 |
	cacheMutex isNil ifTrue: [^ODBExpiredProxyObject on: objectID].
	cacheMutex critical: [transactionObject := objects at: objectID].
	transactionObject isNil ifFalse: [^transactionObject].
	(holder := dbConnection objectManager holderAt: objectID) isNil 
		ifTrue: 
			["OID (1:1) = nil"
			^transactionObject := (objectID index = 1 and: [objectID containerID = 1]) 
						ifFalse: [OmniBase signalError: 'Invalid object ID']].
	[versionDescriptor versionOK: holder versionNumber] 
		whileFalse: [holder loadPreviousVersionFrom: self oldHolders].
	[transactionObject := holder getObject makeTransactionObject: self] 
		ifCurtailed: [self becomeInconsistent].
	cacheMutex critical: 
			[(t2 := objects at: objectID) isNil 
				ifTrue: 
					[objects at: objectID put: transactionObject.
					objectIndex at: transactionObject value put: transactionObject]].
	^t2 isNil ifTrue: [transactionObject objectLoaded] ifFalse: [t2]! !

!ODBTransaction methodsFor: 'private' stamp: ''!
transactionReferenceAt: objectIDindex 
	"Private - Answer object at objectID index."

	objectIDindex == 1000 ifTrue: [^self].
	^transactionManager transactionReferenceAt: objectIDindex! !

!ODBTransaction methodsFor: 'private' stamp: ''!
transactionReferences
	"Private - Answer collection of transaction dependent 
	objects and their object IDs (starting with 1000)."

	^(OrderedCollection new: 512)
		add: (Association key: self value: self odbObjectID);
		add: (Association key: dbConnection value: dbConnection odbObjectID);
		yourself! !

!ODBTransaction methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
versionDescriptor

    ^versionDescriptor! !

!ODBTransaction methodsFor: 'private' stamp: ''!
versionDescriptor: aVersionDescriptor 
	versionDescriptor := aVersionDescriptor! !

!ODBTransaction methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
versionNumber

    ^versionDescriptor versionNumber! !

Object subclass: #ODBTransactionManager
	instanceVariableNames: 'committingTransaction dbConnection mutex oldHolders serializingTransactionsMutex serializingTransactionsSemaphore transactionReferences versionControl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBTransactionManager methodsFor: 'public' stamp: ''!
close
	versionControl notNil 
		ifTrue: 
			[versionControl close.
			versionControl := nil].
	oldHolders notNil 
		ifTrue: 
			[oldHolders close.
			oldHolders := nil].
	dbConnection := nil! !

!ODBTransactionManager methodsFor: 'public' stamp: ''!
createOn: aDatabase 
	self initializeOn: aDatabase.
	
	[versionControl := ODBVersionControlFile createOn: self vcFileName.
	oldHolders := ODBOldHoldersFile createOn: self oldHoldersFileName.
	self initializeReferences] 
			ifCurtailed: [self close]! !

!ODBTransactionManager methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
critical: aBlock

	mutex critical: aBlock! !

!ODBTransactionManager methodsFor: 'public' stamp: ''!
currentVersionDescriptor
	^versionControl versionDescriptor copy! !

!ODBTransactionManager methodsFor: 'private' stamp: 'david@inspiron 10/31/2004 23:00'!
initializeOn: aDatabase 
	dbConnection := aDatabase.
	mutex := Semaphore forMutualExclusion.
	serializingTransactionsSemaphore := Semaphore new.
	serializingTransactionsSemaphore signal! !

!ODBTransactionManager methodsFor: 'private' stamp: ''!
initializeReferences
	"Private - Initialize dictionary of transaction references."

	transactionReferences := Array new: 4.
	transactionReferences
		at: 1 put: nil;
		at: 2 put: true;
		at: 3 put: false;
		at: 4 put: dbConnection! !

!ODBTransactionManager methodsFor: 'public/accessing' stamp: 'cdg 3/13/2003 18:05'!
oldHolders

    ^oldHolders! !

!ODBTransactionManager methodsFor: 'private' stamp: ''!
oldHoldersFileName
	^dbConnection dirName , ODBFileStream pathSeparatorString , 'omnibase.log'! !

!ODBTransactionManager methodsFor: 'public' stamp: ''!
openOn: anOmniBase 
	self initializeOn: anOmniBase.
	
	[versionControl := ODBVersionControlFile openOn: self vcFileName.
	[oldHolders := ODBOldHoldersFile openOn: self oldHoldersFileName] on: Error
		do: [:er | oldHolders := ODBOldHoldersFile createOn: self oldHoldersFileName].
	self initializeReferences] 
			ifCurtailed: [self close]! !

!ODBTransactionManager methodsFor: 'public' stamp: ''!
transactionAborted: aTransaction 
	"Discard version descriptor. Default do nothing."

	committingTransaction == aTransaction 
		ifTrue: 
			[versionControl removeCommittingFor: aTransaction client clientID.
			committingTransaction := nil.
			serializingTransactionsSemaphore signal]! !

!ODBTransactionManager methodsFor: 'public' stamp: ''!
transactionCommitBegin: aTransaction 
	| versionNumber |
	serializingTransactionsSemaphore wait.
	committingTransaction notNil 
		ifTrue: [OmniBase signalError: 'Concurrent commit is not allowed'].
	committingTransaction := aTransaction.
	versionNumber := versionControl getNewVersionNumberFor: aTransaction client clientID.
	aTransaction versionDescriptor versionNumber: versionNumber! !

!ODBTransactionManager methodsFor: 'public' stamp: ''!
transactionCommitEnd: aTransaction 
	committingTransaction == aTransaction 
		ifTrue: 
			[versionControl removeCommittingFor: aTransaction client clientID.
			committingTransaction := nil.
			serializingTransactionsSemaphore signal]! !

!ODBTransactionManager methodsFor: 'public' stamp: ''!
transactionReferenceAt: index 
	^(index > transactionReferences size or: [index = 0]) 
		ifFalse: [transactionReferences at: index]! !

!ODBTransactionManager methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
transactionStart: aTransaction
                "Set transaction version descriptor upon transaction start."

        aTransaction versionDescriptor: versionControl versionDescriptor copy! !

!ODBTransactionManager methodsFor: 'private' stamp: ''!
vcFileName
	^dbConnection dirName , ODBFileStream pathSeparatorString , 'omnibase.vcf'! !

!ODBTransactionManager methodsFor: 'private' stamp: ''!
versionControl
	^versionControl! !

Object subclass: #ODBTransactionObject
	instanceVariableNames: 'transaction lockObject holder dataBaseObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBTransactionObject subclass: #ODBBTreeIndexDictionary
	instanceVariableNames: 'changed currentKey keySize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

ODBBTreeIndexDictionary subclass: #ODBBTreeDictionary
	instanceVariableNames: 'locks initialSize deltaSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBBTreeDictionary methodsFor: 'private' stamp: ''!
addKey: key value: anObject 
	"Private - Add association to dictionary of changed associations."

	| value |
	(value := self valueAt: key) isRemoved 
		ifTrue: [deltaSize := deltaSize + 1]
		ifFalse: 
			[transaction isNil 
				ifFalse: 
					["ce je objekt identicen ga ne shranjuj znova"
					(transaction getObjectIDOrNil: anObject) = value objectID ifTrue: [^anObject]]].
	value object: anObject.
	changed isNil ifTrue: [changed := self newChangedDictionary].
	changed at: key put: value.
	^anObject! !

!ODBBTreeDictionary methodsFor: 'public' stamp: ''!
at: aKey put: anObject 
	"Associate aKey with anObject.
	aKey can be any object which implements method #asBtreeKeyOfSize:
	Trigger an exception if aKey has already been locked or changed in a concurrently running transaction."

	^self 
		at: aKey
		put: anObject
		ifLocked: [ODBCannotLockKey signal]! !

!ODBBTreeDictionary methodsFor: 'public' stamp: ''!
at: aKey put: anObject ifLocked: aBlock 
	"Associate aKey with anObject.
	Evaluate aBlock if aKey has been locked before in some other transaction."

	| key |
	key := self bytesFromKey: aKey.
	(self basicLockKey: key) ifFalse: [^aBlock value].
	transaction isNil ifFalse: [transaction makePersistent: anObject in: holder container].
	^self addKey: key value: anObject! !

!ODBBTreeDictionary methodsFor: 'private' stamp: 'dg 12/20/2003 10:17'!
basicLockKey: key 
	"Private - Lock key so that other transactions wont be able
	to change it. Answer <true> if successfull."

	| lock lockID value |
	dataBaseObject isNil ifTrue: [^true].
	(lockID := transaction lockID) isNil ifTrue: [^false].
	transaction isGlobalLocked ifTrue: [^true].
	locks isNil 
		ifTrue: [locks := Dictionary new]
		ifFalse: [(locks includesKey: key) ifTrue: [^true]].
	lock := (ODBKeyLock new)
				objectID: holder objectID;
				lockID: lockID;
				key: key.
	value := self valueAt: key.
	dataBaseObject iterator critical: 
			[transaction addLoggedLock: lock.
			((dataBaseObject iterator)
				goTo: key;
				lockCurrentValue: value contents with: lockID) 
					ifFalse: 
						[transaction removeLoggedLock: lock.
						^false]].
	locks at: key put: lock.
	^true! !

!ODBBTreeDictionary methodsFor: 'private' stamp: ''!
commitChanged
	"Private - Commit changes on an already existing dictionary."

	| changesPackage newValue vn oldHolders |
	changesPackage := transaction changesPackage.
	changesPackage add: (ODBDictionaryChanged new transactionObject: self).
	deltaSize = 0 
		ifFalse: 
			[changesPackage add: ((ODBSizeChanged new)
						setObjectID: holder objectID transactionObject: self;
						deltaSize: deltaSize)].
	vn := transaction versionNumber.
	oldHolders := transaction oldHolders.
	changed isNil 
		ifFalse: 
			[changed keysAndValuesDo: 
					[:key :oldValue | 
					newValue := oldValue makeNewVersion: oldHolders.
					newValue versionNumber: vn.
					oldValue isRemoved 
						ifFalse: [newValue objectID: (transaction getObjectID: newValue object)].
					changesPackage add: ((ODBAssociationChanged new)
								key: key;
								setObjectID: holder objectID transactionObject: self;
								oldValue: oldValue;
								newValue: newValue)]]! !

!ODBBTreeDictionary methodsFor: 'private' stamp: ''!
commitNew
	"Private - Commit changes when new database object needs to be created."

	| newHolder newDBObject vn |
	vn := transaction versionNumber.
	newHolder := (holder makeNewVersion: transaction oldHolders)
				persistentClassID: self databaseObjectClass classID;
				versionNumber: vn.
	newDBObject := self databaseObjectClass new createOn: newHolder keySize: keySize.
	changed notNil 
		ifTrue: 
			[changed keysAndValuesDo: 
					[:key :value | 
					value isRemoved 
						ifFalse: 
							[value
								objectID: (transaction getObjectID: value object);
								versionNumber: vn.
							newDBObject at: key put: value]]].
	newDBObject iterator 
		updateSizeAt: vn
		oldHolders: nil
		deltaSize: deltaSize.
	(transaction changesPackage)
		add: ((ODBNewObjectVersion new)
					setObjectID: holder objectID transactionObject: self;
					oldVersion: holder;
					newVersion: newHolder);
		add: ((ODBDictionaryChanged new)
					transactionObject: self;
					dataBaseObject: newDBObject)! !

!ODBBTreeDictionary methodsFor: 'private' stamp: ''!
databaseObjectClass
	^ODBDBBTreeDictionary! !

!ODBBTreeDictionary methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
initialize
        "Private - Initialize receiver."

    super initialize.
    initialSize := 0.
    deltaSize := 0! !

!ODBBTreeDictionary methodsFor: 'public' stamp: ''!
isKeyLocked: aKey 
	"Answer <true> if aKey is locked."

	| key result |
	dataBaseObject isNil ifTrue: [^false].
	transaction isGlobalLocked ifTrue: [^false].
	key := self bytesFromKey: aKey.
	dataBaseObject iterator critical: 
			[result := (locks notNil and: [locks includesKey: key]) or: 
							[(dataBaseObject iterator)
								goTo: key;
								isLocked]].
	^result! !

!ODBBTreeDictionary methodsFor: 'public' stamp: ''!
lockKey: aKey 
	"Lock key aKey so that other transactions wont be able
	to change it. Answer <true> if successfull."

	^self basicLockKey: (self bytesFromKey: aKey)! !

!ODBBTreeDictionary methodsFor: 'private' stamp: ''!
objectCommitted
	"Changes have been committed, update object."

	changed := nil.
	initialSize := initialSize + deltaSize.
	deltaSize := 0! !

!ODBBTreeDictionary methodsFor: 'private' stamp: ''!
objectLoaded
	"Sent to transaction object when it is loaded into transaction."

	initialSize := dataBaseObject iterator getSizeAt: transaction versionDescriptor
				oldHolders: transaction oldHolders! !

!ODBBTreeDictionary methodsFor: 'private' stamp: ''!
objectStored
	"Sent to transaction object when it is stored for the first time."

	| container |
	changed notNil 
		ifTrue: 
			[container := holder container.
			changed do: 
					[:eachValue | 
					eachValue isRemoved ifFalse: [transaction makePersistent: eachValue object in: container]]]! !

!ODBBTreeDictionary methodsFor: 'public' stamp: ''!
removeKey: aKey 
	^self removeKey: aKey ifLocked: [ODBCannotLockKey signal]! !

!ODBBTreeDictionary methodsFor: 'public' stamp: ''!
removeKey: aKey ifLocked: aBlock 
	| key value |
	key := self bytesFromKey: aKey.
	(self basicLockKey: key) ifFalse: [^aBlock value].
	value := self valueAt: key ifAbsent: [^nil].
	value isRemoved 
		ifFalse: 
			[value removed.
			changed isNil ifTrue: [changed := self newChangedDictionary].
			changed at: key put: value.
			deltaSize := deltaSize - 1]! !

!ODBBTreeDictionary methodsFor: 'public' stamp: ''!
size
	"Answer number of keys in receiver.
	(metodo je treba spremeniti, ce so reference na objekte iz 
	transakcije weak -> sizeHolder mora biti iz verzije pred startom transakcije)"

	^initialSize + deltaSize! !

!ODBBTreeDictionary methodsFor: 'public' stamp: ''!
unlockKey: aKey 
	"Unlocks key aKey. Answer <true> if successfull."

	| lock key |
	dataBaseObject isNil ifTrue: [^true].
	key := self bytesFromKey: aKey.
	changed isNil ifFalse: [(changed includes: key) ifTrue: [^false]].
	locks isNil ifTrue: [^transaction isGlobalLocked].
	lock := locks at: key ifAbsent: [^false].
	(dataBaseObject unlockKey: key with: lock lockID) ifFalse: [^false].
	transaction removeLoggedLock: lock.
	locks removeKey: key.
	^true! !

ODBBTreeDictionary subclass: #ODBBTreeIdentityDictionary
	instanceVariableNames: 'newKeys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
at: aKey ifAbsent: aBlock 
	| oid |
	^transaction isNil 
		ifTrue: [newKeys at: aKey odbResolve ifAbsent: aBlock]
		ifFalse: 
			[(oid := transaction getObjectIDOrNil: aKey) isNil 
				ifTrue: [newKeys at: aKey ifAbsent: aBlock]
				ifFalse: [super at: oid ifAbsent: aBlock]]! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
at: aKey put: anObject ifLocked: aBlock 
	"Associate aKey with anObject.
	Evaluate aBlock if aKey has been locked before in some other transaction."

	| oid |
	^transaction isNil 
		ifTrue: [newKeys at: aKey odbResolve put: anObject]
		ifFalse: 
			[(oid := transaction getObjectIDOrNil: aKey) isNil 
				ifTrue: [newKeys at: aKey put: anObject]
				ifFalse: 
					[super 
						at: oid
						put: anObject
						ifLocked: aBlock]]! !

!ODBBTreeIdentityDictionary methodsFor: 'private' stamp: ''!
bytesFromKey: anObjectID 
	^anObjectID contents! !

!ODBBTreeIdentityDictionary methodsFor: 'private' stamp: ''!
commit: serializer 
	"Object IDs have been allocated. Add associations."

	newKeys keysAndValuesDo: 
			[:eachKey :eachValue | 
			self addKey: (self bytesFromKey: (transaction getObjectID: eachKey)) value: eachValue].
	super commit: serializer! !

!ODBBTreeIdentityDictionary methodsFor: 'private' stamp: ''!
databaseObjectClass
	^ODBDBBTreeIdentityDictionary! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
includesKey: aKey 
	| oid |
	^transaction isNil 
		ifTrue: [newKeys includesKey: aKey odbResolve]
		ifFalse: 
			[(oid := transaction getObjectIDOrNil: aKey) isNil 
				ifTrue: [newKeys includesKey: aKey]
				ifFalse: [super includesKey: oid]]! !

!ODBBTreeIdentityDictionary methodsFor: 'private' stamp: ''!
initialize
	super initialize.
	keySize := ODBObjectID sizeInBytes.
	newKeys := IdentityDictionary new! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
isChanged
	^super isChanged or: [newKeys notEmpty]! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
isKeyLocked: aKey 
	"Answer <true> if aKey is locked."

	| oid |
	^(transaction isNil or: [(oid := transaction getObjectIDOrNil: aKey) isNil]) 
		ifTrue: [false]
		ifFalse: [super isKeyLocked: oid]! !

!ODBBTreeIdentityDictionary methodsFor: 'private' stamp: ''!
keyFromBytes: aByteArray 
	transaction referenceAt: (ODBObjectID new fromBytes: aByteArray at: 1)! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
keys
	"Answer collection of all keys in the dictionary.
	NOTE: All objects will be loaded in one transaction at once.
	Do not use this method if there are a lot of objects in the dictionary since this could block your image for some time."

	| coll assoc |
	coll := OrderedCollection new: self size.
	coll addAll: newKeys keys.
	transaction isNil 
		ifFalse: 
			[assoc := self getFirst.
			[assoc isNil] whileFalse: 
					[coll add: (transaction referenceAt: (ODBObjectID new fromBytes: assoc key at: 1)).
					assoc := self getNext]].
	^coll! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
keysFrom: key1 to: key2 do: aBlock 
	"Evaluate aBlock for each key in the given key range."

	self error: 'Invalid message for this class'! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
lockKey: aKey 
	"Lock key aKey so that other transactions wont be able
	to change it. Answer <true> if successfull."

	| oid |
	^(transaction isNil or: [(oid := transaction getObjectIDOrNil: aKey) isNil]) 
		ifTrue: [true]
		ifFalse: [super lockKey: oid]! !

!ODBBTreeIdentityDictionary methodsFor: 'private' stamp: ''!
objectCommitted
	"Changes have been committed, update object."

	super objectCommitted.
	newKeys := IdentityDictionary new! !

!ODBBTreeIdentityDictionary methodsFor: 'private' stamp: ''!
objectStored
	"Sent to transaction object when it is stored for the first time.
	Remove all persistent objects which were put into dictionary before itself was persistent."

	| oid |
	super objectStored.
	newKeys copy keysAndValuesDo: 
			[:eachKey :eachValue | 
			(oid := transaction getObjectIDOrNil: eachKey) isNil 
				ifFalse: 
					[super 
						at: oid
						put: eachValue
						ifLocked: [ODBCannotLockKey signal].
					newKeys removeKey: eachKey]]! !

!ODBBTreeIdentityDictionary methodsFor: 'private' stamp: ''!
odbAboutToCommitIn: anOmniBaseTransaction 
	"Sent before transaction writes changes to the database (right before commit).
	In this method you can use transaction the same way as usual."

	| container |
	container := holder container.
	newKeys keysAndValuesDo: 
			[:eachKey :eachValue | 
			transaction
				makePersistent: eachKey in: container;
				makePersistent: eachValue in: container]! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
removeKey: aKey ifLocked: aBlock 
	| oid |
	^transaction isNil 
		ifTrue: [newKeys removeKey: aKey odbResolve ifAbsent: []]
		ifFalse: 
			[(oid := transaction getObjectIDOrNil: aKey) isNil 
				ifTrue: [newKeys removeKey: aKey ifAbsent: []]
				ifFalse: [super removeKey: oid ifLocked: aBlock]]! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
size
	^super size + newKeys size! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
unlockKey: aKey 
	"Unlocks key aKey. Answer <true> if successfull."

	| oid |
	^(transaction isNil or: [(oid := transaction getObjectIDOrNil: aKey) isNil]) 
		ifTrue: [true]
		ifFalse: [super unlockKey: oid]! !

!ODBBTreeIdentityDictionary methodsFor: 'public' stamp: ''!
values
	^newKeys values , super values! !

!ODBBTreeIndexDictionary class methodsFor: 'as yet unclassified' stamp: 'cdg 3/13/2003 18:06'!
createWithKeyLength: keyLength
        "Answer new instance of dictionary with max keyLength characters for keys."

    ^self new keySize: keyLength! !

!ODBBTreeIndexDictionary methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
at: aKey

    ^self at: aKey ifAbsent: []! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: 'jf 1/28/2004 10:52'!
at: aKey ifAbsentPut: aBlock 
	^ self at: aKey ifAbsent: [self at: aKey put: aBlock value]! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
at: aKey ifAbsent: aBlock 
	| key value |
	key := self bytesFromKey: aKey.
	value := self valueAt: key ifAbsent: [^aBlock value].
	value isRemoved ifTrue: [^aBlock value].
	^value getObjectIn: transaction! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
at: aKey put: anObject 
	"Associate aKey with anObject. Answer anObject."

	| key value |
	key := self bytesFromKey: aKey.
	value := self valueAt: key.
	value object: anObject.
	changed isNil ifTrue: [changed := self newChangedDictionary].
	changed at: key put: value.
	^anObject! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
basicGoTo: aByteArray 
	currentKey := aByteArray.
	changed isNil ifFalse: [changed goTo: currentKey]! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
bytesFromKey: anObject 
	^anObject asBtreeKeyOfSize: keySize! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
commitChanged
	"Private - Commit changes on an already existing dictionary."

	| changesPackage newValue vn oldHolders |
	changesPackage := transaction changesPackage.
	changesPackage add: (ODBDictionaryChanged new transactionObject: self).
	vn := transaction versionNumber.
	oldHolders := transaction oldHolders.
	changed isNil 
		ifFalse: 
			[changed keysAndValuesDo: 
					[:key :oldValue | 
					newValue := oldValue makeNewVersion: oldHolders.
					newValue versionNumber: vn.
					oldValue isRemoved 
						ifFalse: [newValue objectID: (transaction getObjectID: newValue object)].
					changesPackage add: ((ODBAssociationChanged new)
								key: key;
								setObjectID: holder objectID transactionObject: self;
								oldValue: oldValue;
								newValue: newValue)]]! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
commitNew
	"Private - Commit changes when new database object needs to be created."

	| newHolder newDBObject vn |
	vn := transaction versionNumber.
	newHolder := (holder makeNewVersion: transaction oldHolders)
				persistentClassID: self databaseObjectClass classID;
				versionNumber: vn.
	newDBObject := self databaseObjectClass new createOn: newHolder keySize: keySize.
	changed notNil 
		ifTrue: 
			[changed keysAndValuesDo: 
					[:key :value | 
					value isRemoved 
						ifFalse: 
							[value
								objectID: (transaction getObjectID: value object);
								versionNumber: vn.
							newDBObject at: key put: value]]].
	(transaction changesPackage)
		add: ((ODBNewObjectVersion new)
					setObjectID: holder objectID transactionObject: self;
					oldVersion: holder;
					newVersion: newHolder);
		add: ((ODBDictionaryChanged new)
					transactionObject: self;
					dataBaseObject: newDBObject)! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
commit: serializer 
	"Commit changes."

	dataBaseObject isNil ifTrue: [self commitNew] ifFalse: [self commitChanged]! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
databaseObjectClass
	^ODBDBBTreeIndexDictionary! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
dbPeekNext
	| iterator assoc valueHolder |
	dataBaseObject isNil ifTrue: [^nil].
	iterator := dataBaseObject iterator.
	"critical section begin"
	iterator critical: 
			[iterator goTo: currentKey.
			
			[(assoc := iterator getNext) isNil ifTrue: [^nil].
			valueHolder := ODBValueHolder createOn: assoc value.
			[transaction versionDescriptor versionOK: valueHolder versionNumber] 
				whileFalse: [valueHolder loadPreviousVersionFrom: transaction oldHolders].
			valueHolder isRemoved] 
					whileTrue: []].
	"critical section end"
	^ODBBTreeDictionaryAssociation new 
		setTransaction: transaction
		key: (self keyFromBytes: assoc key)
		value: valueHolder! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
dbPeekPrevious
	| iterator assoc valueHolder |
	dataBaseObject isNil ifTrue: [^nil].
	iterator := dataBaseObject iterator.
	"critical section begin"
	iterator critical: 
			[iterator goTo: currentKey.
			
			[(assoc := iterator getPrevious) isNil ifTrue: [^nil].
			valueHolder := ODBValueHolder createOn: assoc value.
			[transaction versionDescriptor versionOK: valueHolder versionNumber] 
				whileFalse: [valueHolder loadPreviousVersionFrom: transaction oldHolders].
			valueHolder isRemoved] 
					whileTrue: []].
	"critical section end"
	^ODBBTreeDictionaryAssociation new 
		setTransaction: transaction
		key: (self keyFromBytes: assoc key)
		value: valueHolder! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: 'david@inspiron 10/24/2004 19:48'!
do: aBlock 
	"Evaluate aBlock for each object in the dictionary.
	NOTE: All objects will be loaded in one transaction at once.
	Do not use this method if there are a lot of objects in the dictionary since this could take some time."

	| assoc |
	assoc := self getFirst.
	[assoc isNil] whileFalse: 
			[aBlock value: assoc value.
			assoc := self getNext]! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
forKeysStartingWith: aStringOrByteArray do: aBlock 
	"Evaluate aOneArgumentBlock for every key that starts with aStringOrByteArray."

	| fromKey toKey assoc |
	fromKey := self bytesFromKey: aStringOrByteArray.
	toKey := fromKey copy.
	aStringOrByteArray size + 1 to: keySize do: [:i | toKey at: i put: 255].
	self basicGoTo: fromKey.
	(assoc := self getCurrent) isNil ifTrue: [assoc := self getNext].
	[assoc isNil] whileFalse: 
			[(toKey odbIsLessThan: assoc key) ifTrue: [^self].
			aBlock value: assoc value.
			assoc := self getNext]! !

!ODBBTreeIndexDictionary methodsFor: 'enumerating' stamp: ''!
getCurrent
	| a |
	changed isNil 
		ifFalse: 
			[(a := changed getCurrent) isNil 
				ifFalse: 
					[a valueHolder isRemoved ifTrue: [^nil].
					^a]].
	(dataBaseObject isNil 
		or: [(a := dataBaseObject iterator goToAndGetCurrentAt: currentKey) isNil]) ifTrue: [^nil].
	a := ODBValueHolder createOn: a value.
	[transaction versionDescriptor versionOK: a versionNumber] 
		whileFalse: [a loadPreviousVersionFrom: transaction oldHolders].
	a isRemoved ifTrue: [^nil].
	^ODBBTreeDictionaryAssociation new 
		setTransaction: transaction
		key: (self keyFromBytes: currentKey)
		value: a! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
getFirst
	| assoc |
	self basicGoTo: (ByteArray new: keySize).
	(assoc := self getCurrent) isNil ifTrue: [^self getNext].
	^assoc! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
getLast
	| assoc |
	self basicGoTo: ((ByteArray new: keySize) atAllPut: 255).
	(assoc := self getCurrent) isNil ifTrue: [^self getPrevious].
	^assoc! !

!ODBBTreeIndexDictionary methodsFor: 'enumerating' stamp: ''!
getNext
	| a1 a2 |
	changed isNil 
		ifFalse: 
			[[(a1 := changed peekNext) isNil] whileFalse: 
					[((a2 := self dbPeekNext) notNil and: [a2 < a1]) 
						ifTrue: 
							[changed goTo: (currentKey := a2 key).
							^a2].
					currentKey := a1 key.
					changed goToNext.
					a1 valueHolder isRemoved ifFalse: [^a1]]].
	(a2 := self dbPeekNext) isNil ifTrue: [^nil].
	currentKey := self bytesFromKey: a2 key.
	^a2! !

!ODBBTreeIndexDictionary methodsFor: 'enumerating' stamp: ''!
getPrevious
	| a1 a2 |
	changed isNil 
		ifFalse: 
			[[(a1 := changed peekPrevious) isNil] whileFalse: 
					[((a2 := self dbPeekPrevious) notNil and: [a1 < a2]) 
						ifTrue: 
							[changed goTo: (currentKey := a2 key).
							^a2].
					currentKey := a1 key.
					changed goToPrevious.
					a1 valueHolder isRemoved ifFalse: [^a1]]].
	(a2 := self dbPeekPrevious) isNil ifTrue: [^nil].
	currentKey := self bytesFromKey: a2 key.
	^a2! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
goTo: aKey 
	self basicGoTo: (self bytesFromKey: aKey)! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
includesKey: aKey 
	| value |
	value := self valueAt: (self bytesFromKey: aKey) ifAbsent: [^false].
	^value isRemoved not! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
initialize
	"Private - Initialize receiver."

	super initialize.
	keySize := 32! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
isChanged
	"Answer <true> if object has been changed."

	^changed notNil or: [dataBaseObject isNil]! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: 'david@inspiron 10/24/2004 20:03'!
isEmpty
	^self size = 0! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
keyFromBytes: aByteArray 
	^aByteArray! !

!ODBBTreeIndexDictionary methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
keyLength

    ^keySize! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
keySize: anInteger 
	"Private - Set the key upon creation size."

	keySize := anInteger.
	(keySize < 300 and: [keySize > 1]) 
		ifFalse: [OmniBase signalError: 'Please choose key size between 2 and 300 bytes']! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
keysFrom: key1 to: key2 do: aBlock 
	"Evaluate aBlock for each key in the given key range."

	| toKey assoc |
	toKey := self bytesFromKey: key2.
	self goTo: key1.
	(assoc := self getCurrent) isNil ifTrue: [assoc := self getNext].
	[assoc isNil] whileFalse: 
			[(toKey odbIsLessThan: assoc key) ifTrue: [^self].
			aBlock value: assoc key.
			assoc := self getNext]! !

!ODBBTreeIndexDictionary methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:06'!
newChangedDictionary

    ^ODBSortedDictionary new! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
objectCommitted
	"Private - Changes have been committed, update object."

	changed := nil! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
removeKey: aKey 
	| key value |
	key := self bytesFromKey: aKey.
	value := self valueAt: key ifAbsent: [^nil].
	value isRemoved 
		ifFalse: 
			[value removed.
			changed isNil ifTrue: [changed := self newChangedDictionary].
			changed at: key put: value]! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
selectKeysFrom: prefix1 to: prefix2 
	"Select all keys between prefix1 and prefix2."

	| toKey keys |
	keys := OrderedCollection new.
	prefix1 size > keySize ifTrue: [^keys].
	toKey := prefix2 , ((String new: keySize - prefix2 size) atAllPut: 255 asCharacter).
	self 
		keysFrom: prefix1
		to: toKey
		do: [:key | keys add: key].
	^keys! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
selectKeysStartingWith: aString 
	"Select all keys that start with aString."

	| toKey keys |
	keys := OrderedCollection new.
	aString size > keySize ifTrue: [^keys].
	toKey := aString , ((String new: keySize - aString size) atAllPut: 255 asCharacter).
	self 
		keysFrom: aString
		to: toKey
		do: [:key | keys add: key].
	^keys! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
transactionAssociationsDo: aBlock 
	"Evaluate a block for each association in dictionary.
        New transaction will be created for each key."

	| subTransaction valueHolder versionDescriptor client |
	dataBaseObject isNil ifTrue: [OmniBase signalError: 'Object has not been stored yet'].
	versionDescriptor := transaction versionDescriptor.
	client := transaction client.
	dataBaseObject associationsDo: 
			[:assoc | 
			valueHolder := assoc value.
			[versionDescriptor versionOK: valueHolder versionNumber] 
				whileFalse: [valueHolder loadPreviousVersionFrom: transaction oldHolders].
			valueHolder isRemoved 
				ifFalse: 
					[subTransaction := client newTransactionFrom: transaction.
					aBlock value: subTransaction
						value: (Association key: assoc key
								value: (subTransaction referenceAt: valueHolder objectID)).
					subTransaction abort]]! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
transactionDo: aBlock 
	"Evaluate a block for every object in dictionary.
        New transaction will be created for each key+value pair."

	| subTransaction client versionDescriptor |
	dataBaseObject isNil ifTrue: [OmniBase signalError: 'Object has not been stored yet'].
	versionDescriptor := transaction versionDescriptor.
	client := transaction client.
	dataBaseObject valuesDo: 
			[:valueHolder | 
			[versionDescriptor versionOK: valueHolder versionNumber] 
				whileFalse: [valueHolder loadPreviousVersionFrom: transaction oldHolders].
			valueHolder isRemoved 
				ifFalse: 
					[subTransaction := client newTransaction.
					"take new version descriptor"
					versionDescriptor := subTransaction versionDescriptor.
					aBlock value: subTransaction value: (subTransaction objectAt: valueHolder objectID).
					subTransaction abort]]! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
transactionReadOnlyDo: aBlock 
	"Evaluate a block for every object in dictionary.
	New transaction will be created for each key+value pair."

	| subTransaction versionDescriptor client |
	dataBaseObject isNil ifTrue: [OmniBase signalError: 'Object has not been stored yet'].
	versionDescriptor := transaction versionDescriptor.
	client := transaction client.
	dataBaseObject valuesDo: 
			[:valueHolder | 
			[versionDescriptor versionOK: valueHolder versionNumber] 
				whileFalse: [valueHolder loadPreviousVersionFrom: transaction oldHolders].
			valueHolder isRemoved 
				ifFalse: 
					[subTransaction := client newTransactionFrom: transaction.
					aBlock value: subTransaction value: (subTransaction objectAt: valueHolder objectID).
					subTransaction abort]]! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
transactionValueBlocksDo: aBlock 
	"Evaluate a block for every 100 objects in dictionary.
        New transaction is created each time aBlock is evaluated."

	| subTransaction objects count client versionDescriptor |
	dataBaseObject isNil ifTrue: [OmniBase signalError: 'Object has not been stored yet'].
	client := transaction client.
	count := 0.
	objects := OrderedCollection new: 40.
	subTransaction := client newTransaction.
	"take new version descriptor"
	versionDescriptor := subTransaction versionDescriptor.
	
	[dataBaseObject valuesDo: 
			[:valueHolder | 
			[versionDescriptor versionOK: valueHolder versionNumber] 
				whileFalse: [valueHolder loadPreviousVersionFrom: transaction oldHolders].
			valueHolder isRemoved 
				ifFalse: 
					[objects add: (subTransaction objectAt: valueHolder objectID).
					(count := count + 1) == 40 
						ifTrue: 
							[aBlock value: subTransaction value: objects.
							subTransaction abort.
							count := 0.
							objects := OrderedCollection new: 40.
							subTransaction := client newTransaction.
							"take new version descriptor"
							versionDescriptor := subTransaction versionDescriptor]]].
	count > 0 ifTrue: [aBlock value: subTransaction value: objects]] 
			ensure: [subTransaction abort]! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
valueAt: key 
	"Private - Answer persistent object value at key  with right version loaded."

	^self valueAt: key ifAbsent: [ODBValueHolder new]! !

!ODBBTreeIndexDictionary methodsFor: 'private' stamp: ''!
valueAt: aKey ifAbsent: aBlock 
	"Private - Answer correct version of value holder at aKey, evaluate aBlock if absent."

	| value |
	changed isNil 
		ifFalse: 
			[value := changed at: aKey.
			value isNil ifFalse: [^value]].
	dataBaseObject isNil ifTrue: [^aBlock value].
	(value := dataBaseObject iterator goToAndGetCurrentAt: aKey) isNil 
		ifTrue: [^aBlock value].
	value := ODBValueHolder createOn: value value.
	[transaction versionDescriptor versionOK: value versionNumber] 
		whileFalse: [value loadPreviousVersionFrom: transaction oldHolders].
	^value! !

!ODBBTreeIndexDictionary methodsFor: 'public' stamp: ''!
values
	"Answer collection of all objects in the dictionary.
	NOTE: All objects will be loaded in one transaction at once.
	Do not use this method if there are a lot of objects in the dictionary since this could block your image for some time."

	| coll assoc |
	coll := OrderedCollection new.
	assoc := self getFirst.
	[assoc isNil] whileFalse: 
			[coll add: assoc value.
			assoc := self getNext].
	^coll! !

ODBBTreeIndexDictionary subclass: #ODBBTreeIntegerIndexDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBBTreeIntegerIndexDictionary class methodsFor: 'public' stamp: 'david@inspiron 10/30/2004 14:53'!
new
	^super new keySize: 4! !

!ODBBTreeIntegerIndexDictionary methodsFor: 'private' stamp: 'david@inspiron 11/16/2004 10:54'!
bytesFromKey: anInteger 
	^((ByteArray new: 4) odbLongAt: 1 put: anInteger) reverse! !

!ODBBTreeIntegerIndexDictionary methodsFor: 'private' stamp: 'david@inspiron 10/30/2004 16:29'!
databaseObjectClass
	^ODBDBBTreeIntegerIndexDictionary! !

!ODBBTreeIntegerIndexDictionary methodsFor: 'private' stamp: 'david@inspiron 10/30/2004 15:47'!
initialize
	"Private - Initialize receiver."

	super initialize.
	keySize := 4! !

!ODBBTreeIntegerIndexDictionary methodsFor: 'private' stamp: 'david@inspiron 11/16/2004 10:54'!
keyFromBytes: aByteArray 
	^aByteArray reverse odbLongAt: 1! !

ODBBTreeIndexDictionary subclass: #ODBBTreeMultiValueDictionary
	instanceVariableNames: 'deltaSize initialSize newObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBBTreeMultiValueDictionary methodsFor: 'public' stamp: ''!
add: anAssociation 
"
	self atKey: anAssociation key put: anAssociation value.
	^anAssociation"! !

!ODBBTreeMultiValueDictionary methodsFor: 'public' stamp: ''!
atKey: aKey add: anObject! !

!ODBBTreeMultiValueDictionary methodsFor: 'public' stamp: ''!
at: aKey 
	^self valuesAt: aKey! !

!ODBBTreeMultiValueDictionary methodsFor: 'public' stamp: ''!
at: aKey put: anObject 
	^self atKey: aKey add: anObject! !

!ODBBTreeMultiValueDictionary methodsFor: 'public' stamp: 'david@inspiron 9/7/2004 10:46'!
COMMENT
	"This class is not yet implemented."

	! !

!ODBBTreeMultiValueDictionary methodsFor: 'private' stamp: ''!
initialize
	"Private - Initialize receiver."

	super initialize.
	initialSize := 0.
	deltaSize := 0! !

!ODBBTreeMultiValueDictionary methodsFor: 'public' stamp: ''!
valuesAt: aKey
! !

ODBTransactionObject subclass: #ODBRootObjectHolder
	instanceVariableNames: 'changed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBRootObjectHolder methodsFor: 'public' stamp: ''!
commit: serializer 
	"Commit changes."

	| change newHolder |
	changed == true 
		ifTrue: 
			[newHolder := (holder makeNewVersion: transaction oldHolders)
						persistentClassID: ODBRootObjectDBHolder classID;
						versionNumber: transaction versionNumber;
						rootObjectID: (transaction getObjectID: dataBaseObject).
			change := (ODBNewObjectVersion new)
						setObjectID: holder objectID transactionObject: self;
						oldVersion: holder;
						newVersion: newHolder.
			transaction changesPackage add: change]! !

!ODBRootObjectHolder methodsFor: 'transaction processing' stamp: 'cdg 3/13/2003 18:06'!
isChanged
		"Answer <true> if object has been changed."

	^changed == true! !

!ODBRootObjectHolder methodsFor: 'public' stamp: ''!
objectCommitted
	"Sent from change after it has committed."

	changed := false! !

!ODBRootObjectHolder methodsFor: 'public' stamp: ''!
objectLoaded
	"Sent to transaction object when it has been loaded into transaction."

	dataBaseObject := transaction objectAt: dataBaseObject! !

!ODBRootObjectHolder methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:06'!
rootObject
        "Answer object represented by receiver."

    ^dataBaseObject! !

!ODBRootObjectHolder methodsFor: 'public' stamp: ''!
rootObject: anObject 
	"Set object represented by the receiver."

	changed := true.
	transaction makePersistent: anObject.
	dataBaseObject := anObject! !

ODBTransactionObject subclass: #ODBSerializedObject
	instanceVariableNames: 'changed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBSerializedObject methodsFor: 'public' stamp: 'dg 4/30/2005 16:32'!
commit: serializer 
	"Commit changes."

	| change bytes referenceManager newHolder classID |
	changed == true ifFalse: [^self].
	referenceManager := ODBReferenceManager new.
	bytes := ODBMemoryWriteStream new.
	serializer 
		serialize: dataBaseObject odbObject
		onStream: bytes
		referenceManager: referenceManager
		classManager: transaction environment classManager.
	bytes := referenceManager asBytesWith: bytes asByteArray.
	classID := referenceManager databaseObjectClassID.
	newHolder := (holder makeNewVersion: transaction oldHolders)
				persistentClassID: classID;
				versionNumber: transaction versionNumber.
	newHolder storeBytes: bytes.
	change := (ODBNewObjectVersion new)
				setObjectID: holder objectID transactionObject: self;
				oldVersion: holder;
				newVersion: newHolder.
	transaction changesPackage add: change! !

!ODBSerializedObject methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
isChanged
        "Answer <true> if object has been changed."

    ^changed == true! !

!ODBSerializedObject methodsFor: 'public' stamp: ''!
objectChanged
	"This message is sent from transaction the first time it is marked as dirty."

	changed := true! !

!ODBSerializedObject methodsFor: 'public' stamp: ''!
objectCommitted
	"Sent from change after it has committed."

	changed := false! !

!ODBSerializedObject methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
objectLoaded
                "Sent to transaction object when it is loaded into transaction."

	dataBaseObject odbLoadedIn: transaction.! !

!ODBSerializedObject methodsFor: 'public/transaction processing' stamp: 'cdg 3/13/2003 18:06'!
objectStored
		"Sent to transaction object when object was made persistent."

	changed := true.
	dataBaseObject odbMadePersistentIn: transaction.! !

!ODBSerializedObject methodsFor: 'public' stamp: ''!
value
	"Answer object represented by receiver."

	^dataBaseObject! !

!ODBSerializedObject methodsFor: 'public' stamp: ''!
value: anObject 
	"Set the object represented by the receiver."

	dataBaseObject := anObject.
	changed := true! !

!ODBTransactionObject class methodsFor: 'instance creation' stamp: 'cdg 3/13/2003 18:05'!
new

    ^super new initialize! !

!ODBTransactionObject methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
dataBaseObject

    ^dataBaseObject! !

!ODBTransactionObject methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
initialize! !

!ODBTransactionObject methodsFor: 'transaction processing' stamp: 'cdg 3/13/2003 18:05'!
isLocked
        "Answer <true> if the receiver is localy locked."

    ^lockObject notNil! !

!ODBTransactionObject methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
isODBTransactionObject

    ^true! !

!ODBTransactionObject methodsFor: 'public' stamp: ''!
lock
	"Lock receiver."

	| lockID lockObj |
	lockObject isNil 
		ifTrue: 
			[(lockID := transaction lockID) isNil ifTrue: [^false].
			transaction isGlobalLocked ifTrue: [^true].
			lockObj := ODBObjectLock new.
			lockObj
				objectID: holder objectID;
				lockID: lockID.
			transaction addLock: lockObj.
			(holder lockWith: lockID) 
				ifFalse: 
					[transaction removeLock: lockObj.
					^false].
			lockObject := lockObj].
	^true! !

!ODBTransactionObject methodsFor: 'public' stamp: ''!
objectChanged
	"This message is sent from transaction the first time it is marked as dirty."

	! !

!ODBTransactionObject methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
objectHolder

    ^holder! !

!ODBTransactionObject methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
objectID

    ^holder objectID! !

!ODBTransactionObject methodsFor: 'public' stamp: ''!
objectLoaded
	"Sent to transaction object when it is loaded into transaction."

	! !

!ODBTransactionObject methodsFor: 'public' stamp: ''!
objectStored
	"Sent to transaction object when it is stored for the first time."

	! !

!ODBTransactionObject methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
setDataBaseObject: anObject

    dataBaseObject := anObject! !

!ODBTransactionObject methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
setObjectHolder: anObjectHolder

    holder := anObjectHolder! !

!ODBTransactionObject methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
setObjectHolder: anObjectHolder dataBaseObject: aDatabaseObject transaction: aTransaction

    holder := anObjectHolder.
    dataBaseObject := aDatabaseObject.
    transaction := aTransaction! !

!ODBTransactionObject methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
setObjectHolder: anObjectHolder transaction: aTransaction

    holder := anObjectHolder.
    transaction := aTransaction! !

!ODBTransactionObject methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
transaction

    ^transaction! !

!ODBTransactionObject methodsFor: 'public' stamp: ''!
unlock
	"Unlock receiver."

	lockObject isNil 
		ifFalse: 
			[(holder unlockWith: lockObject lockID) ifFalse: [^false].
			transaction removeLock: lockObject.
			lockObject := nil].
	^true! !

!ODBTransactionObject methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
value
        "Answer object represented by receiver. Default <self>."! !

Object subclass: #ODBUndefinedObject
	instanceVariableNames: 'basicHash variables indexedVariables bytes classInfo basicSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBUndefinedObject methodsFor: 'public' stamp: ''!
className
	^classInfo name! !

!ODBUndefinedObject methodsFor: 'public' stamp: ''!
instVarNames
	^classInfo instVarNames! !

!ODBUndefinedObject methodsFor: 'public' stamp: ''!
instVarValues
	^variables! !

!ODBUndefinedObject methodsFor: 'private' stamp: 'ac 3/14/2004 19:53'!
odbLoadVariables: deserializer classInfo: aClassInfo 
	"Private - Deserialize instance of a nonexisting class."

	| stream |
	stream := deserializer stream.
	classInfo := aClassInfo.
	classInfo isVariable 
		ifTrue: [basicSize := stream getPositiveInteger]
		ifFalse: [basicSize := 0].
	deserializer register: self.
	classInfo isBytes 
		ifTrue: [stream getBytesFor: (bytes := ByteArray new: basicSize) len: basicSize]
		ifFalse: 
			[variables := Array new: classInfo instSize.
			1 to: classInfo instSize do: [:i | variables at: i put: deserializer odbNextObject].
			basicSize > 0 ifTrue: [indexedVariables := Array new: basicSize].
			1 to: basicSize do: [:i | indexedVariables at: i put: deserializer odbNextObject]].
	^self odbDeserialized: deserializer! !

Object subclass: #ODBVersionDescriptor
	instanceVariableNames: 'versionNumber readVersionNumber topVersionNumber committingTransactions myCommits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBVersionDescriptor methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
committingTransactions

        ^committingTransactions! !

!ODBVersionDescriptor methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
copy

    ^self class new
        topVersionNumber: topVersionNumber
        readVersionNumber: readVersionNumber
        committingTransactions: committingTransactions! !

!ODBVersionDescriptor methodsFor: 'private' stamp: ''!
fromVersionTable: aByteArray 
	"Private - Initialize receiver."

	| i vn size |
	topVersionNumber := aByteArray odbLongAt: 1.
	readVersionNumber := topVersionNumber.
	committingTransactions := OrderedCollection new.
	i := 5.
	size := aByteArray size.
	[i < size] whileTrue: 
			[(vn := aByteArray odbLongAt: i) == 0 
				ifFalse: 
					[committingTransactions add: vn.
					vn <= readVersionNumber ifTrue: [readVersionNumber := vn - 1]].
			i := i + 4]! !

!ODBVersionDescriptor methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
topVersionNumber

        ^topVersionNumber! !

!ODBVersionDescriptor methodsFor: 'private/unclassified' stamp: 'cdg 3/13/2003 18:05'!
topVersionNumber: tvn readVersionNumber: rvn committingTransactions: ct
                "Private - Initialize receiver variables."

        topVersionNumber := tvn.
        readVersionNumber := rvn.
        committingTransactions := ct asArray! !

!ODBVersionDescriptor methodsFor: 'public' stamp: ''!
versionAtStartOK: aVersionNumber 
	"Answer true if object with aVersionNumber can be read. 
	Current transaction commits are ignored."

	aVersionNumber <= readVersionNumber ifTrue: [^true].
	aVersionNumber <= topVersionNumber ifFalse: [^false].
	^(committingTransactions includes: aVersionNumber) not! !

!ODBVersionDescriptor methodsFor: 'public/unclassified' stamp: 'cdg 3/13/2003 18:05'!
versionNumber
        "Answer version number for read-write transactions."

    ^versionNumber! !

!ODBVersionDescriptor methodsFor: 'private' stamp: ''!
versionNumber: anInteger 
	"Private - Set version number."

	| index |
	(versionNumber := anInteger) isNil 
		ifFalse: 
			[myCommits isNil ifTrue: [myCommits := OrderedCollection new: 4].
			(index := committingTransactions indexOf: anInteger) == 0 
				ifFalse: [committingTransactions at: index put: -1].
			myCommits add: anInteger]! !

!ODBVersionDescriptor methodsFor: 'public' stamp: ''!
versionOK: aVersionNumber 
	"Answer true if object with aVersionNumber can be read."

	aVersionNumber <= readVersionNumber ifTrue: [^true].
	aVersionNumber <= topVersionNumber 
		ifTrue: [^(committingTransactions includes: aVersionNumber) not].
	myCommits isNil ifTrue: [^false].
	^myCommits includes: aVersionNumber! !

!ODBVersionDescriptor methodsFor: 'public' stamp: ''!
= anObject 
	anObject class == self class ifFalse: [^false].
	^topVersionNumber == anObject topVersionNumber 
		and: [committingTransactions size == anObject committingTransactions size]! !

Object subclass: #OmniBase
	instanceVariableNames: 'rootDir objectManager classManager clientManager transactionManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

OmniBase class
	instanceVariableNames: 'currentTransaction processToTransactionDict processToTransactionMutex sessions'!

!OmniBase class methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
add: anOmniBase
		"Private - Registers an opened database session."

	sessions isNil ifTrue: [sessions := OrderedCollection new].
	sessions add: anOmniBase.! !

!OmniBase class methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
allSessions
		"Answers a collection of all opened database sessions."

	^sessions! !

!OmniBase class methodsFor: 'public' stamp: ''!
checkpoint
	"Commit all changes in persistent objects to the database
	and leave all locks set. Current transaction can still be used
	to change more objects."

	self currentTransaction checkpoint! !

!OmniBase class methodsFor: 'public' stamp: ''!
closeAll
	"Closes all opened database sessions. Do not use this method if you're using
	the Source Tracking System for development since it will also close its connection
	to the source code repository."

	sessions isNil ifTrue: [^false].
	sessions copy 
		do: [:each | [each close] on: Error do: [:er | sessions remove: each ifAbsent: []]]! !

!OmniBase class methodsFor: 'public' stamp: ''!
commit
	"Commit all changes in persistent objects to the database
	and release all locks. Current transaction can not be used
	anymore."

	self currentTransaction commit! !

!OmniBase class methodsFor: 'public' stamp: ''!
confirmationMessage: aString 
	^MessageBox confirm: aString! !

!OmniBase class methodsFor: 'public' stamp: ''!
createOn: dirName 
	"Creates new database on a given directory pathname."

	^self new createOn: dirName! !

!OmniBase class methodsFor: 'transaction management' stamp: 'cdg 3/13/2003 18:05'!
current
		"Answers the database session of the current active transaction."

	^self currentTransaction environment! !

!OmniBase class methodsFor: 'public' stamp: ''!
currentTransaction
	| transaction |
	transaction := currentTransaction.
	processToTransactionMutex critical: 
			[transaction := processToTransactionDict at: Processor activeProcess
						ifAbsent: [transaction]].
	transaction isNil ifFalse: [^transaction].
	self signalError: 'No transaction is active'! !

!OmniBase class methodsFor: 'transaction management' stamp: ''!
currentTransactionOrNil
	| transaction |
	transaction := currentTransaction.
	processToTransactionMutex critical: 
			[transaction := processToTransactionDict at: Processor activeProcess
						ifAbsent: [transaction]].
	^transaction! !

!OmniBase class methodsFor: 'transaction management' stamp: 'cdg 3/13/2003 18:05'!
currentTransaction: anODBLocalTransaction

	currentTransaction := anODBLocalTransaction! !

!OmniBase class methodsFor: 'handling' stamp: ''!
getCurrentAndSet: anOmniBaseTransaction for: aProcess 
	"Private - Associaties anOmniBaseTransaction with aProcess.
	Answer previous active transaction in case transactions are nested."

	| previousTxn |
	processToTransactionMutex critical: 
			[previousTxn := processToTransactionDict at: aProcess ifAbsent: [].
			processToTransactionDict at: aProcess put: anOmniBaseTransaction].
	^previousTxn! !

!OmniBase class methodsFor: 'public' stamp: 'david@inspiron 4/17/2005 11:05'!
initialize
	processToTransactionMutex isNil 
		ifTrue: 
			[processToTransactionDict := IdentityDictionary new.
			processToTransactionMutex := Semaphore forMutualExclusion]! !

!OmniBase class methodsFor: 'private' stamp: ''!
new
	self initialize.
	^super new initialize! !

!OmniBase class methodsFor: 'public' stamp: ''!
newBTreeDictionary: keySize 
	"Factory method - create a new instance of a persistent B-tree dictionary.
	This kind of persistent dictionary is using a file system b-tree below to store dictionary associations for quick access.
	A b-tree persistent dictionary can store any object that implements #asBtreeKeyOfSize: as key, and any persistent object as its value."

	^ODBBTreeDictionary createWithKeyLength: keySize! !

!OmniBase class methodsFor: 'public' stamp: ''!
newBTreeIdentityDictionary
	"Factory method - create a new instance of a persistent B-tree identity dictionary.
	This kind of persistent dictionary is using a file system b-tree below to store dictionary associations for quick access.
	A b-tree persistent identity dictionary can store only persistent objects or nil as keys and persistent objects or nil as value."

	^ODBBTreeIdentityDictionary new! !

!OmniBase class methodsFor: 'creating' stamp: 'cdg 3/13/2003 18:05'!
newBTreeIndexDictionary: keySize

	^ODBBTreeIndexDictionary createWithKeyLength: keySize! !

!OmniBase class methodsFor: 'public' stamp: ''!
newPersistentDictionary
	"Create new persistent dictionary. All dictionary keys will be 
	stored together with the dictionary if not already persistent. All
	dictionary values will be stored separately and will be made
	persistent each with its own object ID."

	| dict |
	dict := ODBPersistentDictionary new.
	self currentTransactionOrNil notNil ifTrue: [dict makePersistent].
	^dict! !

!OmniBase class methodsFor: 'public' stamp: ''!
objectAt: anODBObjectID 
	"Answer a persistent object with a given object id. The object will be fetched right away 
	without instantiating a proxy object first. Answer <nil> if object id is nonexistent i.e. 
	there is no persistent object with such oid."

	^self currentTransaction objectAt: anODBObjectID! !

!OmniBase class methodsFor: 'creating' stamp: 'cdg 3/13/2003 18:05'!
openOn: dirName

	^self new openOn: dirName! !

!OmniBase class methodsFor: 'handling' stamp: ''!
removeFor: aProcess 
	"Private - Disassociaties a transaction from aProcess."

	processToTransactionMutex 
		critical: [processToTransactionDict removeKey: aProcess ifAbsent: []]! !

!OmniBase class methodsFor: 'private' stamp: ''!
remove: anOmniBase 
	"Private - Deregisters an opened database session."

	sessions isNil ifTrue: [^self].
	sessions remove: anOmniBase ifAbsent: []! !

!OmniBase class methodsFor: 'public' stamp: ''!
rollback
	"Release all locks set in the current transaction and forget 
	all changes done on persistent objects."

	self currentTransaction abort! !

!OmniBase class methodsFor: 'public' stamp: ''!
root
	"Answer the database root object. Root object represents an entry point into the database.
	Only objects referenced from the root object will remain after the garbage collection is 
	performed on the database. By default the root object is a dictionary with persistent objects
	as its values. This can be changed if needed using message #root: on transaction."

	^self currentTransaction root! !

!OmniBase class methodsFor: 'handling' stamp: ''!
setTransaction: aTransaction for: aProcess 
	"Private - Associaties a transaction to aProcess."

	processToTransactionMutex 
		critical: [processToTransactionDict at: aProcess put: aTransaction]! !

!OmniBase class methodsFor: 'private' stamp: ''!
signalError: errorMessage 
	ODBError signal: errorMessage! !

!OmniBase class methodsFor: 'public' stamp: 'jf 2/22/2004 23:36'!
warningMessage: aString 
	self inform: aString! !

!OmniBase methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
classManager

    ^classManager! !

!OmniBase methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
clientManager

    ^clientManager! !

!OmniBase methodsFor: 'public' stamp: ''!
close
	clientManager notNil 
		ifTrue: 
			[clientManager close.
			clientManager := nil].
	classManager notNil 
		ifTrue: 
			[classManager close.
			classManager := nil].
	objectManager notNil 
		ifTrue: 
			[objectManager close.
			objectManager := nil].
	transactionManager notNil 
		ifTrue: 
			[transactionManager close.
			transactionManager := nil].
	self class remove: self! !

!OmniBase methodsFor: 'public' stamp: 'dg 12/20/2003 22:27'!
createBackupOn: newDirectoryName
	"Starts an on-line backup process and creates a backup copy
	of the receiver database.
	The database will be copied based on the current version of the data.
	The copy of the database will have its containers compacted with no old versions.
	The version counter will be reset to zero and b-trees will be reorganized to be up to 1 node full."

	OmniBaseArchiver new onlineBackup: self to: newDirectoryName! !

!OmniBase methodsFor: 'public' stamp: ''!
createOn: dirName 
	"Create new database. If a database already exists signal error."

	
	[rootDir := dirName.
	(ODBFileStream directoryExists: rootDir) 
		ifFalse: [ODBFileStream directoryCreate: rootDir].
	classManager := ODBClassManager new createOn: self.
	objectManager := ODBObjectManager new createOn: self.
	transactionManager := ODBTransactionManager new createOn: self.
	clientManager := ODBClientManager new createOn: self.
	self opened.
	clientManager localClient makeRootObject] 
			ifCurtailed: [self close]! !

!OmniBase methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
dirName

    ^rootDir! !

!OmniBase methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
existsContainerNamed: aString
        "Answer <true> if container named aString exists."

    objectManager containerNamed: aString ifAbsent: [^false].
    ^true! !

!OmniBase methodsFor: 'public' stamp: 'dg 12/20/2003 09:39'!
freeDiskSpace
	self odbToDo.
	^1024 * 1024 * 1024! !

!OmniBase methodsFor: 'public' stamp: ''!
garbageCollect
	"Garbage collect the database.
	This will do the following:
		- remove all objects which are not referenced from the database root
		- compact all container files and remove old object versions
	B-tree dictionaries will not be compacted."

	(ODBGarbageCollector new)
		reorganizeDictionaries: false;
		reorganizeIndexSets: false;
		runOn: self! !

!OmniBase methodsFor: 'public' stamp: ''!
globalLock
	"Lock database so that only one user can change objects in
	it. No locks will be made to objects stored in the database
	files while the database is globaly locked. Answer <true>
	if successfull or <false> if failed. Global write lock will
	fail if there are read-write transactions already running."

	clientManager removeDisconnectedClients.
	^clientManager localClient globalLock! !

!OmniBase methodsFor: 'public' stamp: ''!
globalUnlock
	"Release global write lock set by the local client."

	^clientManager localClient globalUnlock! !

!OmniBase methodsFor: 'initialization' stamp: 'cdg 3/13/2003 18:05'!
initialize

    ODBDatabaseObject initialize! !

!OmniBase methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
isGlobalLocked

    ^self localClient isGlobalLocked! !

!OmniBase methodsFor: 'administration' stamp: 'cdg 3/13/2003 18:05'!
localClient

    ^clientManager localClient! !

!OmniBase methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
newBTreeDictionary: keySize

	^self class newBTreeDictionary: keySize! !

!OmniBase methodsFor: 'public' stamp: ''!
newBTreeIdentityDictionary
	"Factory method - create a new instance of a persistent B-tree identity dictionary.
	This kind of persistent dictionary is using a file system b-tree below to store dictionary associations for quick access.
	A b-tree persistent identity dictionary can store only persistent objects or nil as keys and persistent objects or nil as value."

	^self class newBTreeIdentityDictionary! !

!OmniBase methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
newBTreeIndexDictionary: keySize

    ^self class newBTreeIndexDictionary: keySize! !

!OmniBase methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
newContainer: aString
        "Create new container named aString."

    ^objectManager containerNew: aString! !

!OmniBase methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
newPersistentDictionary

	^self class newPersistentDictionary! !

!OmniBase methodsFor: 'public' stamp: ''!
newReadOnlyTransaction
	"Answer new read-only transaction. Read only transactions
	are here only to prevent user code from writing into the database.
	Read-only transaction are not meant to improve concurrency since
	multi-version concurrency control is used in OmniBase and therefore
	all transactions run as read-only transactions up to the point when the
	first object is locked."

	^clientManager localClient newReadOnlyTransaction! !

!OmniBase methodsFor: 'accessing' stamp: 'cdg 3/13/2003 18:05'!
newTransaction

    ^clientManager localClient newTransaction! !

!OmniBase methodsFor: 'public' stamp: ''!
numberOfClients
	"Answer total number of client connections currently working with database.
	(this will answer how many times a database on a given directory has been opened)"

	| clients count |
	count := 0.
	clients := clientManager
				removeDisconnectedClients;
				clients.
	clients do: [:eachClient | eachClient isTerminated ifFalse: [count := count + 1]].
	clientManager closeForeignClients.
	^count! !

!OmniBase methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
objectManager

    ^objectManager! !

!OmniBase methodsFor: 'private' stamp: ''!
odbObjectID
	"Private - answer an object ID of the database connection instance.
	This is used when a persistent object is referencing current database connection.
	When deserialized it will set reference to the current database connection."

	^ODBObjectID containerID: 0 index: 4! !

!OmniBase methodsFor: 'private' stamp: ''!
opened
	"Private - Receiver has just been opened."

	self class add: self.
	
	[clientManager
		removeDisconnectedClients;
		closeForeignClients] on: Error
			do: [:er | #odbTODO]! !

!OmniBase methodsFor: 'public' stamp: ''!
openOn: dirName 
	"Open an already existing database environment. 
	Trigger an exception if failed."

	
	[rootDir := dirName.
	classManager := ODBClassManager new openOn: self.
	objectManager := ODBObjectManager new openOn: self.
	transactionManager := ODBTransactionManager new openOn: self.
	clientManager := ODBClientManager new openOn: self.
	self opened] 
			ifCurtailed: [self close].
	self freeDiskSpace < 5242880 ifTrue: [OmniBase warningMessage: 'Low disk space !!']! !

!OmniBase methodsFor: 'public' stamp: ''!
reorganize
	"Reorganize database files.
	This will do the following:
		- remove all objects which are not referenced from the database root
		- compact all container files and remove old object versions
		- compact b-tree index files"

	(ODBGarbageCollector new)
		reorganizeDictionaries: true;
		reorganizeIndexSets: true;
		runOn: self! !

!OmniBase methodsFor: 'public' stamp: ''!
setUserDescription: aString 
	"Set user description.
	This string can be read by other database connections to identify who has opened a database."

	self localClient description: aString! !

!OmniBase methodsFor: 'private' stamp: 'cdg 3/13/2003 18:05'!
transactionManager

    ^transactionManager! !

Object subclass: #OmniBaseArchiver
	instanceVariableNames: 'db newDb newVersionNumber oldHolders progressDialog progressValue versionDescriptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!OmniBaseArchiver methodsFor: 'private' stamp: ''!
copyClassManager
	| lastClassId classDescription |
	self progressNotification: 'Copying class meta information' value: 0.
	lastClassId := db classManager lastClassId.
	1 to: lastClassId
		do: 
			[:i | 
			classDescription := nil.
			[classDescription := db classManager classDescriptionAt: i] on: Error do: [:ex | ].
			newDb classManager addClassDescription: classDescription withId: i.
			self progressNotification: nil value: i / lastClassId]! !

!OmniBaseArchiver methodsFor: 'private' stamp: ''!
copyContainers
	| container i |
	i := 1.
	
	[container := db objectManager containerAt: i ifAbsent: [].
	i := i + 1.
	container isNil] 
			whileFalse: [self copyContainer: container]! !

!OmniBaseArchiver methodsFor: 'private' stamp: ''!
copyContainer: container 
	| size newContainer newIndexFile dbClass |
	self progressNotification: 'Copying container ' , container name value: 0.
	newContainer := newDb objectManager containerAt: container id
				ifAbsent: [newDb objectManager containerNew: container name].
	newIndexFile := newContainer indexFile.
	newIndexFile setLastIndex: container indexFile getLastIndex.
	size := container numberOfObjects.
	container objectHoldersDo: 
			[:eachHolder | 
			eachHolder isRemoved 
				ifTrue: [newIndexFile removeIndex: eachHolder objectID index]
				ifFalse: 
					[[versionDescriptor versionOK: eachHolder versionNumber] 
						whileFalse: [eachHolder loadPreviousVersionFrom: oldHolders].
					eachHolder versionNumber: newVersionNumber.
					dbClass := ODBDatabaseObject persistentClassAt: eachHolder persistentClassID.
					dbClass hasBytes 
						ifTrue: 
							[eachHolder setContainer: newContainer.
							newContainer 
								addByteStorageRequest: (ODBGarbageCollectorRequest new objectHolder: eachHolder
										bytes: (container loadBytesAt: eachHolder objectPosition length: eachHolder objectLength))]
						ifFalse: 
							[dbClass hasExternalFiles 
								ifTrue: 
									["backup objects using external files (b-trees)"
									eachHolder getObject 
										createBackupCopyIn: newContainer
										versionDescriptor: versionDescriptor
										oldHolders: db transactionManager oldHolders
										versionNumber: newVersionNumber].
							newIndexFile at: eachHolder objectID index put: eachHolder contents]].
			self progressNotification: nil value: eachHolder objectID index / size].
	newContainer flushBytes! !

!OmniBaseArchiver methodsFor: 'public' stamp: ''!
copyDatabase
	self
		copyContainers;
		copyClassManager! !

!OmniBaseArchiver methodsFor: 'public' stamp: 'dg 12/20/2003 22:36'!
copyDatabase: silentBool 
	silentBool = true 
		ifTrue: [self copyDatabase]
		ifFalse: 
			['OmniBase on-line backup'
				displayProgressAt: Sensor cursorPoint
				from: 0 to: 100
				during:
					[:bar |
						progressDialog := bar.
						progressValue := bar.
						self copyDatabase]]! !

!OmniBaseArchiver methodsFor: 'public' stamp: ''!
onlineBackup: anOmniBase to: newPath 
	self 
		onlineBackup: anOmniBase
		to: newPath
		silent: false! !

!OmniBaseArchiver methodsFor: 'public' stamp: ''!
onlineBackup: anOmniBase to: newPath silent: silentBool 
	newDb := OmniBase createOn: newPath.
	
	[newDb objectManager reopenExclusively.
	db := anOmniBase.
	oldHolders := db transactionManager oldHolders.
	versionDescriptor := db transactionManager versionControl versionDescriptor copy.
	newVersionNumber := newDb transactionManager versionControl 
				getNewVersionNumberFor: newDb localClient clientID.
	newDb transactionManager versionControl removeCommittingFor: newDb localClient clientID.
	self copyDatabase: silentBool] 
			ensure: [newDb close]! !

!OmniBaseArchiver methodsFor: 'private' stamp: 'dg 12/20/2003 22:34'!
progressNotification: aString value: aFraction 
	progressDialog isNil 
		ifFalse: 
			[aFraction isNil ifFalse: [progressValue value: 100 * aFraction]].! !

Object subclass: #OmniBaseTester
	instanceVariableNames: 'testDb testDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!OmniBaseTester class methodsFor: 'public' stamp: ''!
benchmarkCommitNewObjects
	| db trn dict time timeArray maxIndex maxTime stream |
	stream := WriteStream on: String new.
	db := OmniBase openOn: self testDir.
	timeArray := Array new: 6.
	maxTime := 0.
	1 to: timeArray size
		do: 
			[:count | 
			trn := db newTransaction.
			dict := OmniBase newPersistentDictionary.
			trn store: dict.
			1 to: 100
				do: 
					[:i | 
					dict at: i
						put: (Array 
								with: 'Test array'
								with: i
								with: i printString
								with: (Association key: 'Bla' value: 'Blala'))].
			time := Time millisecondsToRun: [trn commit].
			trn abort.
			stream
				nextPutAll: ' Commit time: ' , (time / 1000) asFloat printString , ' sec';
				cr.
			timeArray at: count put: time.
			time > maxTime 
				ifTrue: 
					[maxTime := time.
					maxIndex := count]].
	time := 0.
	1 to: timeArray size do: [:i | i = maxIndex ifFalse: [time := time + (timeArray at: i)]].
	time := time / (timeArray size - 1).
	stream
		nextPutAll: '------------------------';
		cr.
	stream
		nextPutAll: 'Average time: ' , (time / 1000) asFloat printString , ' sec';
		cr.
	db close.
	Transcript show: stream contents! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test1

	| db |
	[
		db := OmniBase createOn: self testDir.
	] ensure: [db close].! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test10
		"Test basic B-Tree dictionary functionality."

	| db t dict |
	db := OmniBase openOn: self testDir.
	[
		t := db newTransaction.
		dict := db newBTreeDictionary: 20.
		dict
			at: 1 put: self testCollection;
			at: 2 put: 'Dva';
			at: 3 put: nil;
			at: Date today put: 'danes';
			at: 'Test' put: 'test';
			at: 'temp' put: 'temp';
			removeKey: 'temp'.

		(dict at: 2) = 'Dva' ifFalse: [self halt].
		(dict at: 3) = nil ifFalse: [self halt].
		(dict at: Date today) = 'danes' ifFalse: [self halt].
		(dict at: 'Test') = 'test' ifFalse: [self halt].
		(dict includesKey: 'Test') ifFalse: [self halt].
		(dict includesKey: 'none') ifTrue: [self halt].
		(dict includesKey: 3) ifFalse: [self halt].
		(dict includesKey: 'temp') ifTrue: [self halt].
		dict size = 5 ifFalse: [self halt].

		t makePersistent: dict.

		(dict at: 2) = 'Dva' ifFalse: [self halt].
		(dict at: 3) = nil ifFalse: [self halt].
		(dict at: Date today) = 'danes' ifFalse: [self halt].
		(dict at: 'Test') = 'test' ifFalse: [self halt].
		(dict includesKey: 'Test') ifFalse: [self halt].
		(dict includesKey: 'none') ifTrue: [self halt].
		(dict includesKey: 3) ifFalse: [self halt].
		dict size = 5 ifFalse: [self halt].

		t checkpoint.

		(dict at: 2) = 'Dva' ifFalse: [self halt].
		(dict at: 3) = nil ifFalse: [self halt].
		(dict at: Date today) = 'danes' ifFalse: [self halt].
		(dict at: 'Test') = 'test' ifFalse: [self halt].
		(dict includesKey: 'Test') ifFalse: [self halt].
		(dict includesKey: 'none') ifTrue: [self halt].
		(dict includesKey: 3) ifFalse: [self halt].
		dict size = 5 ifFalse: [self halt].

		t root at: 'b-tree' put: dict.
		t commit.

		t := db newTransaction.
		dict := t root at: 'b-tree'.

		(dict at: 2) = 'Dva' ifFalse: [self halt].
		(dict at: 3) = nil ifFalse: [self halt].
		(dict at: Date today) = 'danes' ifFalse: [self halt].
		(dict at: 'Test') = 'test' ifFalse: [self halt].
		(dict includesKey: 'Test') ifFalse: [self halt].
		(dict includesKey: 'none') ifTrue: [self halt].
		(dict includesKey: 3) ifFalse: [self halt].
		dict size = 5 ifFalse: [self halt].

		dict removeKey: 2.
		(dict includesKey: 2) ifTrue: [self halt].
		dict size = 4 ifFalse: [self halt].
		(dict at: 2) isNil ifFalse: [self halt].

		t checkpoint.

		dict at: 2 put: 'blabla'.
		dict size = 5 ifFalse: [self halt].

		t commit.

		t := db newTransaction.
		dict := t root at: 'b-tree'.
		(dict at: 2) = 'blabla' ifFalse: [self halt].

	] ensure: [db close]! !

!OmniBaseTester class methodsFor: 'public' stamp: 'dg 12/20/2003 08:23'!
test10a
	"Test B-Tree identity dictionary functionality."

	| db t dict1 dict2 obj1 obj2 obj3 |
	db := OmniBase openOn: self testDir.
	
	[t := db newTransaction.
	dict1 := db newBTreeIdentityDictionary.
	dict2 := db newBTreeIdentityDictionary.
	obj1 := Array with: 'Array with String as obj1'.
	obj2 := Array with: obj1 with: 'Array with String and obj1 as obj2'.
	obj3 := Array with: Date today.
	t root at: 'obj2' put: obj2.
	dict1 at: obj1 put: obj2.
	(dict1 at: obj1) == obj2 ifFalse: [self halt].
	dict2 at: obj1 put: t root.
	dict2 at: t root put: obj1.
	dict1 at: t root put: obj1.
	dict2 at: t root put: dict1.
	dict2 at: dict2 put: obj1.
	(dict2 at: obj1) == t root ifFalse: [self halt].
	dict1 size = 2 ifFalse: [self halt].
	dict2 size = 3 ifFalse: [self halt].
	dict1 at: obj3 put: Date today.
	t makePersistent: dict2.
	dict2 at: obj3 put: Date today.
	dict1 removeKey: obj3.
	dict2 removeKey: obj3.
	t makePersistent: dict1.
	dict1 size = 2 ifFalse: [self halt].
	dict2 size = 3 ifFalse: [self halt].
	t checkpoint.
	(dict1 at: obj1) == obj2 ifFalse: [self halt].
	t root at: 'identity-dict1' put: dict1.
	dict1 at: t root put: dict2.
	t commit.
	t := db newTransaction.
	dict1 := t root at: 'identity-dict1'.
	dict2 := dict1 at: t root.
	obj1 := dict2 at: dict2.
	obj2 := dict1 at: obj1.
	((dict2 at: obj1) isIdenticalTo: t root) ifFalse: [self halt].
	((dict2 at: t root) isIdenticalTo: dict1) ifFalse: [self halt].
	t checkpoint.
	t commit.
	t := db newTransaction] 
			ensure: [db close]! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test11
		"Test b-tree iterator by inserting large number of associations into b-tree dictionary."

	| db dict |
	db := OmniBase openOn: self testDir.
	[
		[dict := OmniBase newBTreeDictionary: 5.
		OmniBase root at: 'big-dict' put: dict.
		0 to: 300 by: 2 do: [:i | dict at: i put: i printString].
		299 to: 1 by: -2 do: [:i | dict at: i put: i printString]]
			evaluateAndCommitIn: db newTransaction.

		[dict := OmniBase root at: 'big-dict'.
		299 to: 1 by: -2 do: [:i | (dict at: i) = i printString ifFalse: [self halt]].
		0 to: 300 by: 2 do: [:i | (dict at: i) = i printString ifFalse: [self halt]]]
			evaluateIn: db newTransaction.

	] ensure: [db close]! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test12
	"Test local B-Tree key locking"

	| db1 db2 t1 t2 dict dict2 |
	db1 := OmniBase openOn: self testDir.
	db2 := OmniBase openOn: self testDir.
	
	[t1 := db1 newTransaction.
	dict := db1 newBTreeDictionary: 5.
	t1 root at: 'concurrent-btree' put: dict.
	t1 checkpoint.
	t2 := db2 newTransaction.

	"inserting keys in one transaction"
	1 to: 100 do: [:i | dict at: i put: 'test'].
	t1 checkpoint.
	dict2 := t2 root at: 'concurrent-btree'.
	"inserting keys in another transaction"
	101 to: 200 do: [:i | dict2 at: i put: 'test'].
	t2 checkpoint.

	"every transaction sees only its own associations since t1 and t2 overlap
		(t2 was started before the t1 checkpointed its state)"
	dict size = 100 ifFalse: [self halt].
	dict2 size = 100 ifFalse: [self halt].
	t1 commit.
	t2 commit.
	t1 := db1 newTransaction.
	t2 := db2 newTransaction.
	dict := t1 root at: 'concurrent-btree'.
	dict2 := t2 root at: 'concurrent-btree'.
	(dict lockKey: 10) ifFalse: [self halt].
	(dict2 lockKey: 10) ifTrue: [self halt].
	dict unlockKey: 10.
	(dict2 lockKey: 10) ifFalse: [self halt].
	dict2 at: 10 put: 'changed'.
	t2 commit.
	(dict lockKey: 10) ifTrue: [self halt].
	"wait for half a second to ensure that version descriptor will be reloaded"
	(Delay forMilliseconds: 501) wait.
	t1 := db1 newTransaction.
	t2 := db2 newTransaction.
	dict := t1 root at: 'concurrent-btree'.
	dict at: 10 put: 'changed-again'.
	t1 commit.
	dict2 := t2 root at: 'concurrent-btree'.
	"in t2 the value should stay as it was since the t2 was started before t1 committed"
	(dict2 at: 10) = 'changed' ifFalse: [self halt].
	(dict2 lockKey: 10) ifTrue: [self halt]] 
			ensure: 
				[db1 close.
				db2 close]! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test13
	"Test garbage collection"

	| db |
	db := OmniBase openOn: self testDir.
	db garbageCollect.
	db close! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test14
	"Test database reorganization (garbage collection with b-tree index reorganization)."

	| db |
	db := OmniBase openOn: self testDir.
	db garbageCollect.
	db close! !

!OmniBaseTester class methodsFor: 'test' stamp: ''!
test15
	"Test database backup."

	| db t obj |
	db := OmniBase openOn: self testDir.
	t := db newTransaction.
	obj := Array with: 'to je test'.
	t makePersistent: obj.
	t root at: 'backup1' put: obj.
	obj := OmniBase newBTreeDictionary: 20.
	t makePersistent: obj.
	obj at: 'test' put: 'test'.
	t root at: 'backup2' put: obj.
	t commit.
	db createBackupOn: self testDir , 'BackupTest'.
	db close.
	db := OmniBase openOn: self testDir , 'BackupTest'.
	t := db newTransaction.
	(t root at: 'backup1') = (Array with: 'to je test') ifFalse: [self halt].
	((t root at: 'backup2') at: 'test') = 'test' ifFalse: [self halt].
	db close! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test2

	| db |
	[
		db := OmniBase openOn: self testDir.
		db numberOfClients.
	] ensure: [db close].! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test3

	| db |
	[
		db := OmniBase openOn: self testDir.
		[ OrderedCollection newPersistent
			add: 'string object';
			add: 1;
			add: Date today ] evaluateAndCommitIn: db newTransaction.
	] ensure: [db close]! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test4

	| db txn |
	[
		db := OmniBase openOn: self testDir.
		txn := db newTransaction.
		txn makePersistent: self testCollection.
		txn commit.
	] ensure: [db close]! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test5

	| db coll |
	[
		db := OmniBase openOn: self testDir.
		[ OmniBase root
			at: 'test'
			put: self testCollection ] evaluateAndCommitIn: db newTransaction.
		coll := db newTransaction root at: 'test'.
		#( 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 ) do: [:i |
			(coll at: i) = (self testCollection at: i)
				ifFalse: [ self error: 'Contents does not match' ]].
	] ensure: [db close]! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test6

	| db |
	[
		db := OmniBase openOn: self testDir.
		[| coll1 coll2 str |
		coll1 := OrderedCollection new.
		coll2 := OrderedCollection new.
		str := 'This is a string'.
		coll1 add: str.
		coll2 add: str.
		OmniBase root at: 'one' put: coll1.
		OmniBase root at: 'two' put: coll2. ]
			evaluateAndCommitIn: db newTransaction.
		[| coll1 coll2 |
		coll1 := OmniBase root at: 'one'.
		coll2 := OmniBase root at: 'two'.
		(coll1 first isIdenticalTo: coll2 first)
			ifTrue: [self error: 'Objects should not be identical' ].
		]
			evaluateIn: db newTransaction.
	] ensure: [db close]! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test7

	| db |
	[
		db := OmniBase openOn: self testDir.
		[ | coll1 coll2 str |
		coll1 := OrderedCollection new.
		coll2 := OrderedCollection new.
		str := 'This is a string'.
		str makePersistent.
		coll1 add: str.
		coll2 add: str.
		OmniBase root at: 'one' put: coll1.
		OmniBase root at: 'two' put: coll2. ]
			evaluateAndCommitIn: db newTransaction.
		[ | coll1 coll2 |
		coll1 := OmniBase root at: 'one'.
		coll2 := OmniBase root at: 'two'.
		(coll1 first isIdenticalTo: coll2 first)
			ifFalse: [ self error: 'Objects should be identical' ].
		] evaluateIn: db newTransaction.
	] ensure: [db close]! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test8
	"Test if local object locking works with transactions running within one database connection."

	| db t1 t2 coll collCopy |
	
	[db := OmniBase openOn: self testDir.
	"prepare"
	
	[coll := OrderedCollection with: 'This collection will be locked'.
	OmniBase root at: 'lockTest' put: coll] 
			evaluateAndCommitIn: db newTransaction.
	"test"
	t1 := db newTransaction.
	t2 := db newTransaction.
	coll := t1 root at: 'lockTest'.
	(t1 lock: coll) ifFalse: [self error: 'Object locking failed'].
	collCopy := t2 root at: 'lockTest'.
	(t2 lock: collCopy) ifTrue: [self error: 'Object locking should fail'].
	t1 abort.
	(t2 lock: collCopy) ifFalse: [self error: 'Object locking failed'].
	t1 := db newTransaction.
	coll := t1 root at: 'lockTest'.
	coll first.
	(t1 lock: coll) ifTrue: [self error: 'Object locking should fail'].
	t2 unlock: collCopy.
	t2 := db newTransaction.
	(t1 lock: coll) ifFalse: [self error: 'Object locking failed'].
	coll at: 1 put: 'Changed collection'.
	t1
		markDirty: coll;
		commit.
	collCopy := t2 root at: 'lockTest'.
	collCopy first = 'This collection will be locked' 
		ifFalse: [self error: 'Object should not change'].
	(t2 lock: collCopy) 
		ifTrue: [self error: 'Lock should fail as it is already changed in t1'].
	t2 := db newTransaction.
	coll := t2 root at: 'lockTest'.
	coll first = 'Changed collection' ifFalse: [self error: 'Object should be changed']] 
			ensure: [db close]! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
test9
	"Test if object locking works with transactions running in two database connections."

	| db1 db2 t1 t2 coll collCopy |
	
	[db1 := OmniBase openOn: self testDir.
	db2 := OmniBase openOn: self testDir.
	"prepare"
	
	[coll := OrderedCollection with: 'This collection will be locked'.
	OmniBase root at: 'lockTest' put: coll] 
			evaluateAndCommitIn: db1 newTransaction.
	"test"
	t1 := db1 newTransaction.
	t2 := db2 newTransaction.
	coll := t1 root at: 'lockTest'.
	(t1 lock: coll) ifFalse: [self error: 'Object locking failed'].
	collCopy := t2 root at: 'lockTest'.
	(t2 lock: collCopy) ifTrue: [self error: 'Object locking should fail'].
	t1 abort.
	(t2 lock: collCopy) ifFalse: [self error: 'Object locking failed'].
	t1 := db1 newTransaction.
	coll := t1 root at: 'lockTest'.
	coll first.
	(t1 lock: coll) ifTrue: [self error: 'Object locking should fail'].
	t2 unlock: collCopy.
	t2 := db2 newTransaction.
	(t1 lock: coll) ifFalse: [self error: 'Object locking failed'].
	coll at: 1 put: 'Changed collection'.
	t1
		markDirty: coll;
		commit.
	collCopy := t2 root at: 'lockTest'.
	collCopy first = 'This collection will be locked' 
		ifFalse: [self error: 'Object should not change'].
	(t2 lock: collCopy) 
		ifTrue: [self error: 'Lock should fail as it is already changed in t1'].
	"wait here a little since changes are updated every half a second (500 ms)"
	(Delay forMilliseconds: 501) wait.
	t2 := db2 newTransaction.
	coll := t2 root at: 'lockTest'.
	coll first = 'Changed collection' ifFalse: [self error: 'Object should be changed']] 
			ensure: 
				[db1 close.
				db2 close]! !

!OmniBaseTester class methodsFor: 'test' stamp: 'david/vw 9/7/2004 12:21'!
testAll
	self
		test1;
		test2;
		test3;
		test4;
		test5;
		test6;
		test7;
		test8;
		test9;
		test10;
		test10a;
		test11;
		test12;
		test13;
		test14;
		test15! !

!OmniBaseTester class methodsFor: 'public' stamp: ''!
testCollection

	| coll |
	coll := OrderedCollection new.
	coll
		add: 1;
		add: -1;
		add: true;
		add: false;
		add: nil;
		add: 1000;
		add: -1000;
		add: 0.0;
		add: 1.0;
		add: -123.43;
		add: 13 factorial;
		add: 215345245.3425;
		add: 2 / 3;
		add: Date today;
		add: (Time fromSeconds: 20000);
		add: $a;
		add: #symbol;
		add: '';
		add: 'Hello world';
		add: self;
		add: Smalltalk;
		add: (Dictionary new at: 'key' put: 'value'; yourself);
		add: IdentityDictionary new;
		add: (Array with: 'a' with: 'b');
		add: coll.
	^coll! !

!OmniBaseTester class methodsFor: 'public' stamp: 'dg 3/14/2005 12:42'!
testDir

	^'c:\temp\OmniBase-Squeak'! !

!ByteArray methodsFor: '*omnibase' stamp: 'cdg 3/14/2003 21:16'!
asBtreeKeyOfSize: keySize

	self size = keySize ifTrue: [^self].
	^(ByteArray new: keySize)
		replaceFrom: 1 to: (self size min: keySize)
		with: self
		startingAt: 1! !

!ByteArray methodsFor: '*omnibase' stamp: 'david@inspiron 1/9/2004 13:47'!
odbAsInteger
	| result each negative |
	result := 0.
	1 to: self size
		do: 
			[:i | 
			each := self at: i.
			i = 1 
				ifTrue: 
					[result := each bitAnd: 15.
					each > 31 ifTrue: [negative := true]]
				ifFalse: [result := result * 100 + (each bitAnd: 15) + ((each bitShift: -4) * 10)]].
	negative = true ifTrue: [^0 - result].
	^result! !

!ByteArray methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbIsLessOrEqualTo: aByteArray

    | i size |
    i := 1. size := self size.
    [(self at: i) = (aByteArray at: i) and: [i < size]] whileTrue: [i := i + 1].
    ^(self at: i) <= (aByteArray at: i)! !

!ByteArray methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbIsLessThan: aByteArray

    | i size |
    i := 1. size := self size.
    [(self at: i) = (aByteArray at: i) and: [i < size]] whileTrue: [i := i + 1].
    ^(self at: i) < (aByteArray at: i)! !

!ByteArray methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbLongAt: index

	^(self at: index) +
		((self at: index + 1) bitShift: 8) +
		((self at: index + 2) bitShift: 16) +
		((self at: index + 3) bitShift: 24)! !

!ByteArray methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbLongAt: index put: longValue

	self
		at: index put: (longValue bitAnd: 16rFF);
		at: index + 1 put: ((longValue bitShift: -8 ) bitAnd: 16rFF);
		at: index + 2 put: ((longValue bitShift: -16 ) bitAnd: 16rFF);
		at: index + 3 put: (longValue bitShift: -24)! !

!ByteArray methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbShortAt: index

	^(self at: index) + ((self at: index + 1) bitShift: 8)! !

!ByteArray methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbShortAt: index put: longValue

	self
		at: index put: (longValue bitAnd: 16rFF);
		at: index + 1 put: ((longValue bitShift: -8 ) bitAnd: 16rFF)! !

!Float class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbDeserialize: deserializer

	| stream number |
	stream := deserializer stream.
	number := self basicNew: 4.
	1 to: 4 do: [:i | number basicAt: i put: stream getByte ].
	^number! !

!Date class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbDeserialize: deserializer

	^deserializer register: (self fromDays: deserializer stream getInteger)! !

!Date methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 21:53'!
asBtreeKeyOfSize: keySize

	keySize < 3 ifTrue: [OmniBase signalError: 'Key size has to be at least 3 bytes to accomodate a date'].
	^self asJulianDayNumber asBtreeKeyOfSize: keySize! !

!Date methodsFor: '*omnibase' stamp: 'ac 3/18/2005 17:08'!
odbBasicSerialize: serializer

	serializer stream putByte: 32; putInteger: self asJulianDayNumber - 2415386! !

!WideString class methodsFor: '*omnibase' stamp: 'mu 8/3/2005 19:47'!
odbDeserialize: deserializer 
	| str len stream |
	str := self new: (len := (stream := deserializer stream) getPositiveInteger).
	1 to: len do: [:i | str at: i put: (Unicode value: stream getWord)].
	^deserializer register: str! !

!WideString methodsFor: '*omnibase' stamp: 'mu 8/3/2005 19:30'!
odbBasicSerialize: serializer 
	| len stream |
	len := self size.
	(stream := serializer stream)
		putByte: 36;
		putPositiveInteger: len.
	1 to: len do: [:i | stream putWord: (self at: i) charCode]! !

!UndefinedObject class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

	^nil! !

!UndefinedObject methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbBasicSerialize: serializer

	serializer stream putByte: 14! !

!UndefinedObject methodsFor: '*omnibase' stamp: ''!
odbDeserialize: deserializer

	deserializer loadError! !

!UndefinedObject methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbLoadVariables: deserializer classInfo: classInfo

	^ODBUndefinedObject new odbLoadVariables: deserializer classInfo: classInfo! !

!UndefinedObject methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbObjectID

	^ODBObjectID containerID: 0 index: 1! !

!UndefinedObject methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbSerialize: serializer

	serializer stream putByte: 14! !

!Dictionary class methodsFor: '*omnibase' stamp: 'ac 3/14/2004 19:52'!
odbDeserialize: deserializer

	| size dict key |
	size := deserializer stream getPositiveInteger.
	dict := self new: size.
	deserializer register: dict.
	size timesRepeat: [
		key := deserializer odbNextObject.
		dict at: key put: deserializer odbNextObject.
	].
	^dict! !

!Dictionary methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbBasicSerialize: serializer

	self class == Dictionary ifFalse: [ ^super odbBasicSerialize: serializer ].
	serializer
		stream putByte: 37;
		putPositiveInteger: self size.
	self keysAndValuesDo: [:key :value |
		key odbSerialize: serializer.
		value odbSerialize: serializer.
	].! !

Dictionary subclass: #ODBPersistentDictionary
	instanceVariableNames: 'transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBPersistentDictionary class methodsFor: 'public' stamp: 'ac 3/14/2004 19:53'!
odbDeserialize: deserializer 
	| size dict key |
	size := deserializer stream getPositiveInteger.
	dict := self new: size.
	deserializer register: dict.
	size timesRepeat: 
			[key := deserializer odbNextObject.
			dict superAt: key put: deserializer odbNextObject].
	^dict! !

!ODBPersistentDictionary methodsFor: 'public' stamp: ''!
add: anAssociation 
	| t |
	t := transaction.
	anAssociation key isODBReference ifTrue: [self error: 'Invalid key!!'].
	super add: anAssociation.
	transaction := t.
	transaction isNil ifTrue: [^anAssociation].
	anAssociation value isImmediate 
		ifFalse: [transaction makePersistent: anAssociation value].
	transaction markDirty: self.
	^anAssociation! !

!ODBPersistentDictionary methodsFor: 'public' stamp: ''!
asDictionary
	| dict |
	dict := Dictionary new.
	self associationsDo: [:assoc | dict add: assoc].
	^dict! !

!ODBPersistentDictionary methodsFor: 'public' stamp: ''!
at: key put: value 
	| oldValue |
	key isODBReference ifTrue: [self error: 'Invalid key!!'].
	oldValue := super at: key ifAbsent: [].
	value == oldValue ifTrue: [^value].
	oldValue := transaction.
	super at: key put: value.
	transaction := oldValue.
	transaction isNil ifTrue: [^value].
	transaction markDirty: self.
	(value isImmediate or: [value == key]) ifFalse: [transaction makePersistent: value].
	^value! !

!ODBPersistentDictionary methodsFor: 'public' stamp: ''!
odbBasicSerialize: serializer 
	(serializer stream)
		putByte: 83;
		putPositiveInteger: self size.
	self keysAndValuesDo: 
			[:key :value | 
			key odbSerialize: serializer.
			value odbSerialize: serializer]! !

!ODBPersistentDictionary methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
odbLoadedIn: anOmniBaseTransaction
		"This method is sent when the object is loaded from the database."

	transaction := anOmniBaseTransaction! !

!ODBPersistentDictionary methodsFor: 'private' stamp: ''!
odbMadePersistentIn: anOmniBaseTransaction 
	"This method is sent when the object is made persistent."

	transaction notNil 
		ifTrue: [self error: 'Object is already persistent in another transaction'].
	transaction := anOmniBaseTransaction.
	self do: [:each | each isImmediate ifFalse: [transaction makePersistent: each]]! !

!ODBPersistentDictionary methodsFor: 'public' stamp: ''!
removeKey: aKey ifAbsent: aBlock 
	| t |
	t := transaction.
	super removeKey: aKey ifAbsent: [^aBlock value].
	transaction := t.
	transaction isNil ifFalse: [transaction markDirty: self]! !

!ODBPersistentDictionary methodsFor: 'private' stamp: 'cdg 3/13/2003 18:06'!
superAt: key put: value

	^super at: key put: value! !

!ODBPersistentDictionary methodsFor: 'public' stamp: 'cdg 3/13/2003 18:06'!
transaction

	^transaction! !

Notification subclass: #ODBLockNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBLockNotification methodsFor: 'public' stamp: ''!
defaultAction
	"Display a notifier and then continue."

	^OmniBase confirmationMessage: 'File can not be locked. Do you want to try again?'! !

Notification subclass: #ODBStreamLockedNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBStreamLockedNotification methodsFor: 'public' stamp: ''!
defaultAction
	^OmniBase 
		confirmationMessage: 'File can not be read because it is locked. Do you want to try again ?'! !

!True methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbBasicSerialize: serializer

	serializer stream putByte: 15! !

!True methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbObjectID

	^ODBObjectID containerID: 0 index: 2! !

!True methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbSerialize: serializer

	serializer stream putByte: 15! !

!BlockContext methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:30'!
evaluateAndCommitIn: anOmniBaseTransaction
		"Evaluate the receiver block while setting the current transaction 
		to anOmniBaseTransaction. If an error occurs during execution of
		this block the transaction will be rolled back. If there is no error the
		transaction will be committed. Answer the result of evaluating the block."

	| activeProcess previousTxn result |
	activeProcess := Processor activeProcess.
	previousTxn := OmniBase getCurrentAndSet: anOmniBaseTransaction for: activeProcess.
	[result := self ifCurtailed: [anOmniBaseTransaction abort].
	anOmniBaseTransaction commit]
		ensure: [
			previousTxn isNil
				ifTrue: [OmniBase removeFor: activeProcess]
				ifFalse: [OmniBase setTransaction: previousTxn for: activeProcess]].
	^result! !

!BlockContext methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 17:31'!
evaluateIn: anOmniBaseTransaction
		"Evaluate the receiver block while setting the current transaction 
		to anOmniBaseTransaction. If an error occurs during execution of
		this block the transaction will be rolled back. Answer the result of
		the block."

	| activeProcess previousTxn |
	activeProcess := Processor activeProcess.
	previousTxn := OmniBase getCurrentAndSet: anOmniBaseTransaction for: activeProcess.
	^[self ifCurtailed: [anOmniBaseTransaction abort]]
		ensure: [
			previousTxn isNil
				ifTrue: [OmniBase removeFor: activeProcess]
				ifFalse: [OmniBase setTransaction: previousTxn for: activeProcess]]! !

!BlockContext methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbSerialize: serializer

	serializer cantSave: self! !

!Fraction class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbDeserialize: deserializer

	^self numerator: deserializer stream getInteger
		denominator: deserializer stream getInteger! !

!Fraction methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbBasicSerialize: serializer

	serializer stream
		putByte: 39;
		putInteger: numerator;
		putInteger: denominator! !

!Fraction methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbSerialize: serializer

	serializer stream
		putByte: 39;
		putInteger: numerator;
		putInteger: denominator! !

!FileDirectory class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 19:12'!
separatorString
	^String with: self pathNameDelimiter! !

!FileDirectory methodsFor: '*omnibase' stamp: 'cdg 3/14/2003 13:51'!
lock: aFileHandle set: aBoolean for: length
	self subclassResponsibility! !

!IdentityDictionary methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbBasicSerialize: serializer

	self class == IdentityDictionary ifFalse: [ ^super odbBasicSerialize: serializer ].
	serializer
		stream putByte: 38;
		putPositiveInteger: self size.
	self keysAndValuesDo: [:key :value |
		key odbSerialize: serializer.
		value odbSerialize: serializer.
	].! !

!StandardFileStream methodsFor: '*omnibase' stamp: 'cdg 3/14/2003 22:00'!
lock: aBoolean for: length
	self odbToDo.
	^true! !

!StandardFileStream methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 19:15'!
readInto: aString startingAt: startIndex for: n
	"Read n bytes into the given string."
	^self primRead: fileID into: aString
				startingAt: startIndex count: n.! !

!StandardFileStream methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 19:04'!
writeFrom: aString startingAt: startIndex for: anInteger
	"Store the next anInteger elements from the given collection."
	rwmode ifFalse: [^ self error: 'Cannot write a read-only file'].
	^self primWrite: fileID from: aString startingAt: startIndex count: anInteger! !

!Symbol class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbDeserialize: deserializer

	| bytes len |
	bytes := ByteArray new: (len := deserializer stream getPositiveInteger).
	deserializer stream getBytesFor: bytes len: len.
	^bytes asString asSymbol! !

!Symbol methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbBasicSerialize: serializer

	serializer stream
		putByte: 18;
		putPositiveInteger: self size;
		putBytesFrom: self asByteArray len: self size! !

!Symbol methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbSerialize: serializer

	serializer stream
		putByte: 18;
		putPositiveInteger: self size;
		putBytesFrom: self asByteArray len: self size! !

!False methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbBasicSerialize: serializer

	serializer stream putByte: 16! !

!False methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbObjectID

	^ODBObjectID containerID: 0 index: 3! !

!False methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbSerialize: serializer

	serializer stream putByte: 16! !

!Class class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbDeserialize: deserializer

	^Smalltalk at: deserializer stream getString asSymbol ifAbsent: []! !

!Class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbSerialize: serializer

	serializer stream putByte: 26; putString: name asString! !

!Class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbTransientInstanceVariables
		"This method tells OmniBase which instance variables should not be stored into the database."

	^OrderedCollection new! !

ProtoObject subclass: #ODBReference
	instanceVariableNames: 'transactionObject demandLoader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBase'!

!ODBReference methodsFor: 'predefined intercepted messages' stamp: 'cdg 3/13/2003 17:26'!
doesNotUnderstand: aMessage

    ^demandLoader
        perform: aMessage selector
        withArguments: aMessage arguments! !

!ODBReference methodsFor: 'accessing' stamp: ''!
isIdenticalTo: anObject 
	"Answer true if anObject is identical to receiver. This is necessary since with database
	proxies the real object identity is lost because while the object is not yet loaded from the
	database it is represented by its proxy. Later when the real object is loaded this proxy still
	represents the identical object but the #== identity check will answer false because it is not
	aware of this. It is implemented in this way because the #== method is inlined and can not
	be overridden."

	anObject isODBReference ifTrue: [^self odbObjectID = anObject odbObjectID].
	(anObject isNil or: [self odbNotLoaded]) ifTrue: [^false].
	^self odbTransactionObject value == anObject! !

!ODBReference methodsFor: 'public' stamp: ''!
isImmediate
	"Private - Answer whether the receiver has an immediate representation (that is it is entirely
	encoded in an object pointer, e.g. SmallIntegers. Most objects are not immediate."

	^false! !

!ODBReference methodsFor: 'hacks' stamp: 'ac 1/7/2004 18:10'!
isMorph
	^ false
! !

!ODBReference methodsFor: 'predefined intercepted messages' stamp: 'cdg 3/13/2003 17:26'!
isNil

    ^false! !

!ODBReference methodsFor: 'accessing' stamp: ''!
isODBReference
	"Answer <true> if receiver is kind of ODReference."

	^true! !

!ODBReference methodsFor: 'accessing' stamp: 'david@inspiron 8/23/2004 23:10'!
makePersistent
	"Do nothing, object is already persistent."

	! !

!ODBReference methodsFor: 'accessing' stamp: 'david@inspiron 8/23/2004 23:09'!
markDirty
	self odbNotLoaded ifFalse: [self odbGetTransaction markDirty: self odbResolve]! !

!ODBReference methodsFor: 'predefined intercepted messages' stamp: 'cdg 3/13/2003 17:26'!
notNil

    ^true! !

!ODBReference methodsFor: 'accessing' stamp: 'david@inspiron 8/20/2004 16:43'!
odbGetOID
	transactionObject == nil ifTrue: [^demandLoader odbObjectID].
	^transactionObject objectID! !

!ODBReference methodsFor: 'accessing' stamp: 'david@inspiron 8/20/2004 16:43'!
odbGetTransaction
	"Answer transaction that owns the reference."

	transactionObject isNil ifTrue: [^demandLoader transaction].
	^transactionObject transaction! !

!ODBReference methodsFor: 'private' stamp: ''!
odbNotLoaded
		"Answer <true> if the referenced object has not been loaded yet."

	transactionObject notNil ifTrue: [^false].
	^(demandLoader transaction cachedObjectAt: demandLoader odbObjectID) isNil! !

!ODBReference methodsFor: 'accessing' stamp: ''!
odbObjectID
	transactionObject == nil ifTrue: [^demandLoader odbObjectID].
	^transactionObject objectID! !

!ODBReference methodsFor: 'public' stamp: 'dg 5/7/2003 23:06'!
odbResolve
	"See Object>>#odbResolve for comment."

	^transactionObject isNil 
		ifTrue: [demandLoader getObject]
		ifFalse: [transactionObject value]! !

!ODBReference methodsFor: 'serialization' stamp: 'cdg 3/13/2003 17:26'!
odbSerialize: serializer

	^demandLoader odbSerialize: serializer! !

!ODBReference methodsFor: 'accessing' stamp: 'cdg 3/13/2003 17:26'!
odbSetLoader: aDemandLoader

    demandLoader := aDemandLoader! !

!ODBReference methodsFor: 'accessing' stamp: ''!
odbSetTransactionObject: anODBTransactionObject 
	"Private - Set transaction object and answer its value."

	transactionObject := anODBTransactionObject.
	^demandLoader := transactionObject value! !

!ODBReference methodsFor: 'accessing' stamp: ''!
odbTransaction
	"Answer transaction that owns the reference."

	transactionObject isNil ifTrue: [^demandLoader transaction].
	^transactionObject transaction! !

!ODBReference methodsFor: 'private' stamp: ''!
odbTransactionObject

	transactionObject isNil ifTrue: [demandLoader getObject].
	^transactionObject! !

!ODBReference methodsFor: 'predefined intercepted messages' stamp: 'cdg 3/13/2003 17:26'!
== anObject
	"Answer true if the receiver and the argument are the same object (have the same
	object pointer) and false otherwise.  Do not redefine the message == in any
	other class!!  No Lookup."

	<primitive: 110>
	self primitiveFailed! !

!TimeStamp methodsFor: '*omnibase' stamp: 'david@inspiron 12/5/2003 21:20'!
asBtreeKeyOfSize: keySize 
	keySize < 8 
		ifTrue: 
			[OmniBase signalError: 'Key size has to be at least 8 bytes to accomodate a timestamp'].
	^self asSeconds asBtreeKeyOfSize: keySize! !

!Character class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbDeserialize: deserializer

	^deserializer stream getChar! !

!Character methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbBasicSerialize: serializer

	self asInteger < 256 ifTrue: [
		serializer stream putByte: 13; putChar: self.
		^self
	].
	serializer stream putByte: 29; putWord: self asInteger! !

!Character methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbSerialize: serializer

	self asInteger < 256 ifTrue: [
		serializer stream putByte: 13; putChar: self.
		^self
	].
	serializer stream putByte: 29; putWord: self asInteger! !

!OrderedCollection class methodsFor: '*omnibase' stamp: 'ac 3/14/2004 19:53'!
odbDeserialize: deserializer

	| coll size |
	size := deserializer stream getPositiveInteger.
	deserializer register: (coll := self new: size).
	size timesRepeat: [ coll addLast: deserializer odbNextObject ].
	^coll! !

!OrderedCollection methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 19:42'!
odbBasicSerialize: serializer

	serializer stream
		putByte: 81;
		putPositiveInteger: self size.
	self do: [:each | each odbSerialize: serializer ].! !

!MessageSend class methodsFor: '*omnibase' stamp: 'dg 3/14/2005 12:25'!
odbDeserialize: deserializer 
	| result |
	deserializer register: (result := self new).
	^result
		receiver: deserializer nextObject;
		selector: deserializer nextObject;
		arguments: deserializer nextObject;
		yourself! !

!MessageSend methodsFor: '*omnibase' stamp: 'dg 3/14/2005 12:22'!
odbBasicSerialize: serializer 
	self class == MessageSend ifFalse: [^super odbBasicSerialize: serializer].
	serializer stream putByte: 20.
	receiver odbSerialize: serializer.
	selector odbSerialize: serializer.
	arguments odbSerialize: serializer! !

!String class methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 21:49'!
odbDeserialize: deserializer

	| buf len |
	buf := ByteArray new: (len := deserializer stream getPositiveInteger).
	deserializer stream getBytesFor: buf len: len.
	^deserializer register: buf asString! !

!String methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
asBtreeKeyOfSize: keySize

	^self asByteArray asBtreeKeyOfSize: keySize! !

!String methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbBasicSerialize: serializer

	| buf |
	(buf := self asByteArray) size < 10
		ifTrue: [
			^serializer stream
				putByte: 70 + buf size;
				putBytesFrom: buf len: buf size ].
	serializer stream
		putByte: 34;
		putPositiveInteger: buf size;
		putBytesFrom: buf len: buf size! !

!String methodsFor: '*omnibase' stamp: 'dg 12/20/2003 09:26'!
trimBlanks
	^self withBlanksCondensed! !

!Message class methodsFor: '*omnibase' stamp: 'david@inspiron 2/11/2005 21:35'!
odbDeserialize: deserializer 
	| result |
	deserializer register: (result := self new).
	^result
		setSelector: deserializer nextObject arguments: deserializer nextObject;
		yourself! !

!Message methodsFor: '*omnibase' stamp: 'david@inspiron 2/10/2005 12:04'!
odbBasicSerialize: serializer 
	self class == Message ifFalse: [^super odbBasicSerialize: serializer].
	serializer stream putByte: 17.
	selector odbSerialize: serializer.
	args odbSerialize: serializer! !

!Integer methodsFor: '*omnibase' stamp: ''!
asBtreeKeyOfSize: keySize 
	"Answer BCD encoded byte array for indexing integers in B-tree."

	| bytes b i n |
	bytes := ByteArray new: keySize.
	n := self abs.
	i := keySize.
	[i = 1] whileFalse: 
			[b := n \\ 10.
			n := n // 10.
			b := n \\ 10 * 16 bitOr: b.
			n := n // 10.
			bytes at: i put: b.
			i := i - 1].
	b := n \\ 10.
	self < 0 ifTrue: [b := b bitOr: 32].
	bytes at: 1 put: b.
	n < 10 
		ifFalse: 
			[self error: 'B-tree dictionary key size is too short to convert receiver into byte array'].
	^bytes! !

!Integer methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbBasicSerialize: serializer

	self < 0 ifTrue: [
		self > -4 ifTrue: [ ^serializer stream putByte: self + 70 ].
		^serializer stream putByte: 12; putPositiveInteger: 0 - self.
	].
	self < 17 ifTrue: [ ^serializer stream putByte: self + 50 ].
	serializer stream putByte: 11; putPositiveInteger: self! !

!Integer methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbSerialize: serializer

	self < 0 ifTrue: [
		self > -4 ifTrue: [ ^serializer stream putByte: self + 70 ].
		^serializer stream putByte: 12; putPositiveInteger: 0 - self.
	].
	self < 17 ifTrue: [ ^serializer stream putByte: self + 50 ].
	serializer stream putByte: 11; putPositiveInteger: self! !

!SystemDictionary methodsFor: '*omnibase' stamp: 'dg 12/20/2003 10:01'!
odbBasicSerialize: serializer

	serializer stream putByte: 19! !

!SystemDictionary methodsFor: '*omnibase' stamp: 'dg 12/20/2003 10:01'!
odbSerialize: serializer

	serializer stream putByte: 19! !

!Array class methodsFor: '*omnibase' stamp: 'ac 3/14/2004 19:52'!
odbDeserialize: deserializer

	| array |
	array := self new: deserializer stream getPositiveInteger.
	deserializer register: array.
	1 to: array size do: [:i | array at: i put: deserializer odbNextObject ].
	^array! !

!Array methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:18'!
odbBasicSerialize: serializer

	serializer stream putByte: 35; putPositiveInteger: self size.
	1 to: self size do: [:i | (self at: i) odbSerialize: serializer ].! !

!Association class methodsFor: '*omnibase' stamp: 'ac 3/14/2004 19:52'!
odbDeserialize: deserializer

	| result |
	deserializer register: (result := self new).
	^result
		key: deserializer odbNextObject;
		value: deserializer odbNextObject! !

!Association methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:06'!
odbBasicSerialize: serializer

	serializer stream putByte: 31.
	key odbSerialize: serializer.
	value odbSerialize: serializer.! !

!Behavior methodsFor: '*omnibase' stamp: 'cdg 3/13/2003 18:05'!
odbGetRegDictionary

	^ODBIdentityDictionary new: 500! !
ODBDatabaseObject initialize!
OmniBase initialize!
